package org.cvo.fithas.dbsupport;

import java.io.IOException;

import org.cvo.fithas.util.DBConfHelper;
import org.cvo.fithas.util.SystemConstant;

/*
 * Common connection info should be like this:
 * 		mysql.driver=com.mysql.jdbc.Driver
		mysql.url=jdbc:mysql://localhost/BATC?useUnicode=true&characterEncoding=GBK
		mysql.user=root
		mysql.password=
	
 * */

public class DBConnectionInfo {

	private int dbType;
	private String connectionName = "new Connection"; //as id in xml file
	private String driver = ""; 
	private String server = "";
	private String port = ""; //use default
	private String userName = "";
	private String password = "";
	private String database = "";
	private String tableName = "";
	private String url = "";
	
	/**
	 * Constructor, set attributes' value using default.
	 * */
	public DBConnectionInfo(){
		super();
		
/*		dbType = SystemConstant.DB_TYPE_MYSQL;
		driver = SystemConstant.DB_DEFAULT_DRIVER_MYSQL; 
		server = SystemConstant.CONFIG_DB_DEFAULT_SERVER_MYSQL;
		port = SystemConstant.CONFIG_DB_DEFAULT_PORT_MYSQL;
		userName = SystemConstant.CONFIG_DB_DEFAULT_USERNAME_MYSQL;//use default(root)
		password = SystemConstant.CONFIG_DB_DEFAULT_PASSWORD_MYSQL;//use default
		database = SystemConstant.CONFIG_DB_DEFAULT_DATABASE; //FITHAS;
		tableName ="";
		url="jdbc:mysql://"+server+"/"+database;
		*/
}
	
	/**
	 * Construct from default MySQL setting in properties file.
	 * @throws IOException 
	 * */
	public  DBConnectionInfo(int dbType) throws IOException{
		super();
		this.dbType = dbType;
    	if(dbType==SystemConstant.DB_TYPE_MYSQL)
    	{
    		driver = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_DRIVER);
    		server = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_SERVER);
    		port = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_PORT);
    		database = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_DATABASE);
    		userName = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_USERNAME);
    		password = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_PASSWORD);
    	}
    	
    	else if(dbType==SystemConstant.DB_TYPE_ORACLE)
    	{
    		driver = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_DRIVER);
    		server = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_SERVER);
    		port = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_PORT);
    		database = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_DATABASE);
    		userName = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_USERNAME);
    		password = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_PASSWORD);
    		
    	}
    	else if(dbType==SystemConstant.DB_TYPE_SQLSERVER)
    	{
    		driver = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_DRIVER);
    		server = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_SERVER);
    		port = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_PORT);
    		database = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_DATABASE);
    		userName = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_USERNAME);
    		password = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_PASSWORD);
    	}
//		driver = SystemConstant.DB_DEFAULT_DRIVER_MYSQL; 
//		server = SystemConstant.CONFIG_DB_DEFAULT_SERVER_MYSQL;
//		port = SystemConstant.CONFIG_DB_DEFAULT_PORT_MYSQL;
//		userName = SystemConstant.CONFIG_DB_DEFAULT_USERNAME_MYSQL;//use default(root)
//		password = SystemConstant.CONFIG_DB_DEFAULT_PASSWORD_MYSQL;//use default
//		database = SystemConstant.CONFIG_DB_DEFAULT_DATABASE; //FITHAS;
//		tableName ="";
//		url="jdbc:mysql://"+server+"/"+database;

}
	
	/*
	public DBConnectionInfo(int dbType, String server) {

		super();
		//judge db type
		this.dbType = dbType;
		initDBType(dbType);
		
		this.server = server==null? "" : server;
		this.userName = SystemConstant.CONFIG_DB_DEFAULT_USERNAME_MYSQL; //use default(root)
		this.password = SystemConstant.CONFIG_DB_DEFAULT_PASSWORD_MYSQL ;//use default
		this.database = SystemConstant.CONFIG_DB_DEFAULT_DATABASE; //FITHAS;
		this.tableName ="";
		this.url="jdbc:mysql://"+server+"/"+database;
	}
*/

	public DBConnectionInfo(int dbType, String server, String userName, String password) throws IOException {
		super();
		//judge db type
		this.dbType = dbType;
		initDBType(dbType);
		
		this.server = server==null? "" : server;
		this.userName = userName==null? "" : userName;
		this.password = password==null? "" : password;
	}

	/**
	 * Will not be used.
	 * */
	public DBConnectionInfo(String driver, String server, String port, String userName, String password, String database) {
		super();
		// TODO Auto-generated constructor stub
		this.driver = driver;
		this.server = server;
		this.port = port;
		this.userName = userName;
		this.password = password;
		this.database = database;
	}
	
	/**
	 * Init the driver,port, according to the db type
	 * @throws IOException 
	 * */
	private void initDBType(int dbType) throws IOException {
		
		if(dbType == SystemConstant.DB_TYPE_MYSQL)
		{
			this.driver = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_DRIVER);//get default from config file
			this.port = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_PORT);//get default from config file
			this.database = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_MYSQL_DATABASE); //get default from config file
		}
		else if(dbType == SystemConstant.DB_TYPE_ORACLE)
		{
			this.driver = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_DRIVER);//get default from config file
			this.port = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_PORT);//get default from config file
			this.database = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_ORACLE_DATABASE); 
			
		}
		else if(dbType == SystemConstant.DB_TYPE_SQLSERVER)
		{
			this.driver = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_DRIVER);//get default from config file
			this.port = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_PORT);//get default from config file
			this.database = DBConfHelper.getAttribute(SystemConstant.CONFIG_DB_PROPKEY_SQL_DATABASE); 
		}
		
	}
	
	public void print()
	{
		System.out.println("============== print pojo--[DBConnectionInfo] start ==============");
		System.out.println("<dbType>"+dbType+"</dbType>");
		System.out.println("<driver>"+driver+"</driver>");
		System.out.println("<server>"+server+"</server>");
		System.out.println("<port>"+port+"</port>");
		System.out.println("<database>"+database+"</database>");
		System.out.println("<userName>"+userName+"</userName>");
		System.out.println("<password>"+"******"+"</password>");
		System.out.println("<tableName>"+tableName+"</tableName>");
		System.out.println("============== print pojo--[DBConnectionInfo] end ==============");
	}
	
	/**
	 * @return Returns the connectionName.
	 */
	public String getConnectionName() {
		return connectionName;
	}


	/**
	 * @param connectionName The connectionName to set.
	 */
	public void setConnectionName(String connectionName) {
		this.connectionName = connectionName;
	}


	/**
	 * @return Returns the dbType.
	 */
	public int getDbType() {
		return dbType;
	}


	/**
	 * @param dbType The dbType to set.
	 */
	public void setDbType(int dbType) {
		this.dbType = dbType;
	}

	//getter and setters
	/**
	 * @return Returns the driver.
	 */
	public String getDriver() {
		return driver;
	}
	/**
	 * @param driver The driver to set.
	 */
	public void setDriver(String driver) {
		this.driver = driver;
	}
	public String getDatabase() {
		return database;
	}

	public void setDatabase(String database) {
		this.database = database;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getPort() {
		return port;
	}

	public void setPort(String port) {
		this.port = port;
	}

	public String getServer() {
		return server;
	}

	public void setServer(String server) {
		this.server = server;
	}

	public String getTableName() {
		return tableName;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public String getUrl() {
		String prefix = "";
		if(this.dbType==SystemConstant.DB_TYPE_MYSQL)
		{
			prefix = "jdbc:mysql:";
			//oracle
			//sql server

			//url with encoding
			if(server==null || server.equals(""))
				server = SystemConstant.DB_CONN_DEFAULT_SERVER_MYSQL;
			prefix=prefix+"//"+server+"/"+database+SystemConstant.DB_CONN_ENCODING_UTF8;
		}
		if(this.dbType==SystemConstant.DB_TYPE_SQLSERVER)
		{
			prefix="jdbc:microsoft:sqlserver://"+server+":"+port+";DatabaseName="+database;
			
		}
		if(this.dbType==SystemConstant.DB_TYPE_ORACLE)
		{
			prefix="jdbc:oracle:thin:@"+server+":"+port+":"+database;
			
		}
		return prefix;
	}

	
	public static void main(String[] args)
	{
		//DBConnectionInfo info = new DBConnectionInfo(1);
		DBConnectionInfo info;
		try {
			info = new DBConnectionInfo(0,"localhost",null,null);
			info.print();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}