package org.cvo.fithas.fitsfile;

/** 
 * Copyright @ 2004 Tianjin University IBM center. 
 * All right reserved. 
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.List;

import org.cvo.fithas.dbsupport.TableColumnBean;
import org.cvo.fithas.exception.IllegalFileException;
import org.cvo.fithas.util.GzipHelper;
import org.cvo.fithas.util.SystemConstant;
import org.cvo.fithas.util.Utils;

/**
 * The class is for analying the head of the fits files. Methord: getHead(): to
 * analyze the file head. parameter: File f that is to be analyze return : a
 * hash table including the keys and values.
 */

public class GenericHeadAnalysis {
	
	public static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(GenericHeadAnalysis.class.getName () ) ;
	
	/** 
	 * ĿǰҪڵļĽ鿴⡣
	 * ڵļ˵ûѡĸļͲĸҪpatternжϣҲҪ"Ƿbasedir"ж
	 * ڽļheader(Ϸ)keyvalueʾUItable view
	 * @param fileName
	 * 			--file to analyse, filename with full path
	 * @return List 
	 * 			--List of the key-value pairs(each may be Map.Entry)
	 * @throws IllegalFileException 
	 * @throws IOException
	 * */
	public static List getHeadValuesList(String fileName) throws IOException, IllegalFileException 
	{
        //ArrayList columns = new ArrayList();        
        logger.debug("--[GenericHeadAnalysis][getHeadValuesList]--analysing file:"+fileName);
//        Hashtable htable = GenericHeadAnalysis.getFitsHead(fileName);//.analyseFitsHead(f);
//        if(htable!=null && htable.size()>0)
//        {
//        	logger.debug("--[GenericHeadAnalysis][getHeadValuesList]--got the Hashtable, size="+htable.size());
//        	columns.addAll(htable.entrySet());//Hashtable -> List, entryб
//        }
      
        ArrayList htable=GenericHeadAnalysis.getFitsHead(fileName);
        return htable;
	}

   
    
    /** 20070426ļƥˡ
     * еһЩá
     * 
     * (1)Ӧļ
     * (2)Ӧ*.fit, *.fits, *.fit.gz, *.fits.gz
     * (3)ﲻbasedirpatternжϣʵø÷ǰӦļù˴
     * @return Hashtable
     * 			صHashtableΪnullFileļչԣһֱ쳣ˣղnullֵ
     * */
    public static ArrayList getFitsHead(String fileName) throws IllegalFileException, IOException
    {
    	 //Hashtable htable = null;  
    	ArrayList  htable = null;  
    	 File f = new File(fileName);//ȼָļ/Ŀ¼
         if(f.isFile()) //file
         {
        	 if(fileName.endsWith(".fit") || fileName.endsWith(".fits"))
	         {
	             FileReader fr = null;
	             BufferedReader br = null;	        	        
	             try{
	              	fr = new FileReader(f);
	               	br = new BufferedReader(fr);
	               	htable = analyseFitsHeader(br); //core arithmetic
	             }//try 	        	       
	             finally
	             {
	                 br.close();
	                 fr.close();        	            
	             }
	         }
	         //for gzip file, ungzip to InputStream
        	 else if(fileName.endsWith(".fit.gz") || fileName.endsWith(".fits.gz"))
	         {
	          	 InputStream is = null;
	           	 InputStreamReader isr = null;
	 	         BufferedReader br = null;
	 	         try{
	 	          	 is = GzipHelper.readGzFile(fileName); 	             
	 	           	 isr = new InputStreamReader(is); 	             
	 	           	 br = new BufferedReader(isr);
	 	           	 htable = analyseFitsHeader(br);	//core arithmetic                     	
		 	     }
	 	         finally
	 	         {
	 	           	 br.close();
	 	           	 isr.close();
	 	           	 is.close();
	 	         }
	         }
	         else //other filename extension
	         {
	            throw new IllegalFileException();
	         }             
         } //if(is file)
         else //directory or other formatһø÷֮ǰӦļ/Ŀ¼⣬жֻΪ׳
         {
            throw new IllegalFileException();
         }
    
	    return htable;
    	
    }
    
    
    public static Hashtable getFitsHeadHT(String fileName) throws IllegalFileException, IOException
    {
    	 Hashtable htable = null;  
    	 File f = new File(fileName);//ȼָļ/Ŀ¼
         if(f.isFile()) //file
         {
        	 if(fileName.endsWith(".fit") || fileName.endsWith(".fits"))
	         {
	             FileReader fr = null;
	             BufferedReader br = null;	        	        
	             try{
	              	fr = new FileReader(f);
	               	br = new BufferedReader(fr);
	               	htable = analyseFitsHeaderHT(br); //core arithmetic
	             }//try 	        	       
	             finally
	             {
	                 br.close();
	                 fr.close();        	            
	             }
	         }
	         //for gzip file, ungzip to InputStream
        	 else if(fileName.endsWith(".fit.gz") || fileName.endsWith(".fits.gz"))
	         {
	          	 InputStream is = null;
	           	 InputStreamReader isr = null;
	 	         BufferedReader br = null;
	 	         try{
	 	          	 is = GzipHelper.readGzFile(fileName); 	             
	 	           	 isr = new InputStreamReader(is); 	             
	 	           	 br = new BufferedReader(isr);
	 	           	 htable = analyseFitsHeaderHT(br);	//core arithmetic                     	
		 	     }
	 	         finally
	 	         {
	 	           	 br.close();
	 	           	 isr.close();
	 	           	 is.close();
	 	         }
	         }
	         else //other filename extension
	         {
	            throw new IllegalFileException();
	         }             
         } //if(is file)
         else //directory or other formatһø÷֮ǰӦļ/Ŀ¼⣬жֻΪ׳
         {
            throw new IllegalFileException();
         }
    
	    return htable;
    	
    }

 
    
    public static Hashtable analyseFitsHeaderHT(BufferedReader br) throws IOException
    {
        Hashtable htable 	= new Hashtable(); //header part
        String FirstName 	= null;
        String FirstValue 	= null;
        String line 		= null;					
        int BeginIndex 		= 0;					//Ϊ׼FITļͷĴƫ
        
        boolean isStandard 	= true; //headerǰ沿ǷԹЧַfits涨"SIMPLE  = T"ЧϢ
        boolean isEnd = false; //ǷﵽheaderĽ־
        int i = 0;							//ѭ
            
        /* 벿ļݣﵽ޶δЧϢжΪǱ׼ļټ */
        int count = 0; //
        do{
        	line = br.readLine();//һֱس
            	
            //TODO Сlinenullstreamβˣ
            //Header UnitвӦnon-printable chars(磺سСtab)ЩؼӦüһline
            /*һֱԶֱֱļؼ(֮һ)Ȼ10δ־ͷ*/
            if(line!=null /*line.indexOf("END")>0 */ 
            		&& (line.indexOf("SIMPLE  = ")>=0 || line.indexOf("BITPIX  = ")>=0 || line.indexOf("NAXIS   = ")>=0 || line.indexOf("NAXIS1  = ")>=0 || line.indexOf("NAXIS2  = ")>=0 )) 
            {
            	isStandard = true;
            }
            else
            { //ļͷϢheaderĹؼ--Ann
            	isStandard = false;
            }                	                	
            count ++;
        }while(!isStandard && count <10);//ļͷЩϢԿʮس֮ڴﵽʽheader
           	
            
        /* Ըʽ׼(˵ġ׼ֻ˵headerǰһֳ˹ؼ)ļн */
        if(isStandard)
        {
        	/* ִlineĽǷ"END"ˣδ֣Ӧѭһlineֱ"END"ֻļβ(㲻ϸļʽ)*/
            do{
	            /* lineĿʼֿЧϢֻӵһȺŵǰ8ַʼAnn*/
	            //TODO ᲻ֵһȺǰַ8Ҳ˵һȺǰheaderЧĹؼ֣ûAnn
	            BeginIndex = line.indexOf("=") -8;	//׼ʽȻ"="ڵ8ַ֮
	            if(BeginIndex<0)
	            {
	            	isEnd = true;
            		break;
	            }
	            line = line.substring(BeginIndex); //ȥǰЧϢ
	            int lineLen = line.length();
	            int maxLenOfCurRow = 80; //ÿ80ַfits׼ҪֱENDҲӦֻسеȣĩҲÿո80ַ
	            /*
	             * 8ΪʼȺŽֹռ8ĸλã
	                TIMEǵһֵ"...  TIME    =....",
	           	   ôBeginIndexָT֮ǰǸλ
	           	 */
	            logger.debug("The line: BeginIndex="+BeginIndex+", line's length="+lineLen);
	            
	            /* ζline(ܳһμУҲܲһУس)нн */
	            for(i=0; i*80<lineLen; i++)
	            {
	            	/* ǰпµĲֲ80ַȡµĳȣȡַʱ */
	            	if(lineLen-i*80<80)
	            	{
	            		maxLenOfCurRow = lineLen-i*80;
	            	}
	            	else 
	            	{
	            		maxLenOfCurRow = 80;
	            	}
	            	
	            	//do {
	                	//жϵǰһǷΪհ
	                	if(line.substring(80*i, 80*i+maxLenOfCurRow).trim().equals(""))
	                	{
	                		logger.debug("Line:"+i+" is blank, skip.");
	                		continue; //ѭ䣬´ѭ
	                	}
	                	
	                	//TODO жǷ"KEY     = VALUE"ĸʽл쳣
	                	
	                	//ڷǿհУִ²жϣ	                
	                	FirstName  = line.substring(80*i, 80*i+8).trim();
	                	//logger.debug("Line:"+i+": The FirstName="+FirstName+".");
	                	
	                	//ǽ־END˳forѭ
	                	if(FirstName.equalsIgnoreCase("END"))
	                	{
	                		logger.debug("Line:"+i+" comes to the END. STOP.");
	                		isEnd = true;
	                		break; //˳forѭflagisEnd=true
	                	}
	                	
	                	/* "COMMENT""HISTORY"ؼֻ߿հףܲʹ"="ǿոvalue
	                	 * ʱ0-6λǹؼ֣7λǿո񣬺value8λͿʼ
	                	 * Կհ8еģҲעͣȡֵҲһմ
	                	 */	                	
	                	if(FirstName.equalsIgnoreCase("COMMENT") || FirstName.equalsIgnoreCase("HISTORY")
	                			|| FirstName.equals(""))
	                	{
	                		/* ؼֺ"="fitsʽ"COMMENT = value "valueindexΪ10ĵطʼ*/
	                		if(line.substring(80*i+7, 80*i+10).equals(" = "))//ȺǰһոҪǵȺźոϣֵÿոָkeyvalue
	                		{
	                			logger.debug("Line:"+i+": '=' is after the FirstName "+FirstName+"(line.substring(80*i+7,80*i+10)="+line.substring(80*i+7,80*i+10)+")");
	                			FirstValue = line.substring(80*i+10, 80*i+80).trim(); 
		                		
	                			//עУvalueֵֿܳĵţԵſͷģд
		                		/* valueֿܿͷַǵţһvalueԵַͣ
		                		 * HISTORY   ESO-DESCRIPTORS START   ................                              
		                		 * HISTORY   'LHCUTS'         ,'R*4 '   ,    1,    4,'5E14.7',' ',' '              
		                		 * HISTORY    0.0000000E+00 9.1000000E+01 0.0000000E+00 9.1000000E+01 
		                		 * */
		                		/* ʶĿǰļfitsƼʽ"COMMENT = 'HERE IS COMMENT.'"
		                		 * 8λõȺŵдžͽһԵ֮Ĳ֣ؼһ
		                		 * ʽÿոָ3ոǽһԵ⴦*/
		                		if(FirstValue.startsWith("'"))
		                		{
		                			//TODO ǷҪַ͵valueж"'"ת("''")
		                			int index1 = FirstValue.indexOf("'",1);//ӵһ֮ҵһγֵĵ
		                			//ȻؼֶȥvalueβĿհףעҪԭʽ洢ʹ.trim()
		                			FirstValue = FirstValue.substring(1,index1); //֮Ĳ֣ ȥβհ		                			
		                		}
	                		}
	                		else //ʹÿոkeyvalue"COMMENT value "valueܴindexΪ8ĵطʼ
	                		{
	                			logger.debug("Line:"+i+": blank(' ') is after the FirstName "+FirstName+"(line.substring(80*i+7,80*i+10)="+line.substring(80*i+7,80*i+10)+")");
	                			FirstValue = line.substring(80*i+8, 80*i+maxLenOfCurRow);//עؼ0-6λģ7λǿո񡣲ʹ.trim()
	                		}
	                		
	                		/*עͣÿոָkeyvalueʱvalueֵпֵܳţⲻӰUIʾ
	                		 * ڽmysqlݿʱҪvalueеĵת弴"''"Աܿmysqlıַ"'"
	                		 * תִУͳһŵDbControl(ݿsql﷨пܲ"'"ַַתĹݿй)
	                		 * */
//	                		logger.debug("fits Line:"+i+": COMMENT TYPE, key-value pair is: "+FirstName+"="+FirstValue);
	                	}
	                	else //ؼ
	                	{
	                		//TODO СĴеmaxLenOfCurRow<10Ȼ"END"洦˴˴
	                		FirstValue = line.substring(80*i+10, 80*i+maxLenOfCurRow).trim(); //еȺźͿո֮Ĳ
	                		
	                		/* valueԵſʼַͣʵʵvalueֵӦΪһź͵ڶ֮ */
	                		if(FirstValue.startsWith("'"))
	                		{
	                			//TODO ǷҪַ͵valueж"'"ת("\'")
	                			int index1 = FirstValue.indexOf("'",1);//ӵһ֮ҵһγֵĵ
	                			if(index1<0)
	                				FirstValue = FirstValue.substring(1).trim();
	                			else
	                				
	                				FirstValue = FirstValue.substring(1,index1).trim(); //֮Ĳ
//	                			logger.debug("fits Line:"+i+": String, key-value pair is: "+FirstName+"="+FirstValue);
	                		}
	                		else //ַͣvalueȡһ"/"֮ǰ
	                		{
	                			/* valueֺ"/"ȡǸַȥǰհף򲻱 */
	                			if(FirstValue.indexOf("/") > 0)
	                			{
	                  			  FirstValue = FirstValue.split("/")[0].trim(); //ַ(TFֵǰпո)
	                			}
//	                			logger.debug("fits Line:"+i+":non-String, key-value pair is: "+FirstName+"="+FirstValue);
	                		}
	                	}
	                		  
	                	//ַ滻Ҫ滻keyе"-" -> "_"
//	                	FirstName = replaceWords(FirstName, reservedWords);
	                	FirstName = replaceWords(FirstName);
	                	
		              /* keyvalueHashtable*/
	                  //COMMENTHISTORYֺüΣεݴһ(ԭʽ)Ϊvalue洢
	                	//հ׿ͷעʹùؼ֡MISC洢
	                  if(FirstName.equalsIgnoreCase("COMMENT") || FirstName.equalsIgnoreCase("HISTORY")
	                		  || FirstName.equals(""))
	                  {
	                	  //ǰֶֹΣ򽫸ӳһµĳַ
	                	  if(htable.containsKey(FirstName))
	                	  {
	                		  FirstValue = htable.get(FirstName)+"\n "+FirstValue;//ϻسԼո
//	                		  logger.debug("blank comment##"+htable.get(FirstName)+"## is now add up to\n ##"+FirstValue+"##");
	                	  }             		  
	                  }                
	                  //Hashtable
	                  htable.put(FirstName,FirstValue);
                  
	            	}//forlineڵн
	            	
	                  //7ոʼע͸ĸ֣Ϊ"MISC"ؼֵkeyvalue
	                  if(htable.containsKey(""))
                	  {
	                	  logger.debug("htable.get(\"\")="+htable.get(""));
		                  htable.put("MISC",htable.get(""));
		                  htable.remove("");//ȥԭհ׿ʼע͵ļ¼	   
		                  logger.debug("htable.get(\"MISC\")="+htable.get("MISC"));
                	  }  
	                  
	            	/* lineˣδ"END"־ҪٶһlineΪ´ν׼
	            	 * ѳֽ־(ڷ֡ENDʱbreakforѭ)˷ҲǷnullԽӰ */
	            	line = br.readLine();//һֱس
	            	
	            } while (!isEnd);//lineû"END"־ʱһline
            	                
            }//if,ļisStandard
    
        return htable;
    }
    
    /**
     * Ϊfitsĺ㷨20070423Ϊһ㷨
     * ᷵null
     * */
    public static ArrayList analyseFitsHeader(BufferedReader br) throws IOException
    {
        //Hashtable htable 	= new Hashtable(); //header part
    	ArrayList htable=new ArrayList();
    	ArrayList newhtable=new ArrayList();
        String FirstName 	= null;
        String FirstValue 	= null;
        String FirstComment ="";
     
        String line 		= null;					
        int BeginIndex 		= 0;					//Ϊ׼FITļͷĴƫ
        
        boolean isStandard 	= true; //headerǰ沿ǷԹЧַfits涨"SIMPLE  = T"ЧϢ
        boolean isEnd = false; //ǷﵽheaderĽ־
        int i = 0;							//ѭ
            
        /* 벿ļݣﵽ޶δЧϢжΪǱ׼ļټ */
        int count = 0; //
        do{
        	line = br.readLine();//һֱس
            	
            //TODO Сlinenullstreamβˣ
            //Header UnitвӦnon-printable chars(磺سСtab)ЩؼӦüһline
            /*һֱԶֱֱļؼ(֮һ)Ȼ10δ־ͷ*/
            if(line!=null /*line.indexOf("END")>0 */ 
            		&& (line.indexOf("SIMPLE  = ")>=0 || line.indexOf("BITPIX  = ")>=0 || line.indexOf("NAXIS   = ")>=0 || line.indexOf("NAXIS1  = ")>=0 || line.indexOf("NAXIS2  = ")>=0 )) 
            {
            	isStandard = true;
            }
            else
            { //ļͷϢheaderĹؼ--Ann
            	isStandard = false;
            }                	                	
            count ++;
        }while(!isStandard && count <10);//ļͷЩϢԿʮس֮ڴﵽʽheader
           	
            
        /* Ըʽ׼(˵ġ׼ֻ˵headerǰһֳ˹ؼ)ļн */
        if(isStandard)
        {
        	/* ִlineĽǷ"END"ˣδ֣Ӧѭһlineֱ"END"ֻļβ(㲻ϸļʽ)*/
            do{
	            /* lineĿʼֿЧϢֻӵһȺŵǰ8ַʼAnn*/
	            //TODO ᲻ֵһȺǰַ8Ҳ˵һȺǰheaderЧĹؼ֣ûAnn
	            BeginIndex = line.indexOf("=") -8;	//׼ʽȻ"="ڵ8ַ֮
	            if(BeginIndex<0)
	            {
	            	isEnd = true;
            		break;
	            }
	            line = line.substring(BeginIndex); //ȥǰЧϢ
	            int lineLen = line.length();
	            int maxLenOfCurRow = 80; //ÿ80ַfits׼ҪֱENDҲӦֻسеȣĩҲÿո80ַ
	            /*
	             * 8ΪʼȺŽֹռ8ĸλã
	                TIMEǵһֵ"...  TIME    =....",
	           	   ôBeginIndexָT֮ǰǸλ
	           	 */
	            logger.debug("The line: BeginIndex="+BeginIndex+", line's length="+lineLen);
	            
	            /* ζline(ܳһμУҲܲһУس)нн */
	            for(i=0; i*80<lineLen; i++)
	            {
	            	/* ǰпµĲֲ80ַȡµĳȣȡַʱ */
	            	if(lineLen-i*80<80)
	            	{
	            		maxLenOfCurRow = lineLen-i*80;
	            	}
	            	else 
	            	{
	            		maxLenOfCurRow = 80;
	            	}
	            	
	            	//do {
	                	//жϵǰһǷΪհ
	                	if(line.substring(80*i, 80*i+maxLenOfCurRow).trim().equals(""))
	                	{
	                		logger.debug("Line:"+i+" is blank, skip.");
	                		continue; //ѭ䣬´ѭ
	                	}
	                	
	                	//TODO жǷ"KEY     = VALUE"ĸʽл쳣
	                	
	                	//ڷǿհУִ²жϣ	                
	                	FirstName  = line.substring(80*i, 80*i+8).trim();
	                	//logger.debug("Line:"+i+": The FirstName="+FirstName+".");
	                	
	                	//ǽ־END˳forѭ
	                	if(FirstName.equalsIgnoreCase("END"))
	                	{
	                		logger.debug("Line:"+i+" comes to the END. STOP.");
	                		isEnd = true;
	                		break; //˳forѭflagisEnd=true
	                	}
	                	
	                	
	                	
	                	/* "COMMENT""HISTORY"ؼֻ߿հףܲʹ"="ǿոvalue
	                	 * ʱ0-6λǹؼ֣7λǿո񣬺value8λͿʼ
	                	 * Կհ8еģҲעͣȡֵҲһմ
	                	 */	                	
	                	if(FirstName.equalsIgnoreCase("COMMENT") || FirstName.equalsIgnoreCase("HISTORY")
	                			|| FirstName.equals(""))
	                	{
	                		/* ؼֺ"="fitsʽ"COMMENT = value "valueindexΪ10ĵطʼ*/
	                		if(line.substring(80*i+7, 80*i+10).equals(" = "))//ȺǰһոҪǵȺźոϣֵÿոָkeyvalue
	                		{
	                			logger.debug("Line:"+i+": '=' is after the FirstName "+FirstName+"(line.substring(80*i+7,80*i+10)="+line.substring(80*i+7,80*i+10)+")");
	                			FirstValue = line.substring(80*i+10, 80*i+80).trim(); 
	                			
	                			FirstComment="";
	    	                	int commenindex=FirstValue.indexOf("/");
	    	                	if(commenindex>0)
	    	                	{
	    	                		FirstComment=FirstValue.substring(commenindex+1,FirstValue.length()).trim();
	    	                		FirstComment=ReplaceComma(FirstComment);
	    	                	}
		                		
	                			//עУvalueֵֿܳĵţԵſͷģд
		                		/* valueֿܿͷַǵţһvalueԵַͣ
		                		 * HISTORY   ESO-DESCRIPTORS START   ................                              
		                		 * HISTORY   'LHCUTS'         ,'R*4 '   ,    1,    4,'5E14.7',' ',' '              
		                		 * HISTORY    0.0000000E+00 9.1000000E+01 0.0000000E+00 9.1000000E+01 
		                		 * */
		                		/* ʶĿǰļfitsƼʽ"COMMENT = 'HERE IS COMMENT.'"
		                		 * 8λõȺŵдžͽһԵ֮Ĳ֣ؼһ
		                		 * ʽÿոָ3ոǽһԵ⴦*/
		                		if(FirstValue.startsWith("'"))
		                		{
		                			//TODO ǷҪַ͵valueж"'"ת("''")
		                			int index1 = FirstValue.indexOf("'",1);//ӵһ֮ҵһγֵĵ
		                			//ȻؼֶȥvalueβĿհףעҪԭʽ洢ʹ.trim()
		                			FirstValue = FirstValue.substring(1,index1); //֮Ĳ֣ ȥβհ		                			
		                		}
	                		}
	                		else //ʹÿոkeyvalue"COMMENT value "valueܴindexΪ8ĵطʼ
	                		{
	                			logger.debug("Line:"+i+": blank(' ') is after the FirstName "+FirstName+"(line.substring(80*i+7,80*i+10)="+line.substring(80*i+7,80*i+10)+")");
	                			FirstValue = line.substring(80*i+8, 80*i+maxLenOfCurRow);//עؼ0-6λģ7λǿո񡣲ʹ.trim()
	                		}
	                		
	                		/*עͣÿոָkeyvalueʱvalueֵпֵܳţⲻӰUIʾ
	                		 * ڽmysqlݿʱҪvalueеĵת弴"''"Աܿmysqlıַ"'"
	                		 * תִУͳһŵDbControl(ݿsql﷨пܲ"'"ַַתĹݿй)
	                		 * */
//	                		logger.debug("fits Line:"+i+": COMMENT TYPE, key-value pair is: "+FirstName+"="+FirstValue);
	                	}
	                	else //ؼ
	                	{
	                		//TODO СĴеmaxLenOfCurRow<10Ȼ"END"洦˴˴
	                		FirstValue = line.substring(80*i+10, 80*i+maxLenOfCurRow).trim(); //еȺźͿո֮Ĳ
	                		
	                		
	                		FirstComment="";
    	                	int commenindex=FirstValue.indexOf("/");
    	                	if(commenindex>0)
    	                	{
    	                		FirstComment=FirstValue.substring(commenindex+1,FirstValue.length()).trim();
    	                		FirstComment=ReplaceComma(FirstComment);
    	                	}
    	                	
	                		/* valueԵſʼַͣʵʵvalueֵӦΪһź͵ڶ֮ */
	                		if(FirstValue.startsWith("'"))
	                		{
	                			//TODO ǷҪַ͵valueж"'"ת("\'")
	                			int index1 = FirstValue.indexOf("'",1);//ӵһ֮ҵһγֵĵ
	                			if(index1==-1)
	                				FirstValue = FirstValue.substring(1).trim();
	                			//TODO fitsͷнĸʽvalueַͣʹ֮βոҲԺԵ
	                			else
	                				FirstValue = FirstValue.substring(1,index1).trim(); //֮Ĳ
//	                			logger.debug("fits Line:"+i+": String, key-value pair is: "+FirstName+"="+FirstValue);
	                		}
	                		else //ַͣvalueȡһ"/"֮ǰ
	                		{
	                			/* valueֺ"/"ȡǸַȥǰհף򲻱 */
	                			if(FirstValue.indexOf("/") > 0)
	                			{
	                  			  FirstValue = FirstValue.split("/")[0].trim(); //ַ(TFֵǰпո)
	                			}
//	                			logger.debug("fits Line:"+i+":non-String, key-value pair is: "+FirstName+"="+FirstValue);
	                		}
	                	}
	                		  
	                	//ַ滻Ҫ滻keyе"-" -> "_"
//	                	FirstName = replaceWords(FirstName, reservedWords);
	                	FirstName = replaceWords(FirstName);
	                	
		              /* keyvalueHashtable*/
	                  //COMMENTHISTORYֺüΣεݴһ(ԭʽ)Ϊvalue洢
	                	//հ׿ͷעʹùؼ֡MISC洢
//	                  if(FirstName.equalsIgnoreCase("COMMENT") || FirstName.equalsIgnoreCase("HISTORY")
//	                		  || FirstName.equals(""))
//	                  {
//	                	  //ǰֶֹΣ򽫸ӳһµĳַ
//	                	  if(htable.containsKey(FirstName))
//	                	  {
//	                		  FirstValue = htable.get(FirstName)+"\n "+FirstValue;//ϻسԼո
////	                		  logger.debug("blank comment##"+htable.get(FirstName)+"## is now add up to\n ##"+FirstValue+"##");
//	                	  }             		  
//	                  }           
	                	
	                //yujianjun modified at 20071009
	                //save the values in a arraylist.
	                 HeaderEntryBean headerbean=new HeaderEntryBean(FirstName,FirstValue,FirstComment);
	                 htable.add(headerbean);
	                  //Hashtable
	                  //htable.put(FirstName,FirstValue);
                  
	            	}//forlineڵн
	            	
	                 
	                  
	            	/* lineˣδ"END"־ҪٶһlineΪ´ν׼
	            	 * ѳֽ־(ڷ֡ENDʱbreakforѭ)˷ҲǷnullԽӰ */
	            	line = br.readLine();//һֱس
	            	
	            } while (!isEnd);//lineû"END"־ʱһline
            
            
            //7ոʼע͸ĸ֣Ϊ"MISC"ؼֵkeyvalue
            
            if(htable!=null&&htable.size()>0)
            {
            	for(int j=0;j<htable.size();j++)
            	{
            		HeaderEntryBean temp=(HeaderEntryBean)htable.get(j);
            		if(temp.getKey().equals(""))
            		{
            			temp.setKey("MISC");
            		}
            		newhtable.add(temp);
            	}
            }
            
//            if(htable.containsKey(""))
//      	  {
//          	  logger.debug("htable.get(\"\")="+htable.get(""));
//                htable.put("MISC",htable.get(""));
//                htable.remove("");//ȥԭհ׿ʼע͵ļ¼	   
//                logger.debug("htable.get(\"MISC\")="+htable.get("MISC"));
//      	  }  
            	                
            }//if,ļisStandard
    
        return newhtable;
    }
   public static String ReplaceComma(String comment)
   {
	 String newcomment=comment.replace("'", " ");
	 return newcomment;
   }
    /**
     * Convert the array of reserved words to Hashtable.
     * */
/*	private static Hashtable initReservedWords() {
		Hashtable reservedWords = new Hashtable();
		for(int i=0; i<SystemConstant.DB_RESERVED_MYSQL.length; i++)
		{
			reservedWords.put(SystemConstant.DB_RESERVED_MYSQL[i], SystemConstant.DB_RESERVED_MYSQL[i]);
		}
		return reservedWords;
	}
	
	*/
    

	/**
	 * If the word is in the reserved_word_list or contains illegel chars, then replace it as some rules.
	 * @param word --
	 * 			String : the word to be deal.
	 * @param reservedWords --
	 * 			Hashtable : contains all reserved words.
	 * @return String
	 * 			the replace result.
	 * <p>Rule: 
	 * 1. char: '-' --> '_'
	 * 2. reserved word: add '_' at the beginning.</p>
	 * 
	 *   */
/*		public static String replaceWords(String word, Hashtable reservedWords)
		{
			String result;
			if(word==null)
				word = ""; //to avoid NullPointerException
			
			//滻мΪ»
			result = word.replace('-','_');
			
			//TODO ֹţ
			
			//if the word is reserved, replace it
			if(reservedWords.containsKey(word))
			{
				result = "_" + word;
			}			
			return result;	
		}
*/		
				
		/**
		 * If the word is in the reserved_word_list or contains illegel chars, then replace it as some rules.
		 * @param word --
		 * 			String : the word to be deal.
		 * @return String
		 * 			the result.
		 * <p>Rule: 
		 * char: '-' --> '_'</p>
		 *   */
			public static String replaceWords(String word)
			{
				String result;
				if(word==null)
					word = ""; //to avoid NullPointerException
				
				//20070430ע͵滻
				//滻мΪ»
//				result = word.replace('-','_');
				result = word;
				
				//TODO ֹţ
	
				return result;	
			}

			
    /** 
     * Batch archiveУ
     * Analyse files' head, get Hashtable of available columns to create in db.
     * @param fileName String[] 
     * 				array of the sample files' name (with full path)
     * @return Hashtable 
     * 				Hashtable of available columns, 
     * 				each entry is a key-value pair: "String"(columnName)-"TableColumnBean"(columnName,type,length)
     * @throws IOException 
     * @throws IllegalFileException 
     *  */
	public static ArrayList getHeadColumnsHt(String[] fileName, String filter) throws IllegalFileException, IOException {
		ArrayList columnsHt = new ArrayList();
    	for(int i=0; i<fileName.length; i++)
    	{
    		columnsHt.addAll((getHeadColumnsHt(fileName[i], filter)));
    	}
    	return columnsHt;
	}
	
	public static ArrayList getHeadColumnsTable(String[] fileName, String filter) throws IllegalFileException, IOException {
		Hashtable columnsHt = new Hashtable();
		ArrayList columns=new ArrayList();
		HashSet set=new HashSet();
    	for(int i=0; i<fileName.length; i++)
    	{
    		//columnsHt.putAll(getHeadColumnsTable(fileName[i], filter,set));
    		columns.addAll(getHeadColumnsTable(fileName[i], filter,set));
    	}
    	return columns;
	}
	public static ArrayList getHeadColumnsTable(String[] fileName, String filter,String filterfilename,String contains) throws IllegalFileException, IOException {
		Hashtable columnsHt = new Hashtable();
		ArrayList columns=new ArrayList();
		HashSet set=new HashSet();
    	for(int i=0; i<fileName.length; i++)
    	{
    		//columnsHt.putAll(getHeadColumnsTable(fileName[i], filter,set));
    		columns.addAll(getHeadColumnsTable(fileName[i], filter,set,filterfilename,contains));
    	}
    	return columns;
	}
    
    /**
     * 20070426ļpatternˡ
     * ڵļļarchivingлõڽǰȡֶνṹϢ
     * patternĹˣbasedirжϣΪbasedir뽨޹ء
     * @see DbControl.recursiveFileImport(DBConnectionInfo, File, String, int, Hashtable, Hashtable) 
     * 
     * fits headerеĹؼϢʱõrecord_Idpath
     * Analyse file head and get available keys (will be set as columns in db).
     * @param fileName String 
     * 				sample files' name (with full path)
     * @return Hashtable 
     * 				Hashtable of available columns, each is a "TableColumnBean"(columnName,type,length)
     * @throws IOException 
     * @throws IllegalFileException 
     *  */
	public static ArrayList getHeadColumnsHt(String fileName, String filter) throws IllegalFileException, IOException 
	{
        ArrayList tempHt = new ArrayList(); //original hashtable from file head
        ArrayList columnsHt = new ArrayList(); //hashtable of entries like: columnName-TableColumnBean
        File f = new File(fileName);//ȼָļ/Ŀ¼

        //׼ļ
        if(f.isFile()) //file
        {
            logger.debug("param "+fileName+" is a file, begin to checkFileNamePattern.");
        	//ļǷָpattern(filter),ϵĲŽнļ
	        if(Utils.checkFileNamePattern(fileName, filter)) //filterֻⲽõ
	        {
	        	//ϵĲŽнļ
	            logger.debug("The file passed pattern check.");
                tempHt = GenericHeadAnalysis.getFitsHead(fileName);
                //ļfilterģʽʱ᷵null쳣Ҳܵõnullֵ쳣׶ִ
                //TODO ֮ڷصnullûֵｫ
		        if(tempHt!=null && tempHt.size()>0)
		        {
		            //ǴļõϢ2Ĭϵݿֶڽɣ	
		        	logger.debug("--[GenericHeadAnalysis][getHeadColumnsHt]--got the head Hashtable, size="+tempHt.size());
		        	/* 200704޸ģʹtempHt.entrySet()ȡCollectioniterator ΪʹEnumerationֱ˳*/
//		        	Enumeration enums = tempHt.keys();//enumeration of the keys(column name String)
//		        	while(enums.hasMoreElements())//αHashtable
//		        	{
//		        		String key = (String) enums.nextElement(); //get an item (String, column name)
//		        		TableColumnBean tcb = new TableColumnBean(); //make a new one each time!
//		        		tcb.setColumnName(key);
//		        		
//		        		/* 20070412޸ģעֶݿʹøtext*/
//	        	    	if(key.equalsIgnoreCase("COMMENT") || key.equalsIgnoreCase("HISTORY") || key.equalsIgnoreCase("MISC"))
//	        	    	{
//	        	    		tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_COMMENT);//"text",longer than "varchar"
//	        	    		tcb.setLength(SystemConstant.DB_COLUMNLENGTH_COMMENT);//unknown, value=0
//	        	    		//TODO ˵ԣtcb.setCommment(comment)
//	        	    	}
//	        	    	else
//	        	    	{
//	        	    		tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_NORMAL);//"varchar", <=255
//	        	    		tcb.setLength(SystemConstant.DB_COLUMNLENGTH_NORMAL); //text, do not set length
//	        	    		//TODO ˵ԣtcb.setCommment(comment)
//	        	    	}
//	        	    	//add the bean into the Hashtable
//		        		columnsHt.put(key, tcb);
//		        	}
		        	
		        	//yujianjun modified at 20071009
		        	for (int i=0;i<tempHt.size();i++)
		        	{
		        		HeaderEntryBean header=(HeaderEntryBean)tempHt.get(i);
		        		String key = header.getKey(); //get an item (String, column name)
		        		TableColumnBean tcb = new TableColumnBean(); //make a new one each time!
		        		tcb.setColumnName(key);
		        		
		        		/* 20070412޸ģעֶݿʹøtext*/
	        	    	if(key.equalsIgnoreCase("COMMENT") || key.equalsIgnoreCase("HISTORY") || key.equalsIgnoreCase("MISC"))
	        	    	{
	        	    		tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_COMMENT);//"text",longer than "varchar"
	        	    		tcb.setLength(SystemConstant.DB_COLUMNLENGTH_COMMENT);//unknown, value=0
	        	    		//TODO ˵ԣtcb.setCommment(comment)
	        	    	}
	        	    	else
	        	    	{
	        	    		tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_NORMAL);//"varchar", <=255
	        	    		tcb.setLength(SystemConstant.DB_COLUMNLENGTH_NORMAL); //text, do not set length
	        	    		//TODO ˵ԣtcb.setCommment(comment)
	        	    	}
	        	    	//add the bean into the Hashtable
		        		//columnsHt.put(key, tcb);
		        		
		        		columnsHt.add(tcb);
		        	}
		        	
		        }
		        /* 20070419޸:۱νļһIO쳣,ܲԣ쳣Ӧ׳ֹ̣
		         * ifвʹtry-catch
		         * */
	        }//if patternҪ
        }//is a normal file
        else if(f.isDirectory())//is directory or illegal file
        {
        	//recursive call
			File[] file = f.listFiles();
			logger.debug("The file: "+f.getPath()+" is directory.\n It contains "+file.length+" files/subdir.");
			for(int i = 0; i<file.length; i++)
			{
				//get columnsHt from each subdir/file, and put together(ignore same columnName) 
				columnsHt.addAll((getHeadColumnsHt(file[i].getPath(), filter))); //pass on this file's path
			}
        }
        else //illegal filename
        {
        	//ûʲôرֻϢ
        	logger.debug("illegal file"+f.getPath());
        }        
        
        return columnsHt;
	
	}
	
	public static Hashtable getHeadColumnsTable(String fileName, String filter) throws IllegalFileException, IOException 
	{
		
        Hashtable tempHt = new Hashtable(); //original hashtable from file head
        Hashtable columnsHt = new Hashtable(); //hashtable of entries like: columnName-TableColumnBean
        File f = new File(fileName);//ȼָļ/Ŀ¼

        //׼ļ
        if(f.isFile()) //file
        {
            logger.debug("param "+fileName+" is a file, begin to checkFileNamePattern.");
        	//ļǷָpattern(filter),ϵĲŽнļ
	        if(Utils.checkFileNamePattern(fileName, filter)) //filterֻⲽõ
	        {
	        	//ϵĲŽнļ
	            logger.debug("The file passed pattern check.");
                tempHt = GenericHeadAnalysis.getFitsHeadHT(fileName);
                //ļfilterģʽʱ᷵null쳣Ҳܵõnullֵ쳣׶ִ
                //TODO ֮ڷصnullûֵｫ
		        if(tempHt!=null && tempHt.size()>0)
		        {
		            //ǴļõϢ2Ĭϵݿֶڽɣ	
		        	logger.debug("--[GenericHeadAnalysis][getHeadColumnsHt]--got the head Hashtable, size="+tempHt.size());
		        	/* 200704޸ģʹtempHt.entrySet()ȡCollectioniterator ΪʹEnumerationֱ˳*/
		        	Enumeration enums = tempHt.keys();//enumeration of the keys(column name String)
		        	while(enums.hasMoreElements())//αHashtable
		        	{
		        		String key = (String) enums.nextElement(); //get an item (String, column name)
		        		TableColumnBean tcb = new TableColumnBean(); //make a new one each time!
		        		tcb.setColumnName(key);
		        		
		        		/* 20070412޸ģעֶݿʹøtext*/
	        	    	if(key.equalsIgnoreCase("COMMENT") || key.equalsIgnoreCase("HISTORY") || key.equalsIgnoreCase("MISC"))
	        	    	{
	        	    		tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_COMMENT);//"text",longer than "varchar"
	        	    		tcb.setLength(SystemConstant.DB_COLUMNLENGTH_COMMENT);//unknown, value=0
	        	    		//TODO ˵ԣtcb.setCommment(comment)
	        	    	}
	        	    	else
	        	    	{
	        	    		tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_NORMAL);//"varchar", <=255
	        	    		tcb.setLength(SystemConstant.DB_COLUMNLENGTH_NORMAL); //text, do not set length
	        	    		//TODO ˵ԣtcb.setCommment(comment)
	        	    	}
	        	    	//add the bean into the Hashtable
		        		columnsHt.put(key, tcb);
		        	}
		        	
		        }
		        /* 20070419޸:۱νļһIO쳣,ܲԣ쳣Ӧ׳ֹ̣
		         * ifвʹtry-catch
		         * */
	        }//if patternҪ
        }//is a normal file
        else if(f.isDirectory())//is directory or illegal file
        {
        	//recursive call
			File[] file = f.listFiles();
			logger.debug("The file: "+f.getPath()+" is directory.\n It contains "+file.length+" files/subdir.");
			for(int i = 0; i<file.length; i++)
			{
				//get columnsHt from each subdir/file, and put together(ignore same columnName) 
				columnsHt.putAll(getHeadColumnsTable(file[i].getPath(), filter)); //pass on this file's path
			}
        }
        else //illegal filename
        {
        	//ûʲôرֻϢ
        	logger.debug("illegal file"+f.getPath());
        }        
        
        return columnsHt;
	
	}
	
	public static ArrayList getHeadColumnsTable(String fileName, String filter,HashSet set) throws IllegalFileException, IOException 
	{
		
        ArrayList tempHt = new ArrayList(); //original hashtable from file head
        ArrayList columnsHt = new ArrayList(); //hashtable of entries like: columnName-TableColumnBean
        File f = new File(fileName);//ȼָļ/Ŀ¼

        //׼ļ
        if(f.isFile()) //file
        {
            logger.debug("param "+fileName+" is a file, begin to checkFileNamePattern.");
        	//ļǷָpattern(filter),ϵĲŽнļ
	        if(Utils.checkFileNamePattern(fileName, filter)) //filterֻⲽõ
	        {
	        	//ϵĲŽнļ
	            logger.debug("The file passed pattern check.");
                tempHt = GenericHeadAnalysis.getFitsHead(fileName);
                //ļfilterģʽʱ᷵null쳣Ҳܵõnullֵ쳣׶ִ
                //TODO ֮ڷصnullûֵｫ
		        if(tempHt!=null && tempHt.size()>0)
		        {
		            //ǴļõϢ2Ĭϵݿֶڽɣ	
		        	logger.debug("--[GenericHeadAnalysis][getHeadColumnsHt]--got the head Hashtable, size="+tempHt.size());
		        	/* 200704޸ģʹtempHt.entrySet()ȡCollectioniterator ΪʹEnumerationֱ˳*/
		        	//Enumeration enums = tempHt.iterator();//enumeration of the keys(column name String)
		        	for(int i=0;i<tempHt.size();i++)
		        	{
		        		HeaderEntryBean header=(HeaderEntryBean)tempHt.get(i);
		        		String key = header.getKey();
		        		if(!set.contains(key))
		        		{
		        			set.add(key);
		        			TableColumnBean tcb = new TableColumnBean(); //make a new one each time!
		        			tcb.setColumnName(key);
		        			tcb.setComment(header.getComment());

		        			/* 20070412޸ģעֶݿʹøtext*/
		        			if(key.equalsIgnoreCase("COMMENT") || key.equalsIgnoreCase("HISTORY") || key.equalsIgnoreCase("MISC"))
		        			{
		        				tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_COMMENT);//"text",longer than "varchar"
		        				tcb.setLength(SystemConstant.DB_COLUMNLENGTH_COMMENT);//unknown, value=0
		        				//TODO ˵ԣtcb.setCommment(comment)
		        			}
		        			else
		        			{
		        				tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_NORMAL);//"varchar", <=255
		        				tcb.setLength(SystemConstant.DB_COLUMNLENGTH_NORMAL); //text, do not set length
		        				//TODO ˵ԣtcb.setCommment(comment)
		        			}
		        			//add the bean into the Hashtable
		        			columnsHt.add(tcb);
		        		}
		        	}
		        	
		        }
		        /* 20070419޸:۱νļһIO쳣,ܲԣ쳣Ӧ׳ֹ̣
		         * ifвʹtry-catch
		         * */
	        }//if patternҪ
        }//is a normal file
        else if(f.isDirectory())//is directory or illegal file
        {
        	//recursive call
			File[] file = f.listFiles();
			logger.debug("The file: "+f.getPath()+" is directory.\n It contains "+file.length+" files/subdir.");
			for(int i = 0; i<file.length; i++)
			{
				//get columnsHt from each subdir/file, and put together(ignore same columnName) 
				columnsHt.addAll(getHeadColumnsTable(file[i].getPath(), filter,set)); //pass on this file's path
			}
        }
        else //illegal filename
        {
        	//ûʲôرֻϢ
        	logger.debug("illegal file"+f.getPath());
        }        
        
        return columnsHt;
	
	}
	 public static boolean FilterFileName(String filename,String filter,String contains)
	    {
	    	
		 if(filter==null||filter.equals(""))
	    		return true;
	    	
	    	String temp=filter;
	    	String temp2="";
	    	int index=temp.lastIndexOf(".");
	    	if(index>0)
	    		temp2=temp.substring(0,index);
	    	else
	    		temp2=temp;
	    	String []temp3=temp2.split("\\*");
	    	boolean addfile=true;
	    	boolean isnotcontains=false;
	    	if(temp3!=null&&temp3.length>0)
	    	{

	    		for(int j=0;j<temp3.length;j++)
	    		{
	    			if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[0]))
	    			{
	    				if(filename.contains(temp3[j]))
	    				{
	    					return true;
	    				}
	    			}
	    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[1]))
	    			{
	    				if(filename.startsWith(temp3[j]))
	    				{
	    					return true;
	    				}
	    			}
	    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[2]))
	    			{
	    				if(filename.endsWith(temp3[j]))
	    					return true;
	    			}
	    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[3]))
	    			{
	    				isnotcontains=true;
	    				if(filename.endsWith(temp3[j]))
	    					addfile=false;
	    			}
	    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[4]))
	    			{
	    				if(filename.equals(temp3[j]))
	    					return true;
	    			}
	    		}
	    	}
	    	if(isnotcontains)
	    		return addfile;
	    	else
	    		return false;
	    		
	    	
	    	
	    }
	public static ArrayList getHeadColumnsTable(String fileName, String filter,HashSet set,String filterfile,String contains) throws IllegalFileException, IOException 
	{
		
        ArrayList tempHt = new ArrayList(); //original hashtable from file head
        ArrayList columnsHt = new ArrayList(); //hashtable of entries like: columnName-TableColumnBean
        File f = new File(fileName);//ȼָļ/Ŀ¼

        //׼ļ
        if(f.isFile()) //file
        {
            logger.debug("param "+fileName+" is a file, begin to checkFileNamePattern.");
        	//ļǷָpattern(filter),ϵĲŽнļ
	        if(Utils.checkFileNamePattern(fileName, filter)) //filterֻⲽõ
	        {
	        	if(FilterFileName(fileName,filterfile,contains))
	        	{
	        		//ϵĲŽнļ
	        		logger.debug("The file passed pattern check.");
	        		tempHt = GenericHeadAnalysis.getFitsHead(fileName);
	        		//ļfilterģʽʱ᷵null쳣Ҳܵõnullֵ쳣׶ִ
	        		//TODO ֮ڷصnullûֵｫ
	        		if(tempHt!=null && tempHt.size()>0)
	        		{
	        			//ǴļõϢ2Ĭϵݿֶڽɣ	
	        			logger.debug("--[GenericHeadAnalysis][getHeadColumnsHt]--got the head Hashtable, size="+tempHt.size());
	        			/* 200704޸ģʹtempHt.entrySet()ȡCollectioniterator ΪʹEnumerationֱ˳*/
	        			//Enumeration enums = tempHt.iterator();//enumeration of the keys(column name String)
	        			for(int i=0;i<tempHt.size();i++)
	        			{
	        				HeaderEntryBean header=(HeaderEntryBean)tempHt.get(i);
	        				String key = header.getKey();
	        				if(!set.contains(key))
	        				{
	        					set.add(key);
	        					TableColumnBean tcb = new TableColumnBean(); //make a new one each time!
	        					tcb.setColumnName(key);

	        					/* 20070412޸ģעֶݿʹøtext*/
	        					if(key.equalsIgnoreCase("COMMENT") || key.equalsIgnoreCase("HISTORY") || key.equalsIgnoreCase("MISC"))
	        					{
	        						tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_COMMENT);//"text",longer than "varchar"
	        						tcb.setLength(SystemConstant.DB_COLUMNLENGTH_COMMENT);//unknown, value=0
	        						//TODO ˵ԣtcb.setCommment(comment)
	        					}
	        					else
	        					{
	        						tcb.setType(SystemConstant.DB_DATATYPE_MYSQL_NORMAL);//"varchar", <=255
	        						tcb.setLength(SystemConstant.DB_COLUMNLENGTH_NORMAL); //text, do not set length
	        						//TODO ˵ԣtcb.setCommment(comment)
	        					}
	        					//add the bean into the Hashtable
	        					columnsHt.add(tcb);
	        				}
	        			}

	        		}
	        	}
		        /* 20070419޸:۱νļһIO쳣,ܲԣ쳣Ӧ׳ֹ̣
		         * ifвʹtry-catch
		         * */
	        }//if patternҪ
        }//is a normal file
        else if(f.isDirectory())//is directory or illegal file
        {
        	//recursive call
			File[] file = f.listFiles();
			logger.debug("The file: "+f.getPath()+" is directory.\n It contains "+file.length+" files/subdir.");
			for(int i = 0; i<file.length; i++)
			{
				//get columnsHt from each subdir/file, and put together(ignore same columnName) 
				columnsHt.addAll(getHeadColumnsTable(file[i].getPath(), filter,set,filterfile,contains)); //pass on this file's path
			}
        }
        else //illegal filename
        {
        	//ûʲôرֻϢ
        	logger.debug("illegal file"+f.getPath());
        }        
        
        return columnsHt;
	
	}
		

		
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		File f = new File("E:\\projects\\BATC_FITHAS\\data\\p0259987TA05m048.fit");
//		try {
//			GenericHeadAnalysis.analyseFitsHead(f);
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
	}


}


