package org.cvo.fithas.ui;



import java.io.IOException;

import org.cvo.fithas.ui.configure.ConfigDBWizard;
import org.cvo.fithas.ui.configure.ConfigDirDialog;
import org.cvo.fithas.ui.wizard.dbbrowser.BrowseDBWizard;
import org.cvo.fithas.ui.wizard.headerarchiving.ArchivingWizard;
import org.cvo.fithas.ui.wizard.headerarchiving.BatchArchivingWizard;
import org.cvo.fithas.ui.wizard.headerviewer.ViewHeadWizard;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.PathConfHelper;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

import com.swtdesigner.SWTResourceManager;

public class FitHas {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(FitHas.class.getName () ) ;
	
//	private static Image image;

	/**
	 * Launch the application
	 * @param args
	 */
	public static void main(String[] args) {
		//open log4j
//		PropertyConfigurator.configure(SystemConstant.PROPFILE_LOG);//ȡlog4jļ
		try {
			drawUI();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void drawUI() throws IOException {
		final Display display = Display.getDefault();
		final Shell shell = new Shell();
		
//		shell.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
		shell.setSize(644, 463);
		shell.setText(ConfigHelper.getAttribute("ui.msg.application.title")); //application title
		
	    //----------------- CORE PART--------------------------------------
        //------------------MENU PART BEGINS-------------------------------
        //˵
        Menu mainMenu = new Menu(shell, SWT.BAR);
        shell.setMenuBar(mainMenu);
        {
            //1. "File"˵
            MenuItem fileItem = new MenuItem(mainMenu, SWT.CASCADE);
            fileItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.file"));
            Menu fileMenu = new Menu(shell, SWT.DROP_DOWN); //"File"Ĳ˵
            fileItem.setMenu(fileMenu);
            {
                //1-1. fitsļ (鿴fitsļͷ)
                MenuItem openFileItem = new MenuItem(fileMenu, SWT.CASCADE);
                openFileItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.file.openfile"));
                //˵ĵ¼
                openFileItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //TODO open viewHeader dialog (same as the big button 1)
                      doViewHeader(shell);
                  }
                }); 
                //1-2. ݿ⡱ (ݿбļ¼)
                MenuItem openDBItem = new MenuItem(fileMenu, SWT.CASCADE);
                openDBItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.file.opendb"));
                //˵ĵ¼
                openDBItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //TODO open browse database dialog (same as the big button 3)
                      doBrowseDB(shell);
                  }
                }); 

                //ָ
                new MenuItem(fileMenu, SWT.SEPARATOR);
                
                //1-3. archive fits head
                MenuItem archiveItem = new MenuItem(fileMenu, SWT.CASCADE);
                archiveItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.file.archive"));
                //˵ĵ¼
                archiveItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //TODO open archive dialog (same as the big button 2)
                      doArchive(shell);
                  }
                }); 
                
                //1-4. batch archive fits head
                MenuItem batchArchiveItem = new MenuItem(fileMenu, SWT.CASCADE);
                batchArchiveItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.file.batchArchive"));
                //˵ĵ¼
                batchArchiveItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //TODO open viewHeader dialog (same as the big button 1)
                      doBatchArchive(shell);
                  }
                }); 

                //ָ
                new MenuItem(fileMenu, SWT.SEPARATOR);
                
                //1-4. "Exit"
                MenuItem exitItem = new MenuItem(fileMenu, SWT.CASCADE);
                exitItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.file.exit"));
               //˵ĵ¼
                exitItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //test
                      display.dispose();//.readAndDispatch();
              		  shell.dispose();
                  }
                });                
            } //"File"˵  
            
            //2. "Option"˵
            MenuItem optionItem = new MenuItem(mainMenu, SWT.CASCADE);
            optionItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.option"));
            Menu optionMenu = new Menu(shell, SWT.DROP_DOWN);  //"Option"µĲ˵
            optionItem.setMenu(optionMenu);
            {
                //2-1. ݿá (Ĭϵݿѡ)
                MenuItem configDBItem = new MenuItem(optionMenu, SWT.CASCADE);
                configDBItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.option.configdb"));
                //˵ĵ¼
                configDBItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //TODO
                	  doDBConfig(shell);
                  }
                });   
                
                //2-2. basedirá
                MenuItem configDIRItem = new MenuItem(optionMenu, SWT.CASCADE);
                configDIRItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.option.configpath"));
                //˵ĵ¼
                configDIRItem.addSelectionListener(new SelectionAdapter() {
                  public void widgetSelected(SelectionEvent e) {
                	  //TODO
                	  doFileConfig(shell);
                  }
                });   
                
                
                
             } //"Option"˵  
            
            //3. "About"˵
            MenuItem helpItem = new MenuItem(mainMenu, SWT.CASCADE);
            helpItem.setText(ConfigHelper.getAttribute("ui.msg.application.menu.about"));
            //˵ĵ¼
            helpItem.addSelectionListener(new SelectionAdapter() {
              public void widgetSelected(SelectionEvent e) {
                  try {
					MessageDialog.openInformation(null, 
							  ConfigHelper.getAttribute("ui.msg.application.menu.file.about"),
							  ConfigHelper.getAttribute("ui.msg.application.about"));
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
              }
            });           
        }

		final Label welcomeToFitLabel = new Label(shell, SWT.WRAP);
		welcomeToFitLabel.setAlignment(SWT.CENTER);
		welcomeToFitLabel.setForeground(SWTResourceManager.getColor(0, 122, 196));
//		welcomeToFitLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
		welcomeToFitLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_TITLE_INACTIVE_BACKGROUND_GRADIENT));
		welcomeToFitLabel.setFont(SWTResourceManager.getFont("", 26, SWT.BOLD | SWT.ITALIC));
		welcomeToFitLabel.setText(ConfigHelper.getAttribute("ui.msg.application.panel.welcome"));
		welcomeToFitLabel.setBounds(215, 99, 355, 140);
       
        //------------------MENU END---------------------------------------------
        
		//-------------------CANVAS PART--------------------------------------
        final Canvas canvas = new Canvas(shell, SWT.BORDER | SWT.FILL | SWT.RESIZE);
        canvas.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_TITLE_INACTIVE_BACKGROUND_GRADIENT));
        canvas.setBounds(0, 0, 1024,768);
           
//        //canvasػ¼canvas.redrawᷢ
//        image = new Image(display, SystemConstant.UI_BACKGROUND_FILE);
//        canvas.addPaintListener(new PaintListener() {
//            public void paintControl(final PaintEvent event) {
//                //ͼʾcanvasϣ10,10ʾͼϽ
//                if (image != null)
//                    event.gc.drawImage(image, 10, 10);
//            }
//        });

        
        
        //----------------------- BUTTON PART ----------------------------
	    // add top composite, which contains 3 selections
		final Group btnGroup = new Group(canvas,  SWT.NONE);
//		btnGroup.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
		btnGroup.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_TITLE_INACTIVE_BACKGROUND_GRADIENT));
		btnGroup.setBounds(28,40,149,311);
		GridLayout layout = new GridLayout();
		layout.verticalSpacing = 20;
		layout.horizontalSpacing = 1;
        btnGroup.setLayout(layout);

		//------------------ BUTTON 1: analysis fits file-----------------
		//button
		final Button btnViewHeader = new Button(btnGroup, SWT.NONE); 
		final GridData gridData_1 = new GridData(SWT.FILL, SWT.FILL, false, false);
		gridData_1.heightHint = 44;
		btnViewHeader.setLayoutData(gridData_1);
		btnViewHeader.setBounds(9, 32, 136, 60); //ðťλ
//		btnViewHeader.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
		//ֺtooltips
		btnViewHeader.setText(ConfigHelper.getAttribute("ui.msg.application.button.doViewButton"));
		btnViewHeader.setToolTipText(ConfigHelper.getAttribute("ui.msg.application.button.doViewButton.tooltip"));
		
		btnViewHeader.addSelectionListener(new SelectionAdapter() {
		    public void widgetSelected(SelectionEvent e) { //ťĵ¼
		      //open wizard: view header
	    	 doViewHeader(shell);
	     	}

		});	
		
        // ---------------------BUTTON 2: archive file------------------------
		//button
		final Button btnArchiving = new Button(btnGroup, SWT.NONE); 
		final GridData gridData_2 = new GridData(SWT.FILL, SWT.FILL, false, false);
		gridData_2.heightHint = 44;
		btnArchiving.setLayoutData(gridData_2);
		btnArchiving.setBounds(9, 102, 136, 60); //ðťλ
		btnArchiving.setText(ConfigHelper.getAttribute("ui.msg.application.button.doArchiveButton"));
		btnArchiving.setToolTipText(ConfigHelper.getAttribute("ui.msg.application.button.doArchiveButton.tooltip"));
		
		btnArchiving.addSelectionListener(new SelectionAdapter() {
		    public void widgetSelected(SelectionEvent e) { //ťĵ¼
	              //open wizard: header archiving
		    	doArchive(shell);
	     	}
		});	

		final Button btnBatchArchiving = new Button(btnGroup, SWT.NONE);
		final GridData gridData_2_1 = new GridData(SWT.FILL, SWT.FILL, false, false);
		gridData_2_1.heightHint = 44;
		btnBatchArchiving.setLayoutData(gridData_2_1);
		btnBatchArchiving.setBounds(9, 172, 136, 60); //ðťλ
		btnBatchArchiving.setText(ConfigHelper.getAttribute("ui.msg.application.button.doBatchArchiveButton"));
		btnBatchArchiving.setToolTipText(ConfigHelper.getAttribute("ui.msg.application.button.doBatchArchiveButton.tooltip"));
				
		btnBatchArchiving.addSelectionListener(new SelectionAdapter() {
		    public void widgetSelected(SelectionEvent e) { //ťĵ¼
	              //open wizard: header archiving
		    	doBatchArchive(shell);
	     	}
		});	
		
		//--------------- BUTTON 3: browse database----------------
        //button
		final Button btnDBBrowser = new Button(btnGroup, SWT.NONE); 
		final GridData gridData = new GridData(SWT.FILL, SWT.FILL, false, false);
		gridData.heightHint = 44;
		btnDBBrowser.setLayoutData(gridData);
		btnDBBrowser.setBounds(9, 242, 136, 60); //ðťλ
		btnDBBrowser.setText(ConfigHelper.getAttribute("ui.msg.application.button.doDBBrowseButton"));
		btnDBBrowser.setToolTipText(ConfigHelper.getAttribute("ui.msg.application.button.doDBBrowseButton.tooltip"));
		
		// action
		btnDBBrowser.addSelectionListener(new SelectionAdapter() {
		     public void widgetSelected(SelectionEvent e) { //ťĵ¼
		    	 //open wizard: browse database
		    	 	doBrowseDB(shell);
	    		}
		});	
		
        //------------------END OF BUTTON GROUP---------------------------------------------
		
        
        //-------------------------- DRAW -----------------------------------
		
		shell.layout();
		shell.open();
		                                                   
	  //  dialog.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		
		//dispose images
//		image.dispose();
	}
	
	
	//--------------------- Action Functions ---------------------------------------------
	private static void doViewHeader(Shell parent) {
		   //open wizard: analysis fits file
			WizardDialog dialog = new WizardDialog(parent, new ViewHeadWizard());//parent:shell?
	    	 dialog.setPageSize(350, 280); //dialogС,-1ָÿԶ
	    	 dialog.open();
		}

	private static void doArchive(Shell parent)
	{
        WizardDialog dialog = new WizardDialog(parent, new ArchivingWizard());//parent:shell?
        dialog.setPageSize(350, 280); //dialogС,-1ָÿԶ
        dialog.open();
	}
	
	private static void doBatchArchive(Shell parent)
	{
        WizardDialog dialog = new WizardDialog(parent, new BatchArchivingWizard());//parent:shell?
        dialog.setPageSize(350, 280); //dialogС,-1ָÿԶ
        dialog.open();
	}
	
	private static void doBrowseDB(Shell parent)
	{
		
   	 	WizardDialog dialog = new WizardDialog(parent, new BrowseDBWizard());//parent:shell?
		dialog.setPageSize(350, 280); //dialogС,-1ָÿԶ
		dialog.open();
	}
	

	private static void doDBConfig(Shell parent)
	{
        WizardDialog dialog = new WizardDialog(parent, new ConfigDBWizard());//parent:shell?
        dialog.setPageSize(350, 280); //dialogС,-1ָÿԶ
        dialog.open();
	}

	private static void doFileConfig(Shell parent)
	{
		String basedir = null;
		ConfigDirDialog dialog = new ConfigDirDialog(parent);//parent:shell?
        //ֻа¡OK/ɡһİťȡֵдļ
		if (dialog.open() == IDialogConstants.OK_ID) {
        	basedir = dialog.getDirTextValue(); //ȡ
            logger.debug("basedir config:---basedir="+basedir);
            //дļ
            try {
    			PathConfHelper.saveAttribute(basedir);
    		} catch (IOException e) {
    			e.printStackTrace();
    		}
        }
       
	}
}
