/**
 * @author: Ann
 * used in wizard , mainly in viewHeadWizard
 * Only one file can be selected(only file dialog)
 */
package org.cvo.fithas.ui.configure;

import java.io.IOException;
import java.sql.SQLException;

import org.cvo.fithas.dbsupport.DBConnectionInfo;
import org.cvo.fithas.dbsupport.DbControl;
import org.cvo.fithas.exception.DBOperationException;
import org.cvo.fithas.exception.NotSpecifiedInfoException;
import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.SystemConstant;
import org.eclipse.jface.dialogs.IMessageProvider;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class ConfigDBPage extends MyWizardPage {

	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ConfigDBPage.class.getName () ) ;
	
	
	private DBConnectionInfo connInfo;

	private Combo dbType;
	private Text server;
	private Text port; //not show on UI
	private Text username;
	private Text password;
	private Text database;

	/**
	 * ̳иĹ캯
	 */
	protected ConfigDBPage(String pageName) {
		super(pageName);
		// SET DB SETTING FIELDS VALUE
	}

	public static void main(String[] args) {
		
//		  DBSettingPage page = new DBSettingPage("test");
//		  page.testConnection();
		 
	}

    /**
     * ﹹDialogеĽ
     */
    public void createControl(Composite parent) {

		// һĵײ壬ʹGridLayout
		Composite topComp = new Composite(parent, SWT.FILL);
		topComp.setLayout(new GridLayout());
		topComp.setBounds(20, 20, 380, 300);

		// ---database setting group-----
		try{
			final Group dbSettingComp = new Group(topComp, SWT.FILL);
			dbSettingComp.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.title"));
			dbSettingComp.setLayoutData(new GridData(SWT.DEFAULT, 150));
			dbSettingComp.setBounds(50, 30, 380, 150);
			
			// text fields, NEED "final Text/Lable" here?
			createDBFields(dbSettingComp); // param: parent Composite
		
			initFields();
			
			final Button testConnectionButton = new Button(dbSettingComp, SWT.NONE);
			testConnectionButton.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(final SelectionEvent e) {
					try {
						testConnection();
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			});
			testConnectionButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.testConnButton"));
			testConnectionButton.setBounds(323, 120, 120, 23);
			
			// ---ÿҳʾϢ---
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.title"));
			setMessage(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.message"),
			        		IMessageProvider.INFORMATION);//NONEINFORMATIONWARNINGERROR
			
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} // set initial values

		//Ҫһ
		 this.setControl(topComp);

	}

	/**
	 * Զ巽ݱ仯ʱݵĺϷ
	 * @throws IOException 
	 */

	public boolean checkOnDataChanged() throws IOException {
		if (server.getText().length() == 0) {
			setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.noserver")); // ʾϢ
			setPageComplete(false);	// ʹɡ͡һť
			return false;
		}
		if(database.getText().length()==0)
		{
			setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.nodatabase")); // ʾϢ
			setPageComplete(false);	// ʹɡ͡һť
			return false;
		}

		// validation passed, set to connInfo, and modify UI
//		saveInConnInfo(); //save input values
		setErrorMessage(null);	// Իϵĳʾ
		setPageComplete(true);	// ʹɡ͡һť
		return true;
	}

	/**
	 * Read info from .xml file.
	 * Be called on construction.
	 * Read all out as a list. 
	 * Use only the first? or the last? or the best? or All of them?
	 * @throws IOException 
	 * */
//	private void initFields() {
//
//		List connInfos = XmlHelper.MyXMLReader(getConfFilePath());
//		DBConnectionInfo info = null;
//		for (Iterator it = connInfos.iterator(); it.hasNext();) {
//			info = (DBConnectionInfo) it.next();
//			info.print(); // for debug
//
//			// set fields value (components in UI)
//			server.setText(info.getServer());
//			port.setText(info.getPort());
//			database.setText(info.getDatabase());
//			username.setText(info.getUserName());
//			password.setText(info.getPassword());
//			table.setText(info.getTableName());
//
//			saveInConnInfo(); // save init values in conninfo
//			// for test, only use the first
//			break;
//		}
//	}

	
	private void initFields() throws IOException {
		//init connection info using default (from properties file, MYSQL)
		connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_MYSQL);
		dbType.select(SystemConstant.DB_TYPE_MYSQL);
		setInFields(connInfo);
		
		 // save init values in conninfo
	}

	private void setFields(int index) throws IOException
	{
		if(index==0)
		{
			connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_MYSQL);
			
		}
		else if(index==1)
		{
			connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_ORACLE);
		}
		else if(index==2)
		{
			connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_SQLSERVER);
		}
		setInFields(connInfo);
	}
	private void setInFields(DBConnectionInfo info) {
		// set fields value (components in UI)
		logger.debug("dbType is:"+SystemConstant.DB_TYPE_MYSQL);
		//dbType.select(SystemConstant.DB_TYPE_MYSQL); //select the option with index: DB_TYPE_MYSQL(1)
		server.setText(info.getServer());
		port.setText(info.getPort());
		database.setText(info.getDatabase());
		username.setText(info.getUserName());
		password.setText(info.getPassword());
	}

	public void saveInConnInfo() throws IOException {
		// TODO Auto-generated method stub
		logger.debug("--[ConfigDBWizard.ConfigDBPage][saveInConnInfo]---");
		int type = 0;
		try{
			//type = ((Integer)dbType.getData("0")).intValue();
			type=dbType.getSelectionIndex();
		}catch(Exception e){}
		connInfo = new DBConnectionInfo(type,server.getText(),username.getText(),password.getText());
		connInfo.setDatabase(database.getText());
		connInfo.setPort(port.getText());
		connInfo.print();
		
	}

	/** 
	 * EXCLUDES TABLE FIELD 
	 * @throws IOException 
	 *  */
	private void createDBFields(Composite parent) throws IOException {

		final Label databaseTypeLabel = new Label(parent, SWT.NONE);
		databaseTypeLabel.setAlignment(SWT.RIGHT);
		databaseTypeLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.dbtype"));
		databaseTypeLabel.setBounds(34, 21, 104, 16);

		dbType = new Combo(parent, SWT.READ_ONLY);
		dbType.add(SystemConstant.UI_DB_TYPE_NAME_MYSQL);//db type "MySQL" to show in UI selection
		dbType.setData("0", new Integer(SystemConstant.DB_TYPE_MYSQL));
		dbType.add(SystemConstant.UI_DB_TYPE_NAME_ORACLE);//db type "MySQL" to show in UI selection
		dbType.setData("1", new Integer(SystemConstant.DB_TYPE_ORACLE));
		dbType.add(SystemConstant.UI_DB_TYPE_NAME_SQLSERVER);//db type "MySQL" to show in UI selection
		dbType.setData("2", new Integer(SystemConstant.DB_TYPE_SQLSERVER));
		
		dbType.addSelectionListener(new SelectionAdapter(){
		      public void widgetSelected(SelectionEvent e) {
		    	  try
		    	  {
		    	  setFields(dbType.getSelectionIndex());
		    	  }catch(IOException exe)
		    	  {
		    		  exe.printStackTrace();
		    	  }
		      }
		    });

		
		
		
		
		//the String "0" is the key of the MySQL's id(0) 
		dbType.setBounds(155, 19, 149, 21);
		
		server = new Text(parent, SWT.BORDER);
		server.setBounds(156, 44, 148, 20);
        server.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                try {
					checkOnDataChanged();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}//ֵĺϷж
            }
        });
        
		Label serverLabel = new Label(parent, SWT.NONE);
		serverLabel.setAlignment(SWT.RIGHT);
		serverLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.server"));
		serverLabel.setBounds(70, 47, 68, 20);

		Label portLabel = new Label(parent, SWT.NONE);
		portLabel.setAlignment(SWT.RIGHT);
		portLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.port"));
		portLabel.setBounds(70, 67, 68, 20);
		
		port = new Text(parent, SWT.BORDER);
		//port.setVisible(true);
		port.setBounds(156, 67, 148, 20);
        port.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                try {
                	checkOnDataChanged();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}//ֵĺϷж
            }
        });
        
		

		Label usernameLabel = new Label(parent, SWT.NONE);
		usernameLabel.setAlignment(SWT.RIGHT);
		usernameLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.username"));
		usernameLabel.setBounds(70, 87, 68, 20);

		username = new Text(parent, SWT.BORDER);
		username.setBounds(156, 87, 148, 20);
        username.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                try {
					checkOnDataChanged();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}//ֵĺϷж
            }
        });
        
		Label passwordLabel = new Label(parent, SWT.NONE);
		passwordLabel.setAlignment(SWT.RIGHT);
		passwordLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.password"));
		passwordLabel.setBounds(70, 107, 68, 20);

		password = new Text(parent, SWT.BORDER | SWT.PASSWORD);
		password.setBounds(156, 107, 148, 20);
        password.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                try {
					checkOnDataChanged();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}//ֵĺϷж
            }
        });
        
		Label databaseLabel = new Label(parent, SWT.NONE);
		databaseLabel.setAlignment(SWT.RIGHT);
		databaseLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.database"));
		databaseLabel.setBounds(60, 127, 78, 20);

		database = new Text(parent, SWT.BORDER);
		database.setBounds(156, 127, 148, 21);
        database.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                try {
					checkOnDataChanged();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}//ֵĺϷж
            }
        });
	}
	

	/**
	 * Action on click "test connection" button.
	 * Test connection to the database with the information set by user
	 * @throws IOException 
	 * */
	public void testConnection() throws IOException {

		//1st, get input info, and validate
		saveInConnInfo();
		if(!checkOnDataChanged())
		{
			logger.debug("-------[DBSettingPage][on testConnectionButton] Please check your input-------------");
			MessageDialog.openWarning(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.invalidInput"));
			return;
		}
		//2nd, test connection and show result(prompt dialog)
		logger.debug("---------[DBSettingPage][on testConnectionButton] testing... -----------");
		boolean isOk;
		try {
			isOk = DbControl.testConnection(connInfo); //test connection to the database
			if (isOk) {
				logger.debug("-------[DBSettingPage][on testConnectionButton] test success-------------");
				MessageDialog.openInformation(null, "", 
						ConfigHelper.getAttribute("ui.info.db.testconnect.ok"));
			}
			else{
				logger.debug("-------[DBSettingPage][on testConnectionButton] test failed-------------");
				MessageDialog.openError(null, "", 
						ConfigHelper.getAttribute("ui.error.db.testconnect.fail"));
			}
		} catch (NotSpecifiedInfoException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.fail")+"\n"
					+ConfigHelper.getAttribute("ui.error.db.noConnInfo"));//no message?
	
		} catch (DBOperationException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.fail")
					+"\nThe exception:"+e.getMessage());
		} catch (SQLException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "",
					ConfigHelper.getAttribute("ui.error.db.testconnect.fail")
					+"\nThe exception:"+e.getMessage());
		}

	}
	
	

	/*
	 * --------Ӧset/get ---------------
	 */
	public DBConnectionInfo getConnInfo() {
		return connInfo;
	}

	public void setConnInfo(DBConnectionInfo connInfo) {
		this.connInfo = connInfo;
	}

	/**
	 * @return Returns the database.
	 */
	public String getDatabase() {
		this.connInfo.setDatabase(database.getText());// save a copy
		return database.getText();
	}

	/**
	 * @param database
	 *            The database to set.
	 */
	public void setDatabase(String database) {
		this.database.setText(database); // optional?
		this.connInfo.setDatabase(database);
	}

	/**
	 * @return Returns the password.
	 */
	public String getPassword() {
		this.connInfo.setPassword(password.getText());// save a copy
		return password.getText();
	}

	/**
	 * @param password
	 *            The password to set.
	 */
	public void setPassword(String password) {
		this.password.setText(password);
		this.connInfo.setPassword(password);
	}

	/**
	 * @return Returns the port.
	 */
	public String getPort() {
		this.connInfo.setPort(port.getText());// save a copy
		return port.getText();
	}

	/**
	 * @param port
	 *            The port to set.
	 */
	public void setPort(String port) {
		this.port.setText(port);
		this.connInfo.setPort(port);
	}

	/**
	 * @return Returns the server.
	 */
	public String getServer() {
		this.connInfo.setServer(server.getText());// save a copy
		return server.getText();
	}

	/**
	 * @param server
	 *            The server to set.
	 */
	public void setServer(String server) {
		this.server.setText(server);
		this.connInfo.setServer(server);
	}

	/**
	 * @return Returns the username.
	 */
	public String getUsername() {
		this.connInfo.setUserName(username.getText());// save a copy
		return username.getText();
	}

	/**
	 * @param username
	 *            The username to set.
	 */
	public void setUsername(String username) {
		this.username.setText(username);
		this.connInfo.setUserName(username);
	}

}