package org.cvo.fithas.ui.configure;

import java.io.IOException;

import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.PathConfHelper;
import org.cvo.fithas.util.SystemConstant;
import org.eclipse.jface.dialogs.IMessageProvider;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class ConfigDirDialog extends TitleAreaDialog{

	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ConfigDirDialog.class.getName () ) ;
	
	
	//Text field
    private Text dirText;
    
    //value of text field (String)
    private String dirTextValue = ""; //String of dir
    
    private String initialDir = "";

    //browse buttons, controlled by radio selection
    private Button btnBrowseDir;
    
    
	public ConfigDirDialog(Shell parentShell) {
		super(parentShell);
		// TODO Auto-generated constructor stub
	}

    /**
     * ﹹDialogеĽ
     */
    protected Control createDialogArea(Composite parent) {
        /*
         * Ҫֱparentϴ׵½沼ֻҡ ӦٲһtopCompڴ崴
         */
        Composite topComp = new Composite(parent, SWT.NONE);
        //ӦRowLayout
        final RowLayout rowLayout = new RowLayout();
        rowLayout.marginLeft = 20;
        rowLayout.marginBottom = 20;
        rowLayout.marginTop = 30;
        topComp.setLayout(rowLayout);
        
		try {
			
	        //һıǩ
	        new Label(topComp, SWT.NONE).setText(ConfigHelper.getAttribute("ui.msg.config.basedir.dirlabel"));
	        //dir textField
	        dirText = new Text(topComp, SWT.BORDER);
	        dirText.setBounds(98, 180, 250, 30);
	        
	        //öԻĳʼ·
			initialDir = PathConfHelper.getAttribute(SystemConstant.CONFIG_PATH_PROPFILE_KEY_BASEDIR);
			dirText.setText(initialDir); //ʾʼ·
		
	        //dir browse button
	        btnBrowseDir = new Button(topComp, SWT.NONE);
	        btnBrowseDir.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		DirectoryDialog dlg = new DirectoryDialog(getShell());
	//                dlg.setText("directory"); //ôڱ
	//                dlg.setMessage("Please select a directory as basedir"); //ʾ	
					logger.debug("===basepath:"+initialDir+"=====");				
					dlg.setFilterPath(initialDir); //Ŀ¼ѡԻóʼ·					
					//򿪶Ի򲢷һѡĿ¼·ַ
					dirTextValue = dlg.open(); 
	                if(dirTextValue==null)
	                {
	                	dirTextValue = initialDir;//ΪδĶ
	                }
	                else
	                {
	                	dirTextValue = dirTextValue.replace('\\', '/');
	                }
	                dirText.setText(dirTextValue);//ѡ·زʾtextؼ
	        	}
	        });
	        btnBrowseDir.setText(ConfigHelper.getAttribute("ui.msg.config.basedir.browse"));
	        btnBrowseDir.setBounds(392, 180, 80,30);
	        
	        //RowDataıĳ
	        final RowData rowData = new RowData(100, -1);
	        rowData.width = 388;
	        dirText.setLayoutData(rowData);
	        setTitle(ConfigHelper.getAttribute("ui.msg.config.basedir.title"));
	        setMessage(ConfigHelper.getAttribute("ui.msg.config.basedir.message"),
	        		IMessageProvider.INFORMATION);//NONEINFORMATIONWARNINGERROR
		
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

        return topComp;
    }

    protected Point getInitialSize() {
	    Point p = super.getInitialSize();
	    p.x = 580;//width, unit:px
	    p.y = 250; //height, unit:px    
    	return p;
    }
    
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * @return Returns the dirTextValue.
	 */
	public String getDirTextValue() {
		return dirTextValue;
	}

	/**
	 * @param dirTextValue The dirTextValue to set.
	 */
	public void setDirTextValue(String dirTextValue) {
		this.dirTextValue = dirTextValue;
	}

}
