package org.cvo.fithas.ui.wizard.dbbrowser;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import org.cvo.fithas.dbsupport.DBConnectionInfo;
import org.cvo.fithas.dbsupport.DbControl;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.SystemConstant;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.TableLayout;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;


public class DynamicTableViewer extends Dialog {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(DynamicTableViewer.class.getName () ) ;
	
	
    private TableViewer tv; //һ
    private DBConnectionInfo connInfo = null; //initial as null
    private String[] fileNames;
    private Hashtable columnTable;
    private List columns;
    private Composite topComp1;
    //page control elements
    private Label pageLabel;
    private Button firstButton;
    private Button prevButton;
    private Button nextButton;
    private Button lastButton;
    
    
    private int curPage = 1; //init1ʼ
    private int totalRecordsCount; //ܼ¼
    private int totalPage;
    
    //Constructor
    protected DynamicTableViewer(Shell parentShell) {
        super(parentShell);
    }

    

    /**
     * ﹹDialogеĽ
     * Ÿ
     */
    protected Control createDialogArea(Composite parent) {
    	
        /* topCompڴ崴   */
        Composite topComp1 = new Composite(parent, SWT.NONE);
        topComp1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
        final GridLayout gridLayout = new GridLayout();
        gridLayout.marginTop = 10;
        gridLayout.marginWidth = 15;
        gridLayout.horizontalSpacing = 8;
        gridLayout.verticalSpacing = 15;
        gridLayout.numColumns = 2;
        topComp1.setLayout(gridLayout);
        
        //һıǩʾ
        final Label label = new Label(topComp1, SWT.NONE);      
        GridData gridData = new GridData();
        gridData.horizontalSpan = 2; //
        label.setLayoutData(gridData);//label
        
        if(connInfo!=null && connInfo.getTableName()!=null)
        {
        	try {
				label.setText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.tableview.msglabel")
						+connInfo.getTableName());
			} catch (IOException e) {
				label.setText(""); //ʾ
			}
        }
        
        //񲿷֣ܼ¼
		try{
	    	//̬ظûѡƱ
			createDynTable(parent);

	        /* ѯܼ¼ */
	        setTotalRecordSettings(connInfo);
			
		} catch (ClassNotFoundException e) {
			label.setText("ClassNotFoundException occured.\n "+e.getMessage());
		} catch (InstantiationException e) {
			label.setText("Exception occured.\n "+e.getMessage());
		} catch (IllegalAccessException e) {
			label.setText("Exception occured.\n "+e.getMessage());
		} catch (SQLException e) {
			label.setText("SQLException occured.\n "+e.getMessage());
		}
                
        //ҳ鿴ť
        try {			
        
	        final Composite pageBtnComp = new Composite(topComp1, SWT.NONE);
	        GridData gData = new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 2, 1);
//	        gData.horizontalAlignment = SWT.RIGHT;
	        pageBtnComp.setLayoutData(gData);//new GridData(SWT.FILL, SWT.FILL, false, false));//pageBtnComptopCompһеĲ
	        //÷pageBtnCompʹõĲ
	        final RowLayout rowLayout = new RowLayout();
	        rowLayout.marginBottom = 0;
	        rowLayout.spacing = 8;
	        rowLayout.marginRight = 0;
	        pageBtnComp.setLayout(rowLayout);

	        
	        /* һҳ */
	        firstButton = new Button(pageBtnComp, SWT.NONE);
	        firstButton.setToolTipText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.first.tooltip"));
	        firstButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.first"));
	        firstButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		gotoFirstPage(); //һҳ
	    	        refreshPageText(); //ʾǰҳ/ҳϢ
	        	}
	        });

	        /* ҳ*/
	        prevButton = new Button(pageBtnComp, SWT.NONE);
	        prevButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.previous"));
	        prevButton.setToolTipText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.previous.tooltip"));
	        prevButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		gotoPreviousPage();//ǰһҳ
	    	        refreshPageText(); //ʾǰҳ/ҳϢ
	        	}
	        });

	        /* ҳ */
	        nextButton = new Button(pageBtnComp, SWT.NONE);
	        nextButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.next"));
	        nextButton.setToolTipText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.next.tooltip"));
	        nextButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		gotoNextPage();
	    	        refreshPageText(); //ʾǰҳ/ҳϢ	        		
	        	}
	        });

	        /* һҳ */
	        lastButton = new Button(pageBtnComp, SWT.NONE);
	        lastButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.last"));
	        lastButton.setToolTipText(ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.last.tooltip"));
	        lastButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		gotoLastPage();
	    	        refreshPageText(); //ʾǰҳ/ҳϢ
	        	}
	        });

	        //ʾǰҳ/ҳϢ
	        pageLabel = new Label(pageBtnComp, SWT.NONE);
	        final RowData rowData = new RowData();
	        rowData.width = 200;
	        pageLabel.setLayoutData(rowData);
	        /* ʾǰҳڴ֮ǰӦùsetTotalRecordSettings()ȡü¼ҳȵֵ */
	        refreshPageText(); 
			
		} catch (IOException e) {
			//use default words to show in UI
			firstButton.setText("<<");
			prevButton.setText("<");
			nextButton.setText(">");
			lastButton.setText(">>");
		}
		
		
        return topComp1;
    }

    /** ˢʾ ǰҳ/ҳ Ϣ*/
    private void refreshPageText() {
        String str = "";
		try {
			str = ConfigHelper.getAttribute("ui.msg.wizard.dbbrowse.page.label") 
					+ curPage + "/" + totalPage;
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        pageLabel.setText(str);
	}



	/**
     * ڸﴴ
     * @throws SQLException 
     * @throws IllegalAccessException 
     * @throws InstantiationException 
     * @throws ClassNotFoundException 
     * */
    public void createDynTable(Composite parent) throws ClassNotFoundException, InstantiationException, IllegalAccessException, SQLException {
    	
        //һĵײ壬ʹGridLayout
        Composite topComp2 = new Composite(parent, SWT.NONE);
        RowLayout rowLayout = new RowLayout(SWT.VERTICAL);
        rowLayout.spacing = 5;//֮ļΪ10
        rowLayout.fill = true;
        rowLayout.marginTop = 10;
        rowLayout.marginBottom = 15;
        rowLayout.marginWidth = 15;
        rowLayout.justify = true;
//        rowLayout.pack = true;
//        rowLayout.justify = true;
        topComp2.setLayout(rowLayout);

        
        /* ȡݿϢȣ */
        //TODO ҵ߼ǽ㣬ܷȥ
        ArrayList columnNames=new ArrayList();
        ArrayList recordList=new ArrayList();
       DbControl.queryTableRecords(connInfo, 0, 
    		                      SystemConstant.UI_DB_BROWSE_ROWSPERPAGE,
    		                      columnNames,recordList); //ӵ0ȡ()
		//List columnNames = DbControl.getTableColumnName(rs);//get list of column name(String)
		//List recordList = DbControl.resultSetToRecordList(rs); //get list of records (each record is a Hashtable)
        
		/* (ѻȡݿṹ)  */
        createTableViewer(topComp2, columnNames);//2nd param: list of the title names

        /* ñıǩ */
        tv.setLabelProvider(new TableViewerLabelProvider());
        tv.setContentProvider(new TableViewerContentProvider());
        
        /* ñ */
        setTableValues(recordList);//ΪݼϣList
                
    }
    
   
    /** ѯܼ¼ҳ˽бֵ
     * Ӧҳʼ˵ʼʱø÷Ϊķҳṩܼ¼ҳϢ
     * */
    private void setTotalRecordSettings(DBConnectionInfo connInfo2) throws SQLException, ClassNotFoundException, InstantiationException, IllegalAccessException {
    	//ܼ¼
    	totalRecordsCount = DbControl.queryTotalCount(connInfo);//rsΪǸֻǲѯ˲ּ¼ 
    	//ҳ
    	if(totalRecordsCount % SystemConstant.UI_DB_BROWSE_ROWSPERPAGE == 0) //ܱ
		{
			totalPage = totalRecordsCount / SystemConstant.UI_DB_BROWSE_ROWSPERPAGE; //ȡ
		}
		else //˦²ּ¼һҳҳҪټһ
		{
			totalPage = totalRecordsCount / SystemConstant.UI_DB_BROWSE_ROWSPERPAGE + 1; //
		}
	}



	/** set given values into a table*/
	public void setTableValues(List recordList) {
		tv.setInput(recordList); //¼listtableViewer
//		ctv.setAllChecked(true);
		logger.debug("--[FieldSelectPage][setTableValues] -- set input");
	}
	
	
    /**
     * 
     * @param parent
     * @param tableColumnTitleList List
     * 			-- ΪnullʱʾʱñĸеƼ
     * 			 nullʱListеStringΪýȥ
     */
    private void createTableViewer(Composite parent, List tableColumnTitleList) {
        /*1.һTableViewerʽMULTIɶѡH_SCROLLˮƽV_SCROLLдֱBORDERб߿FULL_SELECTIONѡ */
        tv = new TableViewer(parent, SWT.BORDER | SWT.FULL_SELECTION | SWT.V_SCROLL | SWT.H_SCROLL);
     
        /*2.ͨTableViewerеTable䲼֣TableViewerе(̬)  */
        setTableColumnTitles(tableColumnTitleList);
    }

    
    /** save selections in private variables */
  public void setTableColumnTitles(List tableColumnTitleList) {
	  
	  	if(tableColumnTitleList==null)
	  		return;
	  	
        /* 1.ͨTableViewerеTable䲼  */        
	  	Table table = tv.getTable();  //ҵtvtable
        //tableߵȣʽ
        final RowData rowData = new RowData();
        rowData.width = 640; //
        rowData.height = 350; //
        table.setLayoutData(rowData);
        table.setHeaderVisible(true); //ʾͷ
        table.setLinesVisible(true); //ʾ
        //tableвֵȣʽ
        TableLayout tLayout = new TableLayout(); //רڱĲ
        table.setLayout(tLayout);
        logger.debug("table.getColumnCount()="+table.getColumnCount());

        /* 2.TableViewerеУ̬  */
        for(int i=0; i<tableColumnTitleList.size(); i++)
        {
        	tLayout.addColumnData(new ColumnWeightData(80,80,true));//пСпɷ
            TableColumn col1 = new TableColumn(table, SWT.BOLD);
            col1.setText((String)tableColumnTitleList.get(i)); //each element in the list is an object(String)
//            logger.debug("--------[TableViewPage][setTableColumnTitles]--column:"+col1.getText());
        }
        //TODO FOR TEST
        table.setLayout(tLayout);
        logger.debug("table.getColumnCount()="+table.getColumnCount());

	}

//	/**
//     * Ӽ
//     */
//    private void addListener() {
//
//    }
    
    
    private void gotoFirstPage()
    {
        /* ȡݿϢȣ */
        //TODO ҵ߼ǽ㣬ܷȥ
		ResultSet rs;
		try {
			if(curPage!=1) //ҳҪ
			{
				//ӵ0ȡ()
				ArrayList recordList=new ArrayList();
				DbControl.queryTableRecords(connInfo, 0, 
										SystemConstant.UI_DB_BROWSE_ROWSPERPAGE,
										recordList);
				//List recordList = DbControl.resultSetToRecordList(rs); //get list of records (each record is a Hashtable)
                 /* ˢ± */
                setTableValues(recordList);//ΪݼϣList
                curPage = 1; //Ϊһҳ
                logger.debug("goto first: now curPage="+curPage+"; get list size="+recordList.size());
			}
            
		} catch (Exception e1) {
			// TODOԻʾѯյǰݣʾղŵݣ
			e1.printStackTrace();
		} 
	
    }
    

    private void gotoPreviousPage()
    {
        /* ȡݿϢȣ */
        //TODO ҵ߼ǽ㣬ܷȥ
		ResultSet rs;
		try {
			if(curPage>1) //ֻеڶҳҳ"preButton"Ч
			{
				int curStart = (curPage-1) * SystemConstant.UI_DB_BROWSE_ROWSPERPAGE;
				int newStart = curStart-SystemConstant.UI_DB_BROWSE_ROWSPERPAGE;
				logger.debug("goto previous: curStart="+curStart+"; newStart="+newStart);
				//ҳȡ()
				ArrayList recordList=new ArrayList();
				DbControl.queryTableRecords(connInfo, newStart, 
										SystemConstant.UI_DB_BROWSE_ROWSPERPAGE,
										recordList);
				//List recordList = DbControl.resultSetToRecordList(rs); //get list of records (each record is a Hashtable)
                 /* ˢ± */
                setTableValues(recordList);//ΪݼϣList
                curPage = curPage - 1; //Ϊҳ
                logger.debug("goto previous: now curPage="+curPage+"; get list size="+recordList.size());
			}
            
		} catch (Exception e1) {
			// TODOԻʾѯյǰݣʾղŵݣ
			e1.printStackTrace();
		} 	
    }
    
    
    private void gotoNextPage()
    {
        /* ȡݿϢȣ */
        //TODO ҵ߼ǽ㣬ܷȥ
		ResultSet rs;
		try {
			int curStart = (curPage-1) * SystemConstant.UI_DB_BROWSE_ROWSPERPAGE;			
			if(curStart+SystemConstant.UI_DB_BROWSE_ROWSPERPAGE < totalRecordsCount) //ûʾļ¼ſҳ
			{
				int newStart = curStart + SystemConstant.UI_DB_BROWSE_ROWSPERPAGE;
				logger.debug("goto next: curStart="+curStart+"; newStart="+newStart);
				//ҳȡ()
				ArrayList recordList=new ArrayList();
				DbControl.queryTableRecords(connInfo, newStart, 
										SystemConstant.UI_DB_BROWSE_ROWSPERPAGE,
										recordList);
				//List recordList = DbControl.resultSetToRecordList(rs); //get list of records (each record is a Hashtable)
                 /* ˢ± */
                setTableValues(recordList);//ΪݼϣList
                curPage = curPage + 1; //Ϊҳ
                logger.debug("goto next: now curPage="+curPage+"; get list size="+recordList.size());
			}
            
		} catch (Exception e1) {
			// TODOԻʾѯյǰݣʾղŵݣ
			e1.printStackTrace();
		} 
	
	
    }
    
    private void gotoLastPage()
    {
        /* ȡݿϢȣ */
        //TODO ҵ߼ǽ㣬ܷȥ
		ResultSet rs;
		int newStart;
		try {
			int curStart = (curPage-1) * SystemConstant.UI_DB_BROWSE_ROWSPERPAGE;			
			if(curStart+SystemConstant.UI_DB_BROWSE_ROWSPERPAGE < totalRecordsCount) //ûʾļ¼ſҳ
			{
				newStart = (totalPage-1) * SystemConstant.UI_DB_BROWSE_ROWSPERPAGE; //µʼһҳϵĵһ¼
				logger.debug("goto last: curStart="+curStart+"; newStart="+newStart);
				//ҳȡ()
				ArrayList recordList=new ArrayList();
				DbControl.queryTableRecords(connInfo, newStart, 
										SystemConstant.UI_DB_BROWSE_ROWSPERPAGE,
										recordList);
				//List recordList = DbControl.resultSetToRecordList(rs); //get list of records (each record is a Hashtable)
                 /* ˢ± */
                setTableValues(recordList);//ΪݼϣList
                curPage = totalPage; //Ϊҳ
                logger.debug("goto last: now curPage="+curPage+"; get list size="+recordList.size());
			}
            
		} catch (Exception e1) {
			// TODOԻʾѯյǰݣʾղŵݣ
			e1.printStackTrace();
		} 
    }
    
    
    /**
     * дDialogеı䴰ʽ
     * */
    protected int getShellStyle() {
    	// ԭʽϣСťı䴰ڴСʽ
    	return super.getShellStyle() | SWT.RESIZE;
    }
    
    /*
     * --------Ӧset/get ---------------
     */

	public Hashtable getColumnTable() {
		return columnTable;
	}

	public void setColumnTable(Hashtable columnTable) {
		this.columnTable = columnTable;
	}

	/**
	 * @return Returns the fileNames.
	 */
	public String[] getFileNames() {
		return fileNames;
	}

	/**
	 * @param fileNames The fileNames to set.
	 */
	public void setFileNames(String[] fileNames) {
		this.fileNames = fileNames;
	}

	/**
	 * @return Returns the columns.
	 */
	public List getColumns() {
		return columns;
	}

	/**
	 * @param columns The columns to set.
	 */
	public void setColumns(List columns) {
		this.columns = columns;
	}

	/**
	 * @return Returns the connInfo.
	 */
	public DBConnectionInfo getConnInfo() {
		return connInfo;
	}



	/**
	 * @param connInfo The connInfo to set.
	 */
	public void setConnInfo(DBConnectionInfo connInfo) {
		this.connInfo = connInfo;
	}



	/**
	 * @return Returns the tv.
	 */
	public TableViewer getTv() {
		return tv;
	}



}
