package org.cvo.fithas.ui.wizard.dbbrowser;

import java.util.Hashtable;
import java.util.List;

import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.TableLayout;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;


public class TableViewPage extends WizardPage {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(TableViewPage.class.getName () ) ;
	
    private TableViewer tv; //һ
//    private CheckboxTableViewer ctv;
    private String[] fileNames;
    private Hashtable columnTable;
    private List columns;
//    private List checkObjs = new ArrayList();
    private Composite topComp;
    
    
    protected TableViewPage(String pageName) {
        super(pageName);
        

    }

    public void createControl(Composite parent) {
    	
        //һĵײ壬ʹGridLayout
        /*Composite */topComp = new Composite(parent, SWT.FILL);
        RowLayout rowLayout = new RowLayout(SWT.VERTICAL);
        rowLayout.spacing = 4;//֮ļΪ3
        rowLayout.fill = true;
        rowLayout.marginRight = 5;
        rowLayout.pack = true;
        rowLayout.justify = true;
        topComp.setLayout(rowLayout);

        /*
         * 
         */
        createTableViewer(topComp,null);

        tv.setContentProvider(new TableViewerContentProvider());
        tv.setLabelProvider(new TableViewerLabelProvider());

        
        //add listener, deal with check actions
        addListener(); 
        
        
        //ÿҳʾϢ
        setTitle("Table description");
//        setMessage("Please select fields as columns of table", INFORMATION);
        //Ҫһ
        this.setControl(topComp);
        
    }

    /** set given values into a table*/
	public void setTableValues(List columnsList) {
		tv.setInput(columnsList); //static values to test
//		ctv.setAllChecked(true);
		logger.debug("--[FieldSelectPage][setTableValues] -- set input");
	}
	


    /**
     * 
     * @param parent
     * @param tableColumnTitleList List
     * 			-- ΪnullʱʾʱñĸеƼ
     * 			 nullʱListеStringΪýȥ
     */
    private void createTableViewer(Composite parent, List tableColumnTitleList) {
        /*
         * һһTableViewerʽMULTIɶѡH_SCROLLˮƽ
         * V_SCROLLдֱBORDERб߿FULL_SELECTIONѡ
         */
        tv = new TableViewer(parent, SWT.BORDER | SWT.FULL_SELECTION | SWT.V_SCROLL | SWT.H_SCROLL);
        
        /* ڶͨTableViewerеTable䲼    */
       
        /* TableViewerеУ̬      */
        setTableColumnTitles(tableColumnTitleList);
    }
    

    
    /** save selections in private variables */
  public void setTableColumnTitles(List tableColumnTitleList) {
	  
	  	if(tableColumnTitleList==null)
	  		return;
	  	
        /*
         * 1.ͨTableViewerеTable䲼
         */        
        Table table = tv.getTable();  //ҵtvtable
        //tableߵȣʽ
        final RowData rowData = new RowData();
        rowData.width = 320;
        rowData.height = 270;
        table.setLayoutData(rowData);
        table.setHeaderVisible(true); //ʾͷ
        table.setLinesVisible(true); //ʾ
        //tableвֵȣʽ
        TableLayout tLayout = new TableLayout(); //רڱĲ
        table.setLayout(tLayout);
        logger.debug("table.getColumnCount()="+table.getColumnCount());

      
        /*
         * 2.TableViewerеУ̬
         */
        for(int i=0; i<tableColumnTitleList.size(); i++)
        {
        	tLayout.addColumnData(new ColumnWeightData(80));//IDепΪ10
            TableColumn col1 = new TableColumn(table, SWT.NONE);
            col1.setText((String)tableColumnTitleList.get(i)); //each element in the list is an object(String)
            logger.debug("--------[TableViewPage][setTableColumnTitles]--column:"+col1.getText());
        }
        //TODO FOR TEST
        table.setLayout(tLayout);
        logger.debug("table.getColumnCount()="+table.getColumnCount());
        //Ҫһ
//        this.setControl(table.getShell().topComp);
	}

	/**
     * Ӽ
     */
    private void addListener() {
    }
    
    /*
     * --------Ӧset/get ---------------
     */

	public Hashtable getColumnTable() {
		return columnTable;
	}

	public void setColumnTable(Hashtable columnTable) {
		this.columnTable = columnTable;
	}

	/**
	 * @return Returns the fileNames.
	 */
	public String[] getFileNames() {
		return fileNames;
	}

	/**
	 * @param fileNames The fileNames to set.
	 */
	public void setFileNames(String[] fileNames) {
		this.fileNames = fileNames;
	}

	/**
	 * @return Returns the columns.
	 */
	public List getColumns() {
		return columns;
	}

	/**
	 * @param columns The columns to set.
	 */
	public void setColumns(List columns) {
		this.columns = columns;
	}

	/**
	 * @return Returns the tv.
	 */
	public TableViewer getTv() {
		return tv;
	}

	/**
	 * @return Returns the topComp.
	 */
	public Composite getTopComp() {
		return topComp;
	}



}