package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.SystemConstant;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;

public class ArchiveSettingPage extends MyWizardPage {

	// radios
	private Button clearTheTableButton;

	private Button skipTheDuplicateButton;

	private Button updateTheDuplicateButton;

	private Label resultLabel = null;
	
	protected ArchiveSettingPage(String pageName) {
		super(pageName);
	}
	

	public void createControl(Composite parent) {
		// һĵײ壬ʹGridLayout
		Composite topComp = new Composite(parent, SWT.NULL);
		final GridLayout gridLayout = new GridLayout();
		
		topComp.setLayout(gridLayout);
		
		

		try {
			
			    resultLabel = new Label(topComp, SWT.NONE);
		        final GridData gridData1= new GridData(SWT.FILL, SWT.CENTER, false, false);
		        gridData1.widthHint = 430;
		        gridData1.heightHint = 50;
		        resultLabel.setLayoutData(gridData1);
		        
			// radios
			final Group radioGroup = new Group(topComp, SWT.NONE);
			radioGroup.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.archivesetting.duplicategroup.title"));
		
			final GridData gridData = new GridData(SWT.CENTER, SWT.CENTER, false, false);
			gridData.heightHint = 190;
			gridData.widthHint = 400;
			
		
			radioGroup.setLayoutData(gridData);
			radioGroup.setLayout(new GridLayout());
			
	
			clearTheTableButton = new Button(radioGroup, SWT.RADIO);
			clearTheTableButton.setLayoutData(new GridData(270, 53));
			clearTheTableButton.setSelection(true);
			clearTheTableButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.archivesetting.duplicategroup.clear"));
	
			skipTheDuplicateButton = new Button(radioGroup, SWT.RADIO);
			//skipTheDuplicateButton.setSelection(true);
			skipTheDuplicateButton.setLayoutData(new GridData(SWT.DEFAULT, 53));
			skipTheDuplicateButton
					.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.archivesetting.duplicategroup.skip"));
	
			updateTheDuplicateButton = new Button(radioGroup, SWT.RADIO);
			updateTheDuplicateButton.setLayoutData(new GridData(SWT.DEFAULT, 52));
			updateTheDuplicateButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.archivesetting.duplicategroup.update"));
	
			// ÿҳʾϢ
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.archivesetting.title"));
			// setMessage("ѧУ", INFORMATION);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// Ҫһ
		this.setControl(topComp);
	}

	/*
	 * --------Ӧset/get ---------------
	 */

	/** Get the strategy selection towards duplicate records.
	 * @return int -- constants are defined in SystemConstant, used to judge what action to take
	 */
	public int getStrategySelection()
	{
		if(clearTheTableButton.getSelection())
			return SystemConstant.DB_ACTION_DUPLICATE_CLEARTABLE;
		else if(skipTheDuplicateButton.getSelection())
			return SystemConstant.DB_ACTION_DUPLICATE_SKIP;
		else
			return SystemConstant.DB_ACTION_DUPLICATE_UPDATE;
	}
	
}
