/**
 * @authorAnn
 * wizard, 
 * defines pages' sequence and initial/finish functions
 * 
 * For Single file:
 * Create new table (use selected file):
 * 	select file 
 *  -> show file header --!!!
 *  -> choose "new table" (and dbsetting)
 *  -> show fields from files (with checkbox?) 
 *  -> show creationg result 
 *  -> ResultPage (do import) 
 * Use existing table :
 * 	select file 
 *  -> show file header --!!!
 *  -> choose "existing table" (and dbsetting)
 *  -> show table fields(no checkbox) 
 *  -> DO NOT show creationg result
 *  -> ResultPage (do import) 
 *  
 */
package org.cvo.fithas.ui.wizard.headerarchiving;


import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import org.cvo.fithas.dbsupport.DBConnectionInfo;
import org.cvo.fithas.dbsupport.DbControl;
import org.cvo.fithas.exception.DBOperationException;
import org.cvo.fithas.exception.DuplicateRecordException;
import org.cvo.fithas.exception.IllegalPathException;
import org.cvo.fithas.exception.NotSpecifiedInfoException;
import org.cvo.fithas.exception.TableAlreadyExistException;
import org.cvo.fithas.exception.TableNotExistsException;
import org.cvo.fithas.fitsfile.GenericHeadAnalysis;
import org.cvo.fithas.ui.wizard.MyWizard;
import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.ui.wizard.ResultPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.Utils;
import org.eclipse.jface.dialogs.MessageDialog;


public class ArchivingWizard extends MyWizard {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ArchivingWizard.class.getName () ) ;
	
	
    /* Ѹҳʵʹܷʵõ   */
    private SingleFileSelectPage fileSelectPage;//ҳ1WizardPage
    private HeadViewPage headViewPage; //ҳ2WizardPage
    private DBSettingPage dbSettingPage;//ҳ3WizardPage
    private TableFieldViewPage tableFieldViewPage;
    private CreateTableResultPage createTableResultPage;//show "ok" or "fail" or sth
    private ArchiveSettingPage archiveSettingPage;//
    private ArchiveResultPage archiveResultPage;//show "ok" or "fail" or sth
    
    
    private List tableColumnInfoList; //list of TableColumnBean object("columnName-type-length" pairs)
    
    private int duplicateMethodType;
    

    /**
     * дaddPagesڴ˷5ҳ벢
     */
    public void addPages() {
        //ҳ󣬲ҳ
        fileSelectPage = new SingleFileSelectPage("Header Archiving: step 1 of 4");
        headViewPage = new HeadViewPage("Header Archiving: step 2 of 4");
        dbSettingPage = new DBSettingPage("Header Archiving: step 3 of 4");
        tableFieldViewPage = new TableFieldViewPage("Header Archiving: step 4 of 4");
        createTableResultPage = new CreateTableResultPage("Header Archiving: create table result");
        archiveSettingPage = new ArchiveSettingPage("Header Archiving: archive setttings");
        archiveResultPage = new ArchiveResultPage("Header Archiving: result");
        
        //WizardPage˳ڽʾ˳ͬʱ˳id
        addPage(fileSelectPage);
        addPage(headViewPage);        
        addPage(dbSettingPage);
        addPage(tableFieldViewPage);        
        addPage(createTableResultPage);
        addPage(archiveSettingPage);
        addPage(archiveResultPage);
        
        //òpageSeq,ʹ0ʼ
        resetPageSeq();
    }

    /**
     * дcanFinishɴ˷жϡɡťʱá
     * 
     * @return falseɡťãtrue෴
     */
    public boolean canFinish() {
 
    	//ȣȡǰwizardPageȡididӵwizardʱ䣩
    	MyWizardPage curPage = (MyWizardPage) this.getContainer().getCurrentPage();
    	logger.debug("Page:"+curPage.getTitle()+" -- id="+curPage.getPageId()+", now pageSeq="+getPageSeq());

    	//鿴fitsͷҳ
    	 if (curPage == headViewPage)
    	 {
    		 //жǰˣ˵ĻҲԲˢ
    		 if(getPageSeq() < curPage.getPageId())//ʾղŵ״̬ҳ֮ǰҲǰ
    		 {
    	       	try {
    	       		logger.debug("fileSelectPage.getFileText()="+fileSelectPage.getFileText());
    				List columns = GenericHeadAnalysis.getHeadValuesList(fileSelectPage.getFileText());//.getFilePathsValue());
    				headViewPage.setTableValues(columns); //static values to test,set analysised columns to show in table 
        	       	if(columns==null)
    				{
    					logger.info("no column from the file:" +fileSelectPage.getFileText());
    				}
                        
    			} catch (Exception e) {
    				e.printStackTrace();
    				String msg = e.getMessage()==null? "no exception message" : e.getMessage();
    				MessageDialog.openError(null, "Exception occured", msg);
    			}
            	logger.debug("--[ArchivingWizard][canFinish]: you selected "+fileSelectPage.getFileText()+" at last page");
    		 }
    	 }
    	 //鿴ɱṹ/Ԥ±ṹҳ
    	 else if(curPage == tableFieldViewPage)
    	 {
    		 //жǰˣ˵Ļڲ鿴ɱԤ±Բˢ
    		 if(getPageSeq() < curPage.getPageId())//ʾղŵ״̬ҳ֮ǰҲǰ
    		 {
    			 //ȽUIϵtable viewer
    			 //Ա⣺֮ǰtvֵ(֮ǰҳ)ѯṹ׳쳣tvݵˢ£ʹUIʾʱ
    			 tableFieldViewPage.clearTable();
    			 
    			 //ʹб
	    		 if(dbSettingPage.isUseExistTable())
	    		 {
	    			 //get structure of the old table
	    			 logger.debug("use existing table");
	    			 try {
	        			 //display title
	        			 tableFieldViewPage.setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.title.view"));
	        			 tableFieldViewPage.setMessage(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.message.view"));
	        			 //query out and show table column info
	    				 tableColumnInfoList = DbControl.queryTableDescription(dbSettingPage.getConnInfo());
	    				 tableFieldViewPage.setTableValues(tableColumnInfoList); //static values to test,set analysised columns to show in table 
	 	        		if(tableColumnInfoList==null)
	 					{
	 	        			logger.info("No column has been got from the table you selected.");
	 					}
					} catch (Exception e) {
						e.printStackTrace();
	    				String msg = e.getMessage()==null? "exception occured" : e.getMessage();
	    				MessageDialog.openError(null, "", msg);
					}
	    		 }
	    		 else //create a new table
	    		 {
	    			 //preview structure of the new table, 
		        	try {
		    			 //display title
		    			 tableFieldViewPage.setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.title.preview"));
		    			 tableFieldViewPage.setMessage(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.message.preview"));
		       			 
		    			 /* ļ±ֶνṹϢ
		       			  * ΪֻȡһļԲÿļƵĹ⣬ҲҪbasedir⡣
		       			  */
		    			HashSet set=new HashSet();
	       				tableColumnInfoList= GenericHeadAnalysis.getHeadColumnsTable(fileSelectPage.getFileText(), null,set);
		        		//Hashtable tempHt = GenericHeadAnalysis.getHeadColumnsTable(, null);//ڶfilterΪnull
		        		//tableColumnInfoList = Utils.HashtableToList(tempHt); //Hashtable -> List(of values)
		    			//tableColumnInfoList =
		        		if(tableColumnInfoList==null)
						{
							logger.info("No column has been abstract from the file :"+fileSelectPage.getFileText());
						}
		        		//3UIʾṹ
		        		List columnsToShowList = DbControl.getDefaultColumnEntryList(); //Ҫ2Ĭֶ
		        		columnsToShowList.addAll(tableColumnInfoList); //ټfits headerĹؼ
		        		tableFieldViewPage.setTableValues(columnsToShowList);  //ʾUIϣбʹ
		                    
					} catch (Exception e) {
						e.printStackTrace();
	    				String msg = e.getMessage()==null? "Exception occured" : e.getMessage();
	    				MessageDialog.openError(null, "", msg);
					}
	    		 }//else, create new table
    		 }//if ǰ
    	 }
    	 ///ȷѡɱҳ
    	 else if (curPage == createTableResultPage)
     	 {
    		 //жǰˣ˵ĻĲҲظκϢ
    		 if(getPageSeq() < curPage.getPageId())//ʾղŵ״̬ҳ֮ǰҲǵҳĶ"ǰ"
    		 {
    			 String usedSQL = null;
	     		//clear the text area first
	    		 createTableResultPage.clearDetailText();
	    		 try{
		     		 //get basic information from other pages
		     	     DBConnectionInfo info = dbSettingPage.getConnInfo();	
	    			 if(dbSettingPage.isUseExistTable()) //use existed table
	    			 {
	    				 //TODO test connection?
	    				 createTableResultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.archive.tablecreateresult.message.useExistOK"));
	    				 showSettings(createTableResultPage, info, null);
	    			 }
	    			 else //do create new table, and show creation result
	    			 {
						//ui
		     			curPage.getControl().setEnabled(false); //disable button push, etc
		     			Thread.sleep(10); //to let UI have time to draw		     				     	        
		     			//main work
		     			usedSQL = doCreate(info, tableColumnInfoList); //ֶϢбϲ/		     			
		     			//show result
		    			showCreateTableResult(createTableResultPage, info, usedSQL);	
		    			logger.info("The table is created successfully. The sql to create table is:\n"+usedSQL);
	    			 }//else
	    			
		     		} catch (Exception e) {
			     		try {
							showCreateTableFailure(createTableResultPage, e);
							logger.info("Failed to create the table. The exception is:\n"+e.getMessage());
						} catch (IOException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}	
			 		}
		     		finally
		 			{
		 				curPage.getControl().setEnabled(true); //disable button push, etc
		 			}
    		 }//if, ǰ
     	 }
    	 //ʾҳ
     	 else if (curPage == archiveResultPage)
    	 {
    		//Ȼǰģж
    		try{
    			curPage.getControl().setEnabled(false); //disable button push, etc
    			Thread.sleep(10); //to let UI have time to draw
    			    			
    			//get information from other pages
    	        DBConnectionInfo info = dbSettingPage.getConnInfo();
    			String datafiles = fileSelectPage.getFileText(); //get the file's path
       		 	duplicateMethodType = archiveSettingPage.getStrategySelection(); //global variable
       		 	
    			//show basic information
       		 	archiveResultPage.clearDetailText(); //clear the text area first
    			showSettings(archiveResultPage, info, datafiles);
    			archiveResultPage.appendDetailText(ConfigHelper.getAttribute("ui.info.archive.processing"));
    			
       		 	//Hashtable to store result 
    			ArrayList<ImportFileStatus> successFileInfo = new ArrayList<ImportFileStatus>();
    			ArrayList<ImportFileStatus> failedFileInfo = new ArrayList<ImportFileStatus>();
    			
       		 	//do main work(ļarchiveҪpattern)
    			doImport(info, datafiles, duplicateMethodType, successFileInfo, failedFileInfo);
    			//show result
    			showArchiveResult(archiveResultPage, successFileInfo, failedFileInfo);
    			logger.info("Archiving process completed. ");
    			
    		} catch (Exception e) {
				e.printStackTrace();
				try {
					showArchiveFailure(archiveResultPage, e);
					logger.info("Exception occured while doing archiving :"+e.getMessage());
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			} finally
			{
				curPage.getControl().setEnabled(true); //disable button push, etc
			}
    	}
    	 
    	 //굱ǰҳӦִеĲǰΪǰҳid¼״̬Ժ´ηҳȽϵóǰǺ
    	 setPageSeq(curPage.getPageId());
    	 logger.debug("after main work in canFinish(), update pageSeq to "+getPageSeq());
    	
        //Ϊûһҳʱɡť
        if (curPage != archiveResultPage)
            return false;
        return super.canFinish();
    }

    
	/**
     * Show user's settings in UI textarea.
	 * @throws IOException 
     * */
    private void showSettings(ResultPage resultPage, DBConnectionInfo info, String datafile) throws IOException {
    	if(info==null)
        {
        	resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.db.noConnInfo"));
        }	
        else
        {
         	//show connect info
         	resultPage.appendDetailText("****************** Database information *********************");
         	resultPage.appendDetailText("database type = MySQL");
         	resultPage.appendDetailText("server = "+info.getServer());
         	resultPage.appendDetailText("username = "+info.getUserName());
   			resultPage.appendDetailText("password = ******");//do not show out
         	resultPage.appendDetailText("database = "+info.getDatabase());
         	resultPage.appendDetailText("table = "+info.getTableName());
         	//--------------debug ends----------------

         	//--------------debug begins----------------
         	if(datafile!=null)
         	{
         		resultPage.appendDetailText("\n**************** The file/directory to archive : ***************");
         		resultPage.appendDetailText(datafile+"\n");   
         	}
         	//--------------debug ends----------------
        }
		
	}
 

	private void showCreateTableResult(ResultPage resultPage, DBConnectionInfo info, String usedSQL) throws IOException {
    	if(info==null)
        {
        	resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.db.noConnInfo"));
        }	
        else
        {         	
        	//show wizard page message
        	resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.archive.tablecreateresult.message.createOK"));
         	//show in detail textarea
        	resultPage.appendDetailText("************ Database informations : ***************");
        	resultPage.appendDetailText("database type = MySQL");
        	resultPage.appendDetailText("server = "+info.getServer());
        	resultPage.appendDetailText("username = "+info.getUserName());
        	resultPage.appendDetailText("password = ******");//do not show out
        	resultPage.appendDetailText("database = "+info.getDatabase());
        	resultPage.appendDetailText("table = "+info.getTableName());
	        //show result
        	resultPage.appendDetailText("\n************ SQL to create the new table : ************");
        	resultPage.appendDetailText(usedSQL+"\n");	      	
         }//else (info != null)        
	}

	
	private void showCreateTableFailure(ResultPage resultPage, Exception e) throws IOException {
    	//show in wizard page message
		resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.archive.tablecreateresult.message.createfail"));
		
		//show in detail textarea
//		resultPage.appendDetailText("\n************ result : ************");
       	if(e!=null)
     	{
//     		//judge exception type
//     		if(e instanceof InterruptedException){
//     			resultPage.appendDetailText("InterruptedException");
//     		}else if (e instanceof TableAlreadyExistException) {
//     			resultPage.appendDetailText("The table already exists.");
//			}else if (e instanceof TableNotExistsException) {
//				resultPage.appendDetailText("The table may not exist.");
//			}else if (e instanceof DBOperationException) {
//				resultPage.appendDetailText("Exception occured while doing database operation.");
//			}else if (e instanceof NotSpecifiedInfoException) {
//				resultPage.appendDetailText("The database configuration may not be specified properly.");
//			}else if (e instanceof DuplicateRecordException) {
//				resultPage.appendDetailText("There may be some duplicate records.");
//			}else if (e instanceof SQLException) {
//				resultPage.appendDetailText("Exception occured while doing database operation.");
//			}
     		//print message
     		if(e.getMessage()!=null)
     		{
           		logger.info(e.getMessage());
     			resultPage.appendDetailText(e.getMessage());
     		}
     		else
     		{
     			resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.detail.noExceptionMessage"));
     		}     
     		e.printStackTrace();
     	}
       
       	//popup dialog
 		MessageDialog.openError(null, "Exception", 
 				ConfigHelper.getAttribute("ui.error.archive.tablecreate.fail"));
		
	}
   
	
	private void showArchiveResult(ResultPage resultPage, ArrayList successFileInfo, ArrayList failedFileInfo) throws IOException {
 		//show wizard page messge
		resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.archive.result.message.ok"));

         	//show in detail textarea
         	String filePath,fileInfo;
         	resultPage.appendDetailText("\n******************* Result : *********************");
         	resultPage.appendDetailText("succeed: "+successFileInfo.size()+" file(s).");
         	resultPage.appendDetailText("failed: "+failedFileInfo.size()+" file(s).\n");
         	logger.info("succeed: "+successFileInfo.size()+" file(s).");
         	logger.info("failed: "+failedFileInfo.size()+" file(s).\n");
         	if(successFileInfo!=null&&successFileInfo.size()!=0)
         	{
         		resultPage.appendDetailText("\n>>>>The files archived successfully are:");
         		logger.info(">>>>The files archived successfully are:\n");
             	for(Iterator it=successFileInfo.iterator(); it.hasNext(); )
	         	{
             		ImportFileStatus status1=(ImportFileStatus)it.next();
//	         		filePath = (String) it.next();
//	         		fileInfo = (String) successFileInfo.get(filePath);
	         		resultPage.appendDetailText(status1.getFilename()+" status:"+status1.getImportInfo()+"\n");//+" -- Info: "+fileInfo);
	         		logger.info(status1.getFilename()+" status:"+status1.getImportInfo()+"\n");
	         	}
         	}
         	if(failedFileInfo.size()!=0)
         	{
	         	resultPage.appendDetailText("\n\n>>>>The files archived failed are:");
	         	logger.info(">>>>The files archived failed are:\n");
	         	for(Iterator it=failedFileInfo.iterator(); it.hasNext(); )
	         	{
	         		ImportFileStatus status2=(ImportFileStatus)it.next();
//	         		filePath = (String) it.next();
//	         		fileInfo = (String) failedFileInfo.get(filePath);
	         		resultPage.appendDetailText(status2.getFilename()+"\n\t--Exception: "+status2.getImportInfo()+"\n");
	         		logger.info(status2.getFilename()+"\n\t--Exception: "+status2.getImportInfo()+"\n");
	         	}
         	}
         	
         	//popup dialog
    		MessageDialog.openInformation(null, "", 
    				ConfigHelper.getAttribute("ui.info.archive.archive.finish")
    				 +"\n  succeed: "+successFileInfo.size()+" file(s)."
    				 +"\n  failed: "+failedFileInfo.size()+" file(s).");
	}

	
	private void showArchiveFailure(ResultPage resultPage, Exception e) throws IOException {
		//show wizard page message
		resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.archive.result.message.fail"));
		
		//show in detail textarea
//		resultPage.appendDetailText("\n************ result : ************");
//       	resultPage.appendDetailText("Failed to import the file(s).");
       	if(e!=null)
     	{
//     		//judge exception type
//     		if(e instanceof IllegalPathException){
//     			resultPage.appendDetailText("The data file may not have a proper path under basedir.");
//     		}else if (e instanceof TableAlreadyExistException) {
//     			resultPage.appendDetailText("The table already exists.");
//			}else if (e instanceof TableNotExistsException) {
//     			resultPage.appendDetailText("The table may not exist.");
//			}else if (e instanceof DBOperationException) {
//     			resultPage.appendDetailText("Exception occured while doing database operation.");
//			}else if (e instanceof NotSpecifiedInfoException) {
//     			resultPage.appendDetailText("The database configuration may not be specified properly.");
//			}else if (e instanceof DuplicateRecordException) {
//				resultPage.appendDetailText("There may be some duplicate records.");
//			}
     		//print message
// 			resultPage.appendDetailText("Exception occured."+e.);
     		if(e.getMessage()!=null)
     		{
     			resultPage.appendDetailText(e.getMessage());
     		}
     		else
     		{
     			resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.detail.noExceptionMessage"));
     		}
     		e.printStackTrace();
     	}
       	//popup dialog
 		MessageDialog.openError(null, "", 
 				ConfigHelper.getAttribute("ui.error.archive.archive.fail"));
	}
	
	/**
	 * Main work.
	 * */
	private String doCreate(DBConnectionInfo info, List tableColumnInfoList) 
		throws TableAlreadyExistException, NotSpecifiedInfoException, DBOperationException, SQLException {//work
		
		String usedSQL;
        if(info==null)
        {
        	throw new NotSpecifiedInfoException();
        }	
        else
        { //create table
	        usedSQL = DbControl.createTable(info, tableColumnInfoList);
	        logger.debug("generate createTable sql="+usedSQL);	      	 
         }
        return usedSQL;
	}
	
	/**
	 * Main work
	 * */
	private void doImport(DBConnectionInfo info, String datafilesPathStr, int duplicateMethodType, ArrayList successFileInfo, ArrayList failedFileInfo) 
    	throws NotSpecifiedInfoException, DBOperationException, TableNotExistsException, SQLException, IOException, IllegalPathException, DuplicateRecordException {
        
        if(info==null)
        {
        	throw new NotSpecifiedInfoException();
        }	
        else
        {     
        	//begin import
			DbControl.importToDb(info, datafilesPathStr, null, duplicateMethodType, successFileInfo, failedFileInfo);
         }
		
	}

	/*
     * 
     * дperformFinishɡťʱִд˷
     * wizard dialog will be close, and left the main shell
     */
    public boolean performFinish() {
        return true;
    }
}