/**
 * @authorAnn
 * wizard, 
 * defines pages' sequence and initial/finish functions
 *  
 * For batch dir:
 * Create new table (use selected file):
 * 	select dir 
 *  //-> show file header --!!!
 *  -> choose "new table" (and dbsetting)
 *  -> show fields from files (with checkbox?) 
 *  -> show creationg result 
 *  -> ResultPage (do import) 
 * Use existing table :
 * 	select dir 
 *  //-> show file header --!!!
 *  -> choose "existing table" (and dbsetting)
 *  -> show table fields(no checkbox) 
 *  -> DO NOT show creationg result
 *  -> ResultPage (do import) 
 */
package org.cvo.fithas.ui.wizard.headerarchiving;


import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import org.cvo.fithas.dbsupport.DBConnectionInfo;
import org.cvo.fithas.dbsupport.DbControl;
import org.cvo.fithas.exception.DBOperationException;
import org.cvo.fithas.exception.DuplicateRecordException;
import org.cvo.fithas.exception.IllegalPathException;
import org.cvo.fithas.exception.NotSpecifiedInfoException;
import org.cvo.fithas.exception.TableAlreadyExistException;
import org.cvo.fithas.exception.TableNotExistsException;
import org.cvo.fithas.fitsfile.GenericHeadAnalysis;
import org.cvo.fithas.ui.wizard.MyWizard;
import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.ui.wizard.ResultPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.SystemConstant;
import org.cvo.fithas.util.Utils;
import org.eclipse.jface.dialogs.MessageDialog;


public class BatchArchivingWizard extends MyWizard {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(BatchArchivingWizard.class.getName () ) ;
	
	
    /* Ѹҳʵʹܷʵõ */
    private FileSelectPage fileSelectPage;//ҳ1WizardPage
    private FileNameFilterPage fileNamefilterPage;
    private DBSettingPage dbSettingPage;//ҳ3WizardPage
    private TableFieldViewPage tableFieldViewPage;
    private CreateTableResultPage createTableResultPage;//show "ok" or "fail" or sth
    private ArchiveSettingPage archiveSettingPage;//
    private ArchiveResultPage archiveResultPage;//show "ok" or "fail" or sth
    private ScanTableSelectPage scanTableSelectPage;
    
    
    private List tableColumnInfoList; //list of "columnName-type-length" pairs

    
    private int duplicateMethodType;
    private boolean checkOnlyOneFile=false;
    
    
    /**
     * дaddPagesڴ˷5ҳ벢
     */
    public void addPages() {
        //ҳ󣬲ҳ
        fileSelectPage = new FileSelectPage("Header Archiving: step 1 of 3");
        scanTableSelectPage=new ScanTableSelectPage("Header Archiving: step 1 of 3");
        fileNamefilterPage = new FileNameFilterPage("Header Archiving");        
        dbSettingPage = new DBSettingPage("Header Archiving: step 2 of 3");
        tableFieldViewPage = new TableFieldViewPage("Header Archiving: step 2 of 3");
        createTableResultPage = new CreateTableResultPage("Header Archiving: create table result");
        archiveSettingPage = new ArchiveSettingPage("Header Archiving: step 3 of 3");
        archiveResultPage = new ArchiveResultPage("Header Archiving: result");
        
        
        //WizardPage˳ڽʾ˳ͬʱ˳id
        addPage(fileSelectPage);   
        addPage(fileNamefilterPage);
        addPage(scanTableSelectPage); 
        addPage(dbSettingPage);
        addPage(tableFieldViewPage);        
        addPage(createTableResultPage);
        addPage(archiveSettingPage);
        addPage(archiveResultPage);
        
        //òpageSeq,ʹ0ʼ
        resetPageSeq();
    }

    
    /**
     * дcanFinishɴ˷жϡɡťʱá     * 
     * @return falseɡťãtrue෴
     */
    public boolean canFinish() {
    	
    	//ȣȡǰwizardPageȡididӵwizardʱ䣩
    	MyWizardPage curPage = (MyWizardPage) this.getContainer().getCurrentPage();
    	logger.debug("Page:"+curPage.getTitle()+" -- id="+curPage.getPageId()+", now pageSeq="+getPageSeq());
    	
    	 //鿴ɱṹ/Ԥ±ṹҳ
    	 if(curPage == tableFieldViewPage)
    	 {
    		 //жǰˣ˵Ļڲ鿴ɱԤ±Բˢ
    		 if(getPageSeq() < curPage.getPageId())//ʾղŵ״̬ҳ֮ǰҲǰ
    		 {
    			 //ȽUIϵtable viewer
    			 //Ա⣺֮ǰtvֵ(֮ǰҳ)ѯṹ׳쳣tvݵˢ£ʹUIʾʱ
    			 tableFieldViewPage.clearTable();
    			
    			 //ʹб
	    		 if(dbSettingPage.isUseExistTable()) //use exist table, show table structure
	    		 {
	    			 //show structure of the old table
	    			 logger.debug("use existing table.");
	    			 try {
	        			 //display title
	        			 tableFieldViewPage.setTitle(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tableview.title.view"));
	        			 tableFieldViewPage.setMessage(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tableview.message.view"));
	        			 //get structure to show
	    				 tableColumnInfoList = DbControl.queryTableDescription(dbSettingPage.getConnInfo());
	    				 tableFieldViewPage.setTableValues(tableColumnInfoList); //static values to test,set analysised columns to show in table 
	 	        		if(tableColumnInfoList==null)
	 					{
	 						logger.debug("no columns get from this table!");
	 					}
					} catch (Exception e) {
						e.printStackTrace();
	    				String msg = e.getMessage()==null? "Exception occured" : e.getMessage();
	    				MessageDialog.openError(null, "", msg);
					}
	    		 }//if ʹб
	    		 else //create a new table
	    		 {
	    			 //show structure of the new table to create
		        	try {
		       			 //display title
		       			 tableFieldViewPage.setTitle(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tableview.title.preview"));
		       			 tableFieldViewPage.setMessage(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tableview.message.preview"));
		       			 
		       			 /* ļ±ֶνṹϢ
		       			  * ڽпļƵĹ⣬ֻзûpatternļŻ
		       			  * (ǲҪbasedir)ļgetHeadColumnsHt()ɣUI
		       			  */
		       			 String filter = fileNamefilterPage.getRegExp(); //ȡûpattern
		       			 logger.debug("filter="+filter);
		       			 
		       			 //ֻҪֶ
		       			 String[]newFileList=fileSelectPage.getDataPathsArray();
		       			 //String[]newFileList=getMatchedFileList(FileList);
		       			 String filterFilename=fileNamefilterPage.getFileName();
		       			 String contains=fileNamefilterPage.getContains();
		       			 
		       			 
		       			//ArrayList tempHt=null;
		       			File[] files=null;
		       			if(scanTableSelectPage.getRadioSelection()==0)
		       			{
		       				if(newFileList!=null&&newFileList.length>0)
		       				{
		       					files=new File[newFileList.length];
		       					for(int i=0;i<newFileList.length;i++)
		       					{
		       						files[i]=new File(newFileList[i]);
		       					}
		       				}
		       				String filename="";
		       				if(filterFilename!=null&&!(filterFilename.equals("")))
		       					filename=getFirstFile(files,filterFilename,contains);
		       				else
		       					filename=getFirstFile(files);
		       				
		       				if(filename!=null&&!(filename.equals("")))
		       				{
		       					HashSet set=new HashSet();
		       					tableColumnInfoList= GenericHeadAnalysis.getHeadColumnsTable(filename, filter,set);
		       				}
		       				else
		       				{
		       					MessageDialog.openError(null, "", "can not find any file under the file name filter specified!");
		       					return true;
		       				}
		       			}
		       			else if(scanTableSelectPage.getRadioSelection()==1)
		       			 {
		       				if(newFileList!=null&&newFileList.length>0)
		       				{
		       					if(filterFilename==null||filterFilename.equals(""))
		       						tableColumnInfoList= GenericHeadAnalysis.getHeadColumnsTable(newFileList, filter);
		       					else
		       						tableColumnInfoList= GenericHeadAnalysis.getHeadColumnsTable(newFileList, filter,filterFilename,contains);
		       				}
		       			 }
		       			 //ݴpatternԼûѡļȥڽֶ
		       			 
		        		//tableColumnInfoList = Utils.HashtableToList(tempHt); //Hashtable -> List(of values)
		        		if(tableColumnInfoList==null) //бյĻڽ
						{
							logger.debug("no column in tableColumnInfoList generated from getHeadColumnsHt()");
						}
		        		//3UIʾṹ
		        		List columnsToShowList = DbControl.getDefaultColumnEntryList(); //Ҫ2ĬֶΣListֻUIʾṹ
		        		columnsToShowList.addAll(tableColumnInfoList); //ټfits headerĹؼ
		        		tableFieldViewPage.setTableValues(columnsToShowList);  //ʾUIϣбʹ
			                    
					} catch (Exception e) {
						e.printStackTrace();
	    				String msg = e.getMessage()==null? "Exception occured" : e.getMessage();
	    				MessageDialog.openError(null, "", msg);
					}
	    		 }//else ±
    		 }//if ǰ
    	 }
    	 //ʾ/ȷѡɱҳ
    	 else if (curPage == createTableResultPage)
     	 {
    		 //жǰˣ˵ĻĲҲظκϢ
    		 if(getPageSeq() < curPage.getPageId())//ʾղŵ״̬ҳ֮ǰҲǵҳĶ"ǰ"
    		 {
	    		 //clear the text area first
	    		 createTableResultPage.clearDetailText();	    		 
	    		 try{
		     		 //get basic information from other pages
		     	     DBConnectionInfo info = dbSettingPage.getConnInfo();
	    			 if(dbSettingPage.isUseExistTable()) //use existed table
		    		 {
	    				 createTableResultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tablecreateresult.message.useExistOK"));
		    			 showSettings(createTableResultPage, info, null);
		     		 }
		     		 else //do create new table, and show creation result
		     		 {
		     			curPage.getControl().setEnabled(false); //disable button push, etc
		     			Thread.sleep(10); //to let UI have time to draw	     			
		     	        //main work
		     			String usedSQL = doCreate(info, tableColumnInfoList); //ֶϢбϲ/
		     			//show result
		    			showCreateTableResult(createTableResultPage, info, usedSQL);
		     		 }//else
		    			
		     	} catch (Exception e) {
		     		e.printStackTrace();
		     		try {
						showCreateTableFailure(createTableResultPage, e);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}	
		 		} finally
		 		{
		 			curPage.getControl().setEnabled(true); //disable button push, etc
		 		}
    		 }//if,ǰ
     	 }
    	//ʾҳ
     	 else if (curPage == archiveResultPage)
    	 {
     		//Ȼǰģж
    		try{
    			curPage.getControl().setEnabled(false); //disable button push, etc
    			Thread.sleep(10); //to let UI have time to draw
    			
    			//get information from other pages
    	        DBConnectionInfo info = dbSettingPage.getConnInfo();
    			String[] newFileList = fileSelectPage.getDataPathsArray(); //array of files/dir
    			//String[]newFileList=getMatchedFileList(datafiles);
       		 	duplicateMethodType = archiveSettingPage.getStrategySelection(); //global variable
      			 String filter = fileNamefilterPage.getRegExp(); //ȡûpattern
      			 
    			//show basic information
       		 	archiveResultPage.clearDetailText(); //clear the text area first
    			showSettings(archiveResultPage, info, newFileList);
    			archiveResultPage.appendDetailText(ConfigHelper.getAttribute("ui.info.archive.processing"));
    			
       		 	//Hashtable to store result 
    			ArrayList<ImportFileStatus> successFileInfo = new ArrayList<ImportFileStatus>();
    			ArrayList<ImportFileStatus> failedFileInfo = new ArrayList<ImportFileStatus>();
    			
       		 	//do main work(ΪǶļ/Ŀ¼ԻҪpatternļ)
    			 String filterFilename=fileNamefilterPage.getFileName();
       			 String contains=fileNamefilterPage.getContains();
       			 if(filterFilename==null||filterFilename.equals(""))
       				 doImport(info, newFileList, filter, duplicateMethodType, successFileInfo, failedFileInfo);
       			 else
       				doImport(info, newFileList, filter, duplicateMethodType, successFileInfo, failedFileInfo,filterFilename,contains); 
    			//show result
    			showArchiveResult(archiveResultPage, successFileInfo, failedFileInfo);
    			logger.info("Archiving process completed. ");
    			
    		} catch (Exception e) {
				e.printStackTrace();
				try {
					showArchiveFailure(archiveResultPage, e);
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}  finally
			{
				curPage.getControl().setEnabled(true); //disable button push, etc
			}
    	}
    	 
    	 
    	 //굱ǰҳӦִеĲǰΪǰҳid¼״̬Ժ´ηҳȽϵóǰǺ
    	 setPageSeq(curPage.getPageId());
    	 logger.debug("after main work in canFinish(), update pageSeq to "+getPageSeq());
    	
        //Ϊûһҳʱɡť
        if (curPage != archiveResultPage)
            return false;
        return super.canFinish();
    }
    
   public String getFirstFile(File[]newFileList)
    {
	   String filename="";
	   if(newFileList!=null&&newFileList.length>0)
	   {
		   for(int i=0;i<newFileList.length;i++)
		   {
			  
			   try
			   {
				   File f = newFileList[i];
				   if(f.isFile())
				   {
					   if(f.getAbsolutePath().toUpperCase().endsWith(".FITS")||f.getAbsolutePath().toUpperCase().endsWith(".FIT")||f.getAbsolutePath().toUpperCase().endsWith(".GZ"))
					   return f.getAbsolutePath();
				   }
				   else if(f.isDirectory())
				   {
					   File[] files = f.listFiles();
					   filename=getFirstFile(files);
				   }
			   }catch(Exception e)
			   {
				   
			   }
			   
		   }
	   }
    	return filename;
    	
    }
   
   public String getFirstFile(File[]newFileList,String filterfilename,String contains)
   {
	   String filename="";
	   if(newFileList!=null&&newFileList.length>0)
	   {
		   for(int i=0;i<newFileList.length;i++)
		   {
			  
			   try
			   {
				   File f = newFileList[i];
				   if(f.isFile())
				   {
					   if(f.getAbsolutePath().toUpperCase().endsWith(".FITS")||f.getAbsolutePath().toUpperCase().endsWith(".FIT")||f.getAbsolutePath().toUpperCase().endsWith(".GZ"))
					   {
						   if(f.getName()!=null&&!(f.getName().equals("")))
						   {
							   if(FilterFileName(f.getName(),filterfilename,contains))
							   {
								   return f.getAbsolutePath();
								   
							   }
							   
						   }
					    
					   }
				   }
				   else if(f.isDirectory())
				   {
					   File[] files = f.listFiles();
					   filename=getFirstFile(files,filterfilename,contains);
					   if(filename!=null&&(!filename.equals("")))
						   return filename;
						   
					  
				   }
			   }catch(Exception e)
			   {
				   
			   }
			   
		   }
	   }
   	return filename;
   	
   }

	/**
     * Show user's settings in UI textarea.
	 * @throws IOException 
     * */
    private void showSettings(ResultPage resultPage, DBConnectionInfo info, String[] datafiles) throws IOException {
    	if(info==null)
        {
        	resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.db.noConnInfo"));
        }	
        else
        {
         	//show connect info
         	resultPage.appendDetailText("****************** Database information *********************");
         	resultPage.appendDetailText("database type = MySQL");
         	resultPage.appendDetailText("server = "+info.getServer());
         	resultPage.appendDetailText("username = "+info.getUserName());
   			resultPage.appendDetailText("password = ******");//do not show out
         	resultPage.appendDetailText("database = "+info.getDatabase());
         	resultPage.appendDetailText("table = "+info.getTableName());
         	//--------------debug ends----------------

         	//--------------debug begins----------------
         	if(datafiles!=null && datafiles.length==1)
         	{
	         	resultPage.appendDetailText("\n**************** The file/directory to archive : ***************");
	         	resultPage.appendDetailText(Utils.concatString(datafiles)+"\n");
         	}
         	//--------------debug ends----------------
        }
		
	}
    
    private ArrayList getAllFiles(String[]oldFileList)
    {
    	ArrayList al=new ArrayList();
    	if(oldFileList!=null&&oldFileList.length>0)
    	{
    		for(int i=0;i<oldFileList.length;i++)
    		{
    			
    			File file = new File(oldFileList[i]);
    			if(file.isDirectory())
    			{
    				File[] files = file.listFiles();
    				String []temp=new String[files.length];
    				if(files!=null&&files.length>0)
    				{
    					for(int j=0;j<files.length;j++)
    						temp[j]=files[j].getAbsolutePath();
    				}
    				al.addAll(getAllFiles(temp));
    			}
    			else
    			{
    				if(Utils.checkFileNamePattern(oldFileList[i], fileNamefilterPage.getRegExp()))
        				al.add(oldFileList[i]);
    			}
    			
    		}
    	}
    	return al;
    }
    
    private boolean FilterFileName(String filename,String filter,String contains)
    {
    	
    	if(filter==null||filter.equals(""))
    		return true;
    	
    	String temp=filter;
    	String temp2="";
    	int index=temp.lastIndexOf(".");
    	if(index>0)
    		temp2=temp.substring(0,index);
    	else
    		temp2=temp;
    	String []temp3=temp2.split("\\*");
    	boolean addfile=true;
    	boolean isnotcontains=false;
    	if(temp3!=null&&temp3.length>0)
    	{

    		for(int j=0;j<temp3.length;j++)
    		{
    			if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[0]))
    			{
    				if(filename.contains(temp3[j]))
    				{
    					return true;
    				}
    			}
    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[1]))
    			{
    				if(filename.startsWith(temp3[j]))
    				{
    					return true;
    				}
    			}
    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[2]))
    			{
    				if(filename.endsWith(temp3[j]))
    					return true;
    			}
    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[3]))
    			{
    				isnotcontains=true;
    				if(filename.endsWith(temp3[j]))
    					addfile=false;
    			}
    			else if(contains.equals(SystemConstant.REG_MATCH_PATTERNS[4]))
    			{
    				if(filename.equals(temp3[j]))
    					return true;
    			}
    		}
    	}
    	if(isnotcontains)
    		return addfile;
    	else
    		return false;
    		
    	
    	
    }
	private void showCreateTableResult(ResultPage resultPage, DBConnectionInfo info, String usedSQL) throws IOException {
    	
        if(info==null)
        {
        	resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.db.noConnInfo"));
        }	
        else
        {    
        	//show wizard page message
        	resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tablecreateresult.message.createOK"));
         	//show in detail textarea
        	resultPage.appendDetailText("************ Database informations : ***************");
        	resultPage.appendDetailText("database type = MySQL");
        	resultPage.appendDetailText("server = "+info.getServer());
        	resultPage.appendDetailText("username = "+info.getUserName());
        	resultPage.appendDetailText("password = ******");//do not show out
        	resultPage.appendDetailText("database = "+info.getDatabase());
        	resultPage.appendDetailText("table = "+info.getTableName());
	        //show result
        	resultPage.appendDetailText("\n************ SQL to create the new table : ************");
        	resultPage.appendDetailText(usedSQL+"\n");	      	
         }//else (info != null)
 		
	}

	private void showCreateTableFailure(ResultPage resultPage, Exception e) throws IOException {
    	//show in wizard page message
		resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.tablecreateresult.message.createfail"));
		//show in detail textarea
//		resultPage.appendDetailText("\n************ result : ************");
//		resultPage.appendDetailText("Failed to import the file(s).");
       	if(e!=null)
     	{
//     		//judge exception type
//     		if(e instanceof InterruptedException){
//     			resultPage.appendDetailText("InterruptedException");
//     		}else if (e instanceof TableAlreadyExistException) {
//     			resultPage.appendDetailText("The table already exists.");
//			}else if (e instanceof TableNotExistsException) {
//				resultPage.appendDetailText("The table may not exist.");
//			}else if (e instanceof DBOperationException) {
//				resultPage.appendDetailText("Exception occured while doing database operation.");
//			}else if (e instanceof NotSpecifiedInfoException) {
//				resultPage.appendDetailText("The database configuration may not be specified properly.");
//			}else if (e instanceof DuplicateRecordException) {
//				resultPage.appendDetailText("There may be some duplicate records.");
//			}else if (e instanceof SQLException) {
//				resultPage.appendDetailText("Exception occured while doing database operation.");
//			}
     		//print message
     		if(e.getMessage()!=null)
     		{
           		logger.info(e.getMessage());
     			resultPage.appendDetailText(e.getMessage());
     		}
     		else
     		{
     			resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.detail.noExceptionMessage"));
     		}     
     		e.printStackTrace();
     	     	
     	}
       	//popup dialog
 		MessageDialog.openError(null, "Exception", 
 				ConfigHelper.getAttribute("ui.error.archive.tablecreate.fail"));
				
	}

    private void showArchiveResult(ResultPage resultPage, ArrayList successFileInfo, ArrayList failedFileInfo) throws IOException {
 		//show wizard page messge
		resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.result.message.ok"));
     	//show result
     	String filePath,fileInfo;
     	resultPage.appendDetailText("\n******************* Result : *********************");
      	resultPage.appendDetailText("succeed: "+successFileInfo.size()+" file(s).");
     	resultPage.appendDetailText("failed: "+failedFileInfo.size()+" file(s).\n");
     	if(successFileInfo!=null&&successFileInfo.size()!=0)
     	{
	     	resultPage.appendDetailText("\n>>>>The files imported successfully are:");
	     	
	     	for(Iterator it=successFileInfo.iterator(); it.hasNext(); )
	     	{
	     		ImportFileStatus status1=(ImportFileStatus)it.next();
//	     		filePath = (String) it.next();
//	     		fileInfo = (String) successFileInfo.get(filePath);
	     		resultPage.appendDetailText(status1.getFilename()+" status:"+status1.getImportInfo());//+" -- Info: "+fileInfo);
	     	}
     	}
     	if(failedFileInfo!=null&&failedFileInfo.size()!=0)
     	{
	     	resultPage.appendDetailText("\n\n>>>>The files imported failed are:");
	     	for(Iterator it=failedFileInfo.iterator(); it.hasNext(); )
	     	{
	     		ImportFileStatus status2=(ImportFileStatus)it.next();
//	     		filePath = (String) it.next();
//	     		fileInfo = (String) failedFileInfo.get(filePath);
	     		resultPage.appendDetailText(status2.getFilename()+"\n\t--Exception: "+status2.getImportInfo()+"\n");
	     	}
     	}
     	//--------------debug ends----------------
     	
     	//show result
     	//popup dialog
		MessageDialog.openInformation(null, "", 
				ConfigHelper.getAttribute("ui.info.archive.archive.finish")
				 +"\n  succeed: "+successFileInfo.size()+" file(s)."
				 +"\n  failed: "+failedFileInfo.size()+" file(s).");
	
	}

	private void showArchiveFailure(ResultPage resultPage, Exception e) throws IOException {
		//show wizard page message
		resultPage.setResultMsg(ConfigHelper.getAttribute("ui.msg.wizard.archive.result.message.fail"));
		
		//show in detail textarea
//		resultPage.appendDetailText("\n************ result : ************");
//      resultPage.appendDetailText("Failed to import the file(s).");
       	if(e!=null)
     	{
//     		//judge exception type
//     		if(e instanceof IllegalPathException){
//     			resultPage.appendDetailText("The data file may not have a proper path under basedir.");
//     		}else if (e instanceof TableAlreadyExistException) {
//     			resultPage.appendDetailText("The table already exists.");
//			}else if (e instanceof TableNotExistsException) {
//     			resultPage.appendDetailText("The table may not exist.");
//			}else if (e instanceof DBOperationException) {
//     			resultPage.appendDetailText("Exception occured while doing database operation.");
//			}else if (e instanceof NotSpecifiedInfoException) {
//     			resultPage.appendDetailText("The database configuration may not be specified properly.");
//			}else if (e instanceof DuplicateRecordException) {
//				resultPage.appendDetailText("There may be some duplicate records.");
//			}
     		//print message
     		if(e.getMessage()!=null)
     		{
     			resultPage.appendDetailText(e.getMessage());
     		}
     		else
     		{
     			resultPage.appendDetailText(ConfigHelper.getAttribute("ui.error.detail.noExceptionMessage"));
     		}
     		e.printStackTrace();
     	}
       	//popup dialog
 		MessageDialog.openError(null, "", 
 				ConfigHelper.getAttribute("ui.error.archive.archive.fail"));
	}

    private String doCreate(DBConnectionInfo info, List tableColumnInfoList) throws TableAlreadyExistException, NotSpecifiedInfoException, DBOperationException, SQLException {//work

		String usedSQL;
        if(info==null)
        {
        	throw new NotSpecifiedInfoException();
        }	
        else
        { //create table
	        usedSQL = DbControl.createTable(info, tableColumnInfoList);
	        logger.debug("generate createTable sql="+usedSQL);	      	 
         }
        return usedSQL;
	}
	
	
	private void doImport(DBConnectionInfo info, String[] datafiles, String filter, int duplicateMethodType, ArrayList successFileInfo, ArrayList failedFileInfo) 
    	throws NotSpecifiedInfoException, DBOperationException, TableNotExistsException, SQLException, IOException, IllegalPathException, DuplicateRecordException {
         
        if(info==null)
        {
        	throw new NotSpecifiedInfoException();
        }	
        else
        {
         	//begin import
         	DbControl.importToDb(info, datafiles, filter, duplicateMethodType, successFileInfo, failedFileInfo);         	
         }
		
	}
	
	private void doImport(DBConnectionInfo info, String[] datafiles, String filter, int duplicateMethodType, ArrayList successFileInfo, ArrayList failedFileInfo,String filterFileName,String contains) 
	throws NotSpecifiedInfoException, DBOperationException, TableNotExistsException, SQLException, IOException, IllegalPathException, DuplicateRecordException {
     
    if(info==null)
    {
    	throw new NotSpecifiedInfoException();
    }	
    else
    {
     	//begin import
     	DbControl.importToDb(info, datafiles, filter, duplicateMethodType, successFileInfo, failedFileInfo,filterFileName,contains);         	
     }
	
}

	/*
     * 
     * дperformFinishɡťʱִд˷
     * wizard dialog will be close, and left the main shell
     */
    public boolean performFinish() {

    	logger.debug("---[ArchivingWizard][performFinish]--");
        //redisplay the hidden shell?
        return true;
    }
}