/**
 * @author: Ann
 * used in wizard , mainly in viewHeadWizard
 * Only one file can be selected(only file dialog)
 */
package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.List;

import org.cvo.fithas.dbsupport.DBConnectionInfo;
import org.cvo.fithas.dbsupport.DbControl;
import org.cvo.fithas.exception.DBOperationException;
import org.cvo.fithas.exception.NotSpecifiedInfoException;
import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.SystemConstant;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class DBSettingPage extends MyWizardPage {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(DBSettingPage.class.getName () ) ;

	private DBConnectionInfo connInfo;

	//component in db setting part
	private Combo dbType;
	private Text server;
	private Text port; //not show on UI
	private Text username;
	private Text password;
	private Text database;
	
	//component in table setting part
	private Text tableName; //Textfield stores table name
	private Combo tableNameSelect; //used to query all tables' name, and pass selection to tableName(Text).
	private Text newTableName;
	private Button checkExistButton;
	
	//radio group
	private Button useExistingTableRadio;
	private Button createNewTableRadio;
	
	
	/**
	 * ̳иĹ캯
	 */
	protected DBSettingPage(String pageName) {
		super(pageName);
		// SET DB SETTING FIELDS VALUE
	}

	public static void main(String[] args) {
		/*
		 * DBSettingPage page = new DBSettingPage("test");
		 * page.testConnection();
		 */
	}

	/*
	 * дcreateControlڴ˷ﹹҳϵĽעⲻҪ
	 * parentֱӴԪأӦһtopCompϴ
	 */
	public void createControl(Composite parent) {
		
		// һĵײ壬ʹGridLayout
		Composite topComp = new Composite(parent, SWT.FILL);
		topComp.setLayout(new GridLayout());
		topComp.setBounds(20, 20, 380, 300);

		try {
			// ---database setting group-----	
			final Group dbSettingComp = new Group(topComp, SWT.FILL);
			dbSettingComp.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.title"));
			dbSettingComp.setLayoutData(new GridData(450, 150));
			dbSettingComp.setBounds(50, 30, 380, 150);

			// ---new table setting group-----
			final Group tableSettingComp = new Group(topComp, SWT.FILL);
			tableSettingComp.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.tablegroup.title"));
			tableSettingComp.setLayoutData(new GridData(450, 92));
			tableSettingComp.setBounds(50, 180, 380, 60);
			
			// text fields, NEED "final Text/Lable" here?
			createDBFields(dbSettingComp); // param: parent Composite
			createTableFields(tableSettingComp);
			
			//set init values
			initFields();			

			// ---ÿҳʾϢ---
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.title"));
			String msg = ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.message");
			if(msg!=null && !msg.equals(""))
			{
				setMessage(msg, INFORMATION);
			}
			
		} catch (IOException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		
		// Ҫһ
		this.setControl(topComp);

	}

	/**
	 * Զ巽ݱ仯ʱݵĺϷ
	 */
	private void dataChanged() {
		try{
			if (server.getText().length() == 0) {
				setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.noserver")); // ʾϢ
				setPageComplete(false);	// ʹɡ͡һť
				return;
			}
			if(database.getText().length()==0)
			{
				setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.nodatabase")); // ʾϢ
				setPageComplete(false);	// ʹɡ͡һť
				return;
			}
			if(isUseExistTable())//the method is to judge whether "use existing table" radio is selected
			{
				logger.debug("use existing table => check tableName");
				if(tableName.getText().length()==0)
				{
					setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.notable")); // ʾϢ
					setPageComplete(false);	// ʹɡ͡һť
					return;
				}	
			}
			else
			{
				logger.debug("create a new table => check newTableName");
				if(newTableName.getText().length()==0)
				{
					setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.notable")); // ʾϢ
					setPageComplete(false);	// ʹɡ͡һť
					return;
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		setErrorMessage(null);	// Իϵĳʾ
		setPageComplete(true);	// ʹɡ͡һť
	}

	
	/**
	 * testӰťʱ뱾Ƿ
	 * */
	private boolean checkDbValid() throws IOException {
		if (server.getText().length() == 0) {
			setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.noserver")); // ʾϢ
			setPageComplete(false);	// ʹɡ͡һť
			return false;
		}
		if(database.getText().length()==0)
		{
			setErrorMessage(ConfigHelper.getAttribute("ui.warning.input.dbsetting.nodatabase")); // ʾϢ
			setPageComplete(false);	// ʹɡ͡һť
			return false;
		}
		return true;
	}
	
	
	/**
	 * Read info from .xml file.
	 * Be called on construction.
	 * Read all out as a list. 
	 * Use only the first? or the last? or the best? or All of them?
	 * @throws IOException 
	 * */
//	private void initFields() {
//
//		List connInfos = XmlHelper.MyXMLReader(getConfFilePath());
//		DBConnectionInfo info = null;
//		for (Iterator it = connInfos.iterator(); it.hasNext();) {
//			info = (DBConnectionInfo) it.next();
//			info.print(); // for debug
//
//			// set fields value (components in UI)
//			server.setText(info.getServer());
//			port.setText(info.getPort());
//			database.setText(info.getDatabase());
//			username.setText(info.getUserName());
//			password.setText(info.getPassword());
//			table.setText(info.getTableName());
//
//			saveInConnInfo(); // save init values in conninfo
//			// for test, only use the first
//			break;
//		}
//	}

	
	private void initFields() throws IOException {
		//init connection info using default (from properties file, MYSQL)
		connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_MYSQL);
		dbType.select(SystemConstant.DB_TYPE_MYSQL);
		setInFields(connInfo); // save init values in conninfo
		useExistTable(true);
	}
	
	private void setFields(int index) throws IOException
	{
		if(index==0)
		{
			connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_MYSQL);
			
		}
		else if(index==1)
		{
			connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_ORACLE);
		}
		else if(index==2)
		{
			connInfo = new DBConnectionInfo(SystemConstant.DB_TYPE_SQLSERVER);
		}
		setInFields(connInfo);
	}

	private void setInFields(DBConnectionInfo info) {
		// set fields value (components in UI)
		logger.debug("dbType is:"+SystemConstant.DB_TYPE_MYSQL);
		//dbType.select(SystemConstant.DB_TYPE_MYSQL); //select the option with index: DB_TYPE_MYSQL(1)
		server.setText(info.getServer());
		port.setText(info.getPort());
		database.setText(info.getDatabase());
		username.setText(info.getUserName());
		password.setText(info.getPassword());
		tableName.setText(info.getTableName());
	}

	public void saveInConnInfo() throws IOException {
		// TODO Auto-generated method stub
		logger.debug("--[fileimport.DBSettingPage][saveInConnInfo]---");
		int type = dbType.getSelectionIndex();;
		

		connInfo = new DBConnectionInfo(type,
					server.getText(),	
					username.getText(),
					password.getText());
		connInfo.setDatabase(database.getText());
		connInfo.setPort(port.getText());
		if(useExistingTableRadio.getSelection())
		{
			connInfo.setTableName(tableName.getText());			
		}
		else
		{
			connInfo.setTableName(newTableName.getText());
		}
	}

	/** 
	 * EXCLUDES TABLE FIELD 
	 * @throws IOException 
	 *  */
	private void createDBFields(Composite parent) throws IOException {

		final Label databaseTypeLabel = new Label(parent, SWT.NONE);
		databaseTypeLabel.setAlignment(SWT.RIGHT);
		databaseTypeLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.dbtype"));
		databaseTypeLabel.setBounds(34, 21, 104, 16);

		dbType = new Combo(parent, SWT.READ_ONLY);
		dbType.add("MySQL");//to display
		dbType.setData("0", new Integer(SystemConstant.DB_TYPE_MYSQL)); //the String "0" is the key of the MySQL's id(0) 
		dbType.add(SystemConstant.UI_DB_TYPE_NAME_ORACLE);//db type "MySQL" to show in UI selection
		dbType.setData("1", new Integer(SystemConstant.DB_TYPE_ORACLE));
		dbType.add(SystemConstant.UI_DB_TYPE_NAME_SQLSERVER);//db type "MySQL" to show in UI selection
		dbType.setData("2", new Integer(SystemConstant.DB_TYPE_SQLSERVER));
		dbType.setBounds(155, 19, 149, 21);
		
		
		dbType.addSelectionListener(new SelectionAdapter(){
		      public void widgetSelected(SelectionEvent e) {
		    	  try
		    	  {
		    	  setFields(dbType.getSelectionIndex());
		    	  }catch(IOException exe)
		    	  {
		    		  exe.printStackTrace();
		    	  }
		      }
		    });
		
		server = new Text(parent, SWT.BORDER);
		server.setBounds(156, 44, 148, 20);
        server.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged();//ֵĺϷж
            }
        });
        
		Label serverLabel = new Label(parent, SWT.NONE);
		serverLabel.setAlignment(SWT.RIGHT);
		serverLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.server"));
		serverLabel.setBounds(70, 47, 68, 20);

		port = new Text(parent, SWT.BORDER);
		
		port.setBounds(156, 67, 148, 20);
        port.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged();//ֵĺϷж
            }
        });
        
		Label portLabel = new Label(parent, SWT.NONE);
		portLabel.setAlignment(SWT.RIGHT);
		portLabel.setText("port");
		portLabel.setBounds(70, 67, 68, 20);

		Label usernameLabel = new Label(parent, SWT.NONE);
		usernameLabel.setAlignment(SWT.RIGHT);
		usernameLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.username"));
		usernameLabel.setBounds(70, 87, 68, 20);

		username = new Text(parent, SWT.BORDER);
		username.setBounds(156, 87, 148, 20);
        username.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged();//ֵĺϷж
            }
        });
        
		Label passwordLabel = new Label(parent, SWT.NONE);
		passwordLabel.setAlignment(SWT.RIGHT);
		passwordLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.password"));
		passwordLabel.setBounds(70, 107, 68, 20);

		password = new Text(parent, SWT.BORDER | SWT.PASSWORD);
		password.setBounds(156, 107, 148, 20);
        password.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged();//ֵĺϷж
            }
        });
        
		Label databaseLabel = new Label(parent, SWT.NONE);
		databaseLabel.setAlignment(SWT.RIGHT);
		databaseLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.database"));
		databaseLabel.setBounds(60, 127, 78, 20);

		database = new Text(parent, SWT.BORDER);
		database.setBounds(156, 127, 148, 21);
        database.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged();//ֵĺϷж
            }
        });
        
		final Button testConnectionButton = new Button(parent, SWT.NONE);
		testConnectionButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				try {
					testConnection();
				} catch (IOException e1) {
					e1.printStackTrace();
					MessageDialog.openError(null, "", 
							"IOException occured.");
				}
			}
		});
		testConnectionButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.dbgroup.testConnButton"));
		testConnectionButton.setBounds(323, 120, 120, 23);
		
	}
	

	private void createTableFields(Composite parent) throws IOException {

		//Radio button : use existing table OR create new ?
		useExistingTableRadio = new Button(parent, SWT.RADIO);
		useExistingTableRadio.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.tablegroup.existtable"));
		useExistingTableRadio.setBounds(5, 16, 165, 30);
		useExistingTableRadio.addSelectionListener(new SelectionAdapter() {
        	public void widgetSelected(final SelectionEvent e) {
        		useExistTable(true); //when clicked, enable use existing table group and disable the other
        		dataChanged();
        	}
        });

		createNewTableRadio = new Button(parent, SWT.RADIO);
		createNewTableRadio.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.tablegroup.newtable"));
		createNewTableRadio.setBounds(5, 43, 136, 30);
		createNewTableRadio.addSelectionListener(new SelectionAdapter() {
        	public void widgetSelected(final SelectionEvent e) {
        		useExistTable(false); //when clicked, enable create new table group and disable the other
        		dataChanged();
        	}
        });

		
		//Group 1 : text area at "create new table" area
		newTableName = new Text(parent, SWT.BORDER);
		newTableName.setBounds(175, 49,148, 19);
		newTableName.addModifyListener(new ModifyListener(){
			public void modifyText(ModifyEvent arg0) {
				dataChanged();//ʾݼΪҪıκθĶĻûֹ¼룩Ӧֵļ
			}
		});
		
        //click to check name availability
		checkExistButton = new Button(parent, SWT.NONE);
		checkExistButton.setBounds(325, 47,120, 23);
		checkExistButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.dbsetting.tablegroup.tableNameCheck"));
		checkExistButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				try {
					checkTableExist();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		});
		
		//Group 2 : The Text to show selection result
		tableName = new Text(parent, SWT.READ_ONLY);
		tableName.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		tableName.setBounds(325, 23, 117, 20);
		tableName.addModifyListener(new ModifyListener(){
			public void modifyText(ModifyEvent arg0) {
				dataChanged();//ʾݼΪҪıκθĶĻûֹ¼룩Ӧֵļ
			}
		});
		
		//the combo
		tableNameSelect = new Combo(parent, SWT.READ_ONLY);
		tableNameSelect.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_INFO_FOREGROUND));
		tableNameSelect.setBounds(175, 22, 139, 21);
		
		tableNameSelect.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent arg0) {
				tableNameSelect.removeAll(); //clear all lines first
				try {
					List tables = DbControl.getTables(getConnInfo());
					logger.debug("--tables size:"+tables.size());
					for(Iterator it = tables.iterator(); it.hasNext();)
					{
						String aName = (String) it.next();
						tableNameSelect.add(aName);
//						tableNameSelect.setData(aName,aName);//?
					}
//					saveInConnInfo();
				} catch (Exception e) {
					tableNameSelect.removeAll(); //clear the list, so that to force user to try again
					System.err.println("--[DBSettingPage][]--Exception occured:"+e.getMessage());
				}
			}

			public void focusLost(FocusEvent arg0) {
				//do nothing	
			}
			
		});
		
        tableNameSelect.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged();//ֵĺϷж
            }
        });
        
        tableNameSelect.addSelectionListener(new SelectionAdapter()  {
        	public void widgetSelected(SelectionEvent e)
        	{
        		logger.debug("--[fileimport.DBSetting][createTableFields]--listener: Select:"+ tableNameSelect.getText());
        		logger.debug(">>and tableNameSelect.getSelectionIndex()="+tableNameSelect.getSelectionIndex()+", tableNameSelect.getText()="+tableNameSelect.getText());
        		tableName.setText(tableNameSelect.getText());
//        		dataChanged();//ֵĺϷж
        	}
        });


 	}

	
	/** change status of the "table setting" fields.
	 * @param useExistTable 
	 * 		boolean -- True : enable "use Existing table" and disable "create new table" group
	 * 				-- False: other wise
	 * */
    private void useExistTable(boolean useExistTable)
    {
    	//radio buttons
    	useExistingTableRadio.setSelection(useExistTable);
        createNewTableRadio.setSelection(!useExistTable);
        //use existing table group 
        tableName.setEnabled(useExistTable);
        tableNameSelect.setEnabled(useExistTable);
        //disable dir components
        newTableName.setEnabled(!useExistTable);
        checkExistButton.setEnabled(!useExistTable);
    }
    
    
	/**
	 * Action on click "test connection" button.
	 * Test connection to the database with the information set by user
	 * @throws IOException 
	 * */
	public void testConnection() throws IOException {
		//1st, get input info
		saveInConnInfo();
		if(!checkDbValid())
		{
			logger.debug("-------[DBSettingPage][on testConnectionButton] Please check your input-------------");
			MessageDialog.openWarning(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.invalidInput"));
			return;
		}
		
		
		//2nd, test connection and show result(prompt dialog)
		logger.debug("---------[DBSettingPage][on testConnectionButton] testing... -----------");
		boolean isOk;
		try {
			isOk = DbControl.testConnection(connInfo); //test connection to the database
			if (isOk) {
				logger.debug("-------[DBSettingPage][on testConnectionButton] test success-------------");
				MessageDialog.openInformation(null, "", ConfigHelper.getAttribute("ui.info.db.testconnect.ok"));
			}
			else{
				logger.debug("-------[DBSettingPage][on testConnectionButton] test failed-------------");
				MessageDialog.openError(null, "", 
						ConfigHelper.getAttribute("ui.error.db.testconnect.fail"));
			}
		} catch (NotSpecifiedInfoException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.fail")+"\n"
					+ConfigHelper.getAttribute("ui.error.db.noConnInfo"));//no message?
		} catch (DBOperationException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.fail")
					+"\nThe exception:"+e.getMessage());
		} catch (SQLException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.testconnect.fail")
					+"\nThe exception:"+e.getMessage());
		}

	}
	
	/**
	 * Check whether the new table name has been used.
	 * Take action when "check table existence" button is pushed.
	 * @return boolean
	 * 			true -- if the name has been used (which means the user should change another name)
	 * 			false -- other wise
	 * @throws IOException 
	 * 		*/
	private void checkTableExist() throws IOException {
		//1st, get input info
		saveInConnInfo();
		if(this.newTableName==null || this.newTableName.getText()==null || this.newTableName.getText().length()==0)
		{
			logger.debug("-------[DBSettingPage][on checkTableExist] table name is null------------");
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.tableexits.noname"));
			return;
		}
		
		//2nd, test connection and show result(prompt dialog)
		logger.debug("---------[DBSettingPage][on checkTableExist] testing... -----------");
		boolean exists;
		try {
			exists = DbControl.checkTableExists(connInfo); //test connection to the database
			if (exists) {
				logger.debug("-------[DBSettingPage][on checkTableExist] The table already exists-------------");
				MessageDialog.openWarning(null, "", 
						ConfigHelper.getAttribute("ui.error.db.tableexits.exists"));
			}
			else{
				logger.debug("-------[DBSettingPage][on checkTableExist] The table name hasn't been used.------");
				MessageDialog.openInformation(null, "", 
						ConfigHelper.getAttribute("ui.info.db.tableexits.available"));
			}
		} catch (NotSpecifiedInfoException e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.noConnInfo"));
		} catch (Exception e) {
			e.printStackTrace();
			MessageDialog.openError(null, "", 
					ConfigHelper.getAttribute("ui.error.db.tableexits.exception.others")
					+"\n"+e.getMessage());
		} 

	}
	
	
	/*
	 * --------Ӧset/get ---------------
	 */
	public DBConnectionInfo getConnInfo() throws IOException {
		saveInConnInfo();
		return connInfo;
	}

	public void setConnInfo(DBConnectionInfo connInfo) {
		this.connInfo = connInfo;
	}

	/**
	 * @return Returns the database.
	 */
	public String getDatabase() {
		this.connInfo.setDatabase(database.getText());// save a copy
		return database.getText();
	}

	/**
	 * @param database
	 *            The database to set.
	 */
	public void setDatabase(String database) {
		this.database.setText(database); // optional?
		this.connInfo.setDatabase(database);
	}

	/**
	 * @return Returns the password.
	 */
	public String getPassword() {
		this.connInfo.setPassword(password.getText());// save a copy
		return password.getText();
	}

	/**
	 * @param password
	 *            The password to set.
	 */
	public void setPassword(String password) {
		this.password.setText(password);
		this.connInfo.setPassword(password);
	}

	/**
	 * @return Returns the port.
	 */
	public String getPort() {
		this.connInfo.setPort(port.getText());// save a copy
		return port.getText();
	}

	/**
	 * @param port
	 *            The port to set.
	 */
	public void setPort(String port) {
		this.port.setText(port);
		this.connInfo.setPort(port);
	}

	/**
	 * @return Returns the server.
	 */
	public String getServer() {
		this.connInfo.setServer(server.getText());// save a copy
		return server.getText();
	}

	/**
	 * @param server
	 *            The server to set.
	 */
	public void setServer(String server) {
		this.server.setText(server);
		this.connInfo.setServer(server);
	}

	/**
	 * @return Returns the username.
	 */
	public String getUsername() {
		this.connInfo.setUserName(username.getText());// save a copy
		return username.getText();
	}

	/**
	 * @param username
	 *            The username to set.
	 */
	public void setUsername(String username) {
		this.username.setText(username);
		this.connInfo.setUserName(username);
	}
	
	
	public boolean isUseExistTable() {
		return useExistingTableRadio.getSelection();
	}
	
	public void setUseExistTable(boolean useExistTable) {
		useExistingTableRadio.setSelection(useExistTable);
		createNewTableRadio.setSelection(!useExistTable);
	}
	
}