/**
 * @author: Ann
 * used in wizard , mainly in CreateTableWizard and ArchivingWizard
 * more files can be selected(file dialog and dir dialog)
 * CreateTableWizard MAY NEED TO CHOOSE INTERSET OR UNION? USE ANOTHER PAGE?
 */
package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.PathConfHelper;
import org.cvo.fithas.util.SystemConstant;
import org.cvo.fithas.util.Utils;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;

public class FileSelectPage extends MyWizardPage {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(FileSelectPage.class.getName () ) ;
	
	//Text field
    private Text dirText;
    private Text fileText;//file(s) path String
    
    //array of the files path. For showing & recording file selection
    private String[] fileNamesArray; 
    
    //value of text field (String)
    private String fileTextValue = ""; //concatenated String of file paths, seperated by SystemConstant.UI_FILE_SEPERATOR (",")
    private String dirTextValue = ""; //String of dir
    
    //radio buttons
    private Button Radio_file;
    private Button Radio_dir;
    
    //browse buttons, controlled by radio selection
    private Button btnBrowseFile;
    private Button btnBrowseDir;
    
    /**
     * ̳иĹ캯
     */
    protected FileSelectPage(String pageName) {
        super(pageName);
    }

    /*
     * дcreateControlڴ˷ﹹҳϵĽעⲻҪ
     * parentֱӴԪأӦһtopCompϴ
     */
    public void createControl(Composite parent) {
    	
        //һĵײ壬ʹGridLayout
        Composite topComp = new Composite(parent, SWT.NULL);
        topComp.setLayout(new GridLayout());
        topComp.setBounds(20,20,380,220);
        
        try {
	        //--------------file --------------------
	        Group fileGroup = new Group(topComp, SWT.NULL);
	        fileGroup.setLayoutData(new GridData(SWT.DEFAULT, 111));
	        fileGroup.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.fileGroup.label"));
	        fileGroup.setBounds(50,30,380, 60);
	         
	        /*------------ file part -------------------*/
	        //redio
	        Radio_file = new Button(fileGroup, SWT.RADIO);
	        Radio_file.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.files.label"));
	        Radio_file.setBounds(10, 36, 82, 30);
	        Radio_file.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		enableFileMethod(true); //when clicked, enable file group and disable dir group 
	        		dataChanged();
	        	}
	        });
	
	        // filepath text
	        fileText = new Text(fileGroup, SWT.BORDER);
	        fileText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
	        fileText.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
	        fileText.setBounds(98, 37, 288, 25); //textλ
	        fileText.setText(fileTextValue == null ? "" : fileTextValue);//ֵ
	        fileText.addModifyListener(new ModifyListener() {
	            public void modifyText(ModifyEvent e) {
	                dataChanged(); //ֵĺϷж
	            }
	        });
	        
	        // file browser button
	        btnBrowseFile = new Button(fileGroup, SWT.NONE);
	        btnBrowseFile.setBounds(392, 34, 80, 30); //ðťλ
	        btnBrowseFile.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.files.browse"));//ðťϵ
	        // action on click: open file choose dialog
	        btnBrowseFile.addSelectionListener(new SelectionAdapter() { 
	              public void widgetSelected(SelectionEvent e) {
	                   FileDialog dlg = new FileDialog(getShell(), SWT.OPEN | SWT.MULTI); // -support multiple selection
	                   //öԻĳʼ·
		   				String dataBasePath = "";
						try {
							dataBasePath = PathConfHelper.getAttribute(SystemConstant.CONFIG_PATH_PROPFILE_KEY_BASEDIR);
						} catch (IOException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
		   				logger.debug("===basepath:"+dataBasePath+"=====");
		   				dlg.setFilterPath(dataBasePath); //óʼ·
		   				//ļ͹
					    dlg.setFilterNames(new String[] { "Fits file (*.fit;*.fits)", "gzip Fits file(*.fit.gz;*.fits.gz)" });
					    dlg.setFilterExtensions(new String[] { "*.fit;*.fits", "*.fit.gz;*.fits.gz" });//multi types seperated by ";"
				   
					    String lastSelectedFile = dlg.open(); //return the last selected file's full path
					    if(lastSelectedFile!=null)//Ի򷵻ĳǿֵfileTextʾ
					    {
					       fileNamesArray = dlg.getFileNames(); //ѡļļ· 
					       //ѡļֻͬһĿ¼£ǹͬ·Դ"lastSelectedFile"ȫ·нȡ
					       String commonPath = Utils.getFilePathPart(lastSelectedFile);
					       fileNamesArray = Utils.appendCommonStringToAll(fileNamesArray, commonPath , true); //ǰbasedirתΪȫ·
					       fileText.setText(Utils.concatString(fileNamesArray));//set return value to text beside
					    }
	              }
	
	        	});
	
	        
	        /*------------ dir part -------------------*/
	        //radio button of dir 
	        Radio_dir = new Button(fileGroup, SWT.RADIO);
	        Radio_dir.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.dir.label"));
	        Radio_dir.setBounds(10, 67, 82, 30);
	        Radio_dir.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		enableFileMethod(false); //when clicked, enable dir group and disable file group 
	        		dataChanged();
	        	}
	        });
	
	        //dir textField
	        dirText = new Text(fileGroup, SWT.BORDER);
	        dirText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
	        dirText.setBounds(98, 68, 288, 30);
	        dirText.addModifyListener(new ModifyListener() {
	            public void modifyText(ModifyEvent e) {
	                dataChanged(); //ֵĺϷж
	            }
	        });
	        
	        //dir browse button
	        btnBrowseDir = new Button(fileGroup, SWT.NONE);
	        btnBrowseDir.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.dir.browse"));
	        btnBrowseDir.setBounds(392, 68, 80,30);
	        btnBrowseDir.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		DirectoryDialog dlg = new DirectoryDialog(getShell());
//	                dlg.setText("directory"); //ôڱ
//	                dlg.setMessage("Please select a directory"); //ʾ
	                //öԻĳʼ·
					String dataBasePath = "";
					try {
						dataBasePath = PathConfHelper.getAttribute(SystemConstant.CONFIG_PATH_PROPFILE_KEY_BASEDIR);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					logger.debug("===basepath:"+dataBasePath+"=====");
					dlg.setFilterPath(dataBasePath); //óʼ·
					//򿪶Ի򲢷һѡĿ¼·ַ
	                String dir = dlg.open(); 
	                if(dir!=null)
	                {
	                	dirText.setText(dir); //Ի򷵻ĳǿֵdirTextʾ
	                }
	        	}
	        });
	      
	        //init radio selection status
	        initStatus(); //enable file method
	        
	        //---ÿҳʾϢ---
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.title"));
	        setMessage(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.fileselect.message"),
	        		INFORMATION);
	        
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

        //Ҫһ
        this.setControl(topComp);
       
        
    }


    private void initStatus() {
    	enableFileMethod(true);
        
        //ʼʱ"next""finish"
        setPageComplete(false);
	}

    private void enableFileMethod(boolean enableFile)
    {
    	//radio buttons
        Radio_file.setSelection(enableFile);
        Radio_dir.setSelection(!enableFile);
        //enable file components 
        fileText.setEnabled(enableFile);
        btnBrowseFile.setEnabled(enableFile);
        //disable dir components
        dirText.setEnabled(!enableFile);
        btnBrowseDir.setEnabled(!enableFile);
        if(enableFile)
        {
            fileText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_INFO_BACKGROUND));//ı(Ϊɫ)
            dirText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));//Ϊɫ
        }
        else
        {
            fileText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));//ļû
            dirText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_INFO_BACKGROUND));//Ŀ¼Ϊɫ
        }
    }
    


	
	/**
     * Զ巽ݱ仯ʱݵĺϷ
     */
    private void dataChanged() {
    	int fileMethod = getRadioSelection(); //judge method: file/dir
    	if(fileMethod==SystemConstant.UI_FILE_METHOD_DIR) //choose dir
    	{
	        if (dirText.getText().length() == 0) {
	        	setErrorMessage("Please select directory to import!"); //ʾϢ
	            setPageComplete(false); //ʹɡ͡һť
	            return;
	        }
    	}
    	else //choose multi files
    	{
    		if (fileText.getText().length() == 0) {
                setErrorMessage("Please select file(s) to import!"); //ʾϢ
                setPageComplete(false); //ʹɡ͡һť
                return;
            }
    	}
        setErrorMessage(null); //Իϵĳʾ
        setPageComplete(true); //ʹɡ͡һť
    }



    /*
     * --------Ӧset/get ---------------
     */

	/**
	 * @return Returns the fileText's value.
	 */
	public String getFile() {
		fileTextValue = fileText.getText();
		return fileTextValue;
	}

	public void setFile(String string) {
		this.fileTextValue = string;
	}
	
	/**
	 * @return Returns the dirText's value.
	 */
	public String getDir() {
		dirTextValue = dirText.getText();
		return dirTextValue;
	}

	public void setDir(String string) {
		this.dirTextValue = string;
	}
	
	
	public int getRadioSelection()
	{
		if(Radio_file.getSelection())
			return SystemConstant.UI_FILE_METHOD_FILE;
		else 
			return SystemConstant.UI_FILE_METHOD_DIR;
	}
	
	/**
	 * Judge whether method of "dir" is selected. 
	 * Used to further get data functions (to call getFile() or getDir()).
	 * */
	public boolean isDirSelected()
	{
		if(Radio_dir.getSelection())
			return true;
		else
			return false;
	}
	
	
	public String[] getDataPathsArray()
	{
		if(isDirSelected())
		{
			
			String[] filesSelectArray = {getDir()};
			logger.debug("Selected dir:"+filesSelectArray[0]);
			return filesSelectArray;
		}
		else
		{
			logger.debug("Selected file---"+fileNamesArray.length+" files.");
			return fileNamesArray;
		}
	}

}