/**
 * @author: Ann
 * used in wizard , mainly in viewHeadWizard
 * Only one file can be selected(only file dialog)
 */
package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.PathConfHelper;
import org.cvo.fithas.util.SystemConstant;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;

public class SingleFileSelectPage extends MyWizardPage {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(SingleFileSelectPage.class.getName () ) ;
	
    private Text fileText;//file(s) path String

    private String fileTextValue;

    /**
     * ̳иĹ캯
     */
    protected SingleFileSelectPage(String pageName) {
        super(pageName);
    }

    /*
     * дcreateControlڴ˷ﹹҳϵĽעⲻҪ
     * parentֱӴԪأӦһtopCompϴ
     */
    public void createControl(Composite parent) {
    	
        //һĵײ壬ʹGridLayout
        Composite topComp = new Composite(parent, SWT.NULL);
        topComp.setLayout(new GridLayout());
        
        //---file group-----
        final Group fileGroup = new Group(topComp, SWT.NULL);
        // filepath text
        fileText = new Text(fileGroup, SWT.BORDER);
        fileText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));//ɫ
        fileText.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
        fileText.setBounds(50, 51, 300, 25); //textλ
        fileText.setText(fileTextValue == null ? "" : fileTextValue);//ֵ
        fileText.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                dataChanged(); //ֵĺϷж
            }
        });
        
        // file browser button
        final Button btnBrowseFile = new Button(fileGroup, SWT.NONE);
        btnBrowseFile.setBounds(350, 51, 100, 25); //ðťλ
        try {
        	//ðťϵ
			btnBrowseFile.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.fileselect.browse"));
			 // action on click: open file choose dialog
	        btnBrowseFile.addSelectionListener(new SelectionAdapter() { 
	              public void widgetSelected(SelectionEvent e) {
	                   FileDialog dlg = new FileDialog(getShell(), SWT.OPEN);
	                   String dataBasePath = "";  //Իĳʼ·
					try {
						//ļлȡԻĳʼ·
						dataBasePath = PathConfHelper.getAttribute(SystemConstant.CONFIG_PATH_PROPFILE_KEY_BASEDIR);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
	   					logger.debug("===basepath:"+dataBasePath+"=====");
	   					dlg.setFilterPath(dataBasePath); //óʼ·
	   					//ļ
	 			       dlg.setFilterNames(new String[] { "Fits file (*.fit;*.fits)", "gzip Fits file(*.fit.gz;*.fits.gz)" });
				       dlg.setFilterExtensions(new String[] { "*.fit;*.fits", "*.fit.gz;*.fits.gz" });//multi types seperated by ";"
				       //򿪶Ի򣬲ѡļȫ·
				       fileTextValue = dlg.open(); 
				       if(fileTextValue!=null);//set return value to text beside)
				       {
				    	   fileText.setText(fileTextValue);//set return value to text beside
				       }
	               }
	          });

	        //ҳʾϢ
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.fileselect.title"));
			String msg = ConfigHelper.getAttribute("ui.msg.wizard.archive.fileselect.message");
			if(msg!=null && !msg.equals(""))
			{
				setMessage(msg, INFORMATION);
			}
	        
	        //ʼʱ"next""finish"
	        setPageComplete(false);
	        
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

        //Ҫһ
        this.setControl(topComp);
    }


    /**
     * Զ巽ݱ仯ʱݵĺϷ
     */
    private void dataChanged() {
        if (fileText==null || fileText.getText().length() == 0) {
            setErrorMessage("Please select a file"); //ʾϢ
            setPageComplete(false); //ʹɡ͡һť
            return;
        }
        setErrorMessage(null); //Իϵĳʾ
        setPageComplete(true); //ʹɡ͡һť
    }



    /*
     * --------Ӧset/get ---------------
     */

    /**
     * The FileText may be the full path of the file selected(browse button)
     * */
	public String getFileText() {
		fileTextValue = fileText.getText();
		return fileTextValue;
	}

	public void setFileText(String string) {
		this.fileTextValue = string;
	}


}