package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.TableLayout;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;


public class TableFieldViewPage extends MyWizardPage {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(TableFieldViewPage.class.getName () ) ;
	
    private TableViewer tv; //һ
    private String[] fileNames;
    private Hashtable columnTable;
    private List columns;
    
    
    protected TableFieldViewPage(String pageName) {
        super(pageName);
    }

    public void createControl(Composite parent) {
    	
        //һĵײ壬ʹGridLayout
        Composite topComp = new Composite(parent, SWT.FILL);
        RowLayout rowLayout = new RowLayout(SWT.VERTICAL);
        rowLayout.spacing = 4;//֮ļΪ3
        rowLayout.fill = true;
        rowLayout.marginRight = 5;
        rowLayout.pack = true;
        rowLayout.justify = true;
        topComp.setLayout(rowLayout);

        /*
         * 
         */
        try {
			createTableViewer(topComp);
			
			tv.setContentProvider(new TableViewerContentProvider());
			tv.setLabelProvider(new TableViewerLabelProvider());
        
			//add listener, deal with check actions
			addListener(); 
        
			//ÿҳʾϢ֮ǰû"ѡtable""½table"ѡͬϢãwizard
			
        } catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        //Ҫһ
        this.setControl(topComp);
        
    }

    /** set given values into a table*/
	public void setTableValues(List columnsList) {
		tv.setInput(columnsList); //static values to test
//		ctv.setAllChecked(true);
		logger.debug("--[FieldSelectPage][setTableValues] -- set input");
	}
	
 
    /**
     * 
     * @throws IOException 
     */
    private void createTableViewer(Composite parent) throws IOException {
        /*
         * һһTableViewerʽMULTIɶѡH_SCROLLˮƽ
         * V_SCROLLдֱBORDERб߿FULL_SELECTIONѡ
         */
        tv = new TableViewer(parent, SWT.BORDER | SWT.FULL_SELECTION | SWT.V_SCROLL);
        
        /*
         * ڶͨTableViewerеTable䲼
         */
        Table table = tv.getTable();
        table.setCapture(true);
        final RowData rowData = new RowData();
        rowData.width = 450;
        rowData.height = 240;       
        table.setLayoutData(rowData);
        
        table.setHeaderVisible(true); //ʾͷ
        table.setLinesVisible(true); //ʾ
        TableLayout tLayout = new TableLayout(); //רڱĲ
        table.setLayout(tLayout);
        
        /*
         * TableViewerе
         */
        tLayout.addColumnData(new ColumnWeightData(100));//IDепΪ10
        TableColumn col1 = new TableColumn(table, SWT.NONE);
        col1.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.tv.columntitle.column"));
        //еѡ¼
     /*   col1.addSelectionListener(new SelectionAdapter() {
            boolean sortType = true; //sortType¼һεʽĬΪ

            public void widgetSelected(SelectionEvent e) {
                //ȡһʽҪһε෴
                sortType = !sortType;
                //sortTypeΪidSorter0򣩡idSorter1
                tv.setSorter(sortType ? idSorter0 : idSorter1);
            }
        });
        */
        
        //type , editable
        tLayout.addColumnData(new ColumnWeightData(100));
        TableColumn col2 = new TableColumn(table, SWT.NONE);
        col2.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.tv.columntitle.type"));
    /*    col2.addSelectionListener(new SelectionAdapter() {
            boolean sortType = true;

            public void widgetSelected(SelectionEvent e) {
                sortType = !sortType;
                tv.setSorter(sortType ? nameSorter0 : nameSorter1);
            }
        });
*/
        tLayout.addColumnData(new ColumnWeightData(80));
        new TableColumn(table, SWT.NONE)
        	.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.tv.columntitle.length"));// for varchar etc.
        
        
        //for comments column test
        tLayout.addColumnData(new ColumnWeightData(100));
        new TableColumn(table, SWT.NONE)
        	.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.tableview.tv.columntitle.comment"));// for varchar etc.

        //init data
//        this.checkObjs = new ArrayList();
        
    }
/*
	private void dataChanged() {
        if (schoolText.getText().length() == 0) {
            setErrorMessage("ѧУΪ");//ʾϢ
            setPageComplete(false);//ʹɡ͡һť
            return;
        }
        setErrorMessage(null); //Իϵĳʾ
        setPageComplete(true); //ʹɡ͡һť
    }
*/
    
    /** save selections in private variables */
  /*  public void saveSelections()
    {
    	setCheckObjs(ctv.getCheckedElements());
    }
    */
    
    /**
     * Ӽ
     */
    private void addListener() {
        /*
         * tv˫¼
         */
   /*     tv.addDoubleClickListener(new IDoubleClickListener() {
            public void doubleClick(DoubleClickEvent event) {
                IStructuredSelection selection = (IStructuredSelection) event.getSelection();
                //õ¼ʵҪת
                PeopleEntity o = (PeopleEntity) selection.getFirstElement();
                //һʾ
                MessageDialog.openInformation(null, "ʾ", o.getName());
            }
        });
  */      /*
         * tvѡ¼
         * ûctvĸѡʱ˷
         */
//        tv.addSelectionChangedListener(new ISelectionChangedListener() {
//            public void selectionChanged(SelectionChangedEvent event) {
//                //-------¼롣ʡԣ
//            	Object[] objs = ctv.getCheckedElements();
//            	checkObjs.clear();
//            	for(int i=0; i<objs.length; i++)
//            	{
//            		checkObjs.add(objs[i]);
//            	}	
//            }
//        });
    }
    
    
    public void clearTable()
    {
    	List temp = new ArrayList();
    	setTableValues(temp);
    }
    
    /*
     * --------Ӧset/get ---------------
     */

	public Hashtable getColumnTable() {
		return columnTable;
	}

	public void setColumnTable(Hashtable columnTable) {
		this.columnTable = columnTable;
	}

	/**
	 * @return Returns the fileNames.
	 */
	public String[] getFileNames() {
		return fileNames;
	}

	/**
	 * @param fileNames The fileNames to set.
	 */
	public void setFileNames(String[] fileNames) {
		this.fileNames = fileNames;
	}

	/**
	 * @return Returns the columns.
	 */
	public List getColumns() {
		return columns;
	}

	/**
	 * @param columns The columns to set.
	 */
	public void setColumns(List columns) {
		this.columns = columns;
	}

	
}