/**
 * Header Viewer page.
 * Show table of header info(2 columns), without checkbox.
 * */
package org.cvo.fithas.ui.wizard.headerviewer;

import java.io.IOException;
import java.util.Hashtable;
import java.util.List;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.TableLayout;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

	public class HeadViewPage extends MyWizardPage {

		static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(HeadViewPage.class.getName () ) ;
		
	    private TableViewer tv; //һ
//	    private CheckboxTableViewer ctv;
	    
	    
	    
	    protected HeadViewPage(String pageName) {
	        super(pageName);
	    }
	    
	    public void createControl(Composite parent) {
	    	
	        //һĵײ壬ʹGridLayout
	        Composite topComp = new Composite(parent, SWT.FILL);
	        RowLayout rowLayout = new RowLayout(SWT.VERTICAL);
	        rowLayout.spacing = 5;//֮ļΪ3
	        rowLayout.fill = true;
	        rowLayout.marginRight = 5;
	        rowLayout.pack = true;
	        rowLayout.justify = true;
	        topComp.setLayout(rowLayout);
	        
	        try {
		        // 
		        createTableViewer(topComp);
		        //ôʽݵprovider
		        tv.setContentProvider(new MyContentProvider());
		        tv.setLabelProvider(new MyLabelProvider());
		        //ҳ
				setTitle(ConfigHelper.getAttribute("ui.msg.wizard.headerview.headerview.title"));
				setMessage(ConfigHelper.getAttribute("ui.msg.wizard.headerview.headerview.message"), INFORMATION);
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	        
	        //Ҫһ
	        this.setControl(topComp);
	    
	    }
	    
	    /**
	     *  set given values (LIST of key-value pairs) into a table
	     *  */
		public void setTableValues(List valuePairsList) {
			
//			if(valuePairsList!=null&&valuePairsList.size()>0)
//			{
//				for(int i=0;i<valuePairsList.size();i++)
//				{
//					HeaderEntryBean header=(HeaderEntryBean)valuePairsList.get(i);
//					
//					tv.setData(header.getKey(), header.getValue());
//				}
//				
//			}
			
			tv.setInput(valuePairsList); //static values to test
//			 ctv.setAllChecked(true);
			logger.debug("--[HeadViewPage][setTableValues] -- set input");
		}

//	    /** 
//	     * set given values (HASHTABLE of key-value pairs) into a table
//	     * */
//		public void setTableValues(Hashtable valuePairsTable) {
//			tv.setInput(HashTable2EntryList(valuePairsTable)); //static values to test
////		    ctv.setAllChecked(true);
//			logger.debug("--[HeadViewPage][setTableValues] -- set input");
//		}
//		
//		/**
//		 * @return List of TableColumnBean(contains: columnName, type, length)
//		 * */
//	    private List HashTable2EntryList(Hashtable columnTable) {
//	    	ArrayList entryList = new ArrayList();
//	    	if(columnTable!=null)
//			{	
//	    		entryList.addAll(columnTable.entrySet());
//			}
//			return entryList;
//	    }

	
		/**
	     * 
		 * @throws IOException 
	     */
	    private void createTableViewer(Composite parent) throws IOException {
	        /*
	         * һһTableViewerʽCHECKжѡMULTIɶѡH_SCROLLˮƽ
	         * V_SCROLLдֱBORDERб߿FULL_SELECTIONѡ
	         */
	        tv = new TableViewer(parent, SWT.BORDER | SWT.FULL_SELECTION | SWT.V_SCROLL | SWT.H_SCROLL);
	        
	        /*
	         * ڶͨTableViewerеTable䲼
	         */
	        Table table = tv.getTable();
	        final RowData rowData = new RowData();
	        rowData.width = 480;
	        rowData.height = 245;
	        table.setLayoutData(rowData);
	        table.setHeaderVisible(true); //ʾͷ
	        table.setLinesVisible(true); //ʾ
	        TableLayout tLayout = new TableLayout(); //רڱĲ
	        table.setLayout(tLayout);
	        
	        /*
	         * TableViewerе
	         */
	        tLayout.addColumnData(new ColumnWeightData(45));//IDепΪ45
	        TableColumn col1 = new TableColumn(table, SWT.NONE);
	        col1.setText(ConfigHelper.getAttribute("ui.msg.wizard.headerview.headerview.tv.columntitle.column"));

	        tLayout.addColumnData(new ColumnWeightData(150));
	        TableColumn col2 = new TableColumn(table, SWT.NONE);
	        col2.setText(ConfigHelper.getAttribute("ui.msg.wizard.headerview.headerview.tv.columntitle.value"));
	        
	        
	        tLayout.addColumnData(new ColumnWeightData(150));
	        TableColumn col3 = new TableColumn(table, SWT.NONE);
	        col3.setText(ConfigHelper.getAttribute("ui.msg.wizard.headerview.headerview.tv.columntitle.comment"));
	    
	         //init data
//	        this.checkObjs = new ArrayList();
	        
	    }

	 
	}