/**
 * @authorAnn
 * Header Viewer wizard. 
 * Defines pages' sequence and initial/finish functions
 * If more header part in 1 file, a middle step should be added.
 */
package org.cvo.fithas.ui.wizard.headerviewer;

import java.util.List;

import org.cvo.fithas.fitsfile.GenericHeadAnalysis;
import org.cvo.fithas.ui.wizard.MyWizard;
import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.eclipse.jface.dialogs.MessageDialog;


public class ViewHeadWizard extends MyWizard {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ViewHeadWizard.class.getName () ) ;
	
    /*
     * FileSelectPage,FieldSelectPageҳʵʹܷʵõ
     */
    private SingleFileSelectPage fileSelectPage;//ҳһMyWizardPage
    private HeadViewPage headViewPage;//ҳMyWizardPage
    
    /**
     * дaddPagesڴ˷3ҳ벢
     */
    public void addPages() {
        //ҳ󣬲ҳ
        fileSelectPage = new SingleFileSelectPage("View File : step 1 of 2");
        headViewPage = new HeadViewPage("View File : step 2 of 2");
              
     	//WizardPage˳ڽʾ˳ͬʱ˳id
        addPage(fileSelectPage);
        addPage(headViewPage);
        
        //òpageSeq,ʹ0ʼ
        resetPageSeq();
    }

    /**
     * дcanFinishɴ˷жϡɡťʱá     * 
     * @return falseɡťãtrue෴
     */
    public boolean canFinish() {
    	
    	//ȣȡǰwizardPageȡididӵwizardʱ䣩
    	MyWizardPage curPage = (MyWizardPage) this.getContainer().getCurrentPage();
    	logger.debug("Page:"+curPage.getTitle()+" -- id="+curPage.getPageId()+", now pageSeq="+getPageSeq());
    	
    	//actions at specifiect step
    	 if (curPage == headViewPage)
    	 {
    	       	try {
    				List columns = GenericHeadAnalysis.getHeadValuesList(fileSelectPage.getFileText());//.getFilePathsValue());
    				headViewPage.setTableValues(columns); //static values to test,set analysised columns to show in table 
        	       	if(columns==null)
    				{	
    					logger.debug("--[ViewHeadWizard][canFinish] --no column--");
    				}
                        
    			} catch (Exception e) {
    				String msg = e.getMessage()==null? "IOException" : e.getMessage();
    				MessageDialog.openError(null, "Exception occured", msg);
    			}
            	logger.debug("you selected "+fileSelectPage.getFileText()+" at last page");
    	 }
    	 
    	 //굱ǰҳӦִеĲǰΪǰҳid¼״̬Ժ´ηҳȽϵóǰǺ
    	 setPageSeq(curPage.getPageId());
    	 logger.debug("after main work in canFinish(), update pageSeq to "+getPageSeq());

        //Ϊûһҳʱɡť
        if (this.getContainer().getCurrentPage() != headViewPage)
            return false;
        
        return super.canFinish();
    }
    
    

	/*
     * 
     * дperformFinishɡťʱִд˷
     * wizard dialog will be close, and left the main shell
     */
    public boolean performFinish() {
       
        //redisplay the hidden shell?
        return true;
    }
}