package org.cvo.fithas.util;

import java.io.IOException;

import org.apache.log4j.PropertyConfigurator;
import org.cvo.fithas.exception.NotSpecifiedInfoException;

public class ConfigHelper {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ConfigHelper.class.getName () ) ;
	
	private static Config config = null;
	
	
	/** HARD CODE HERE.
	 * Read config information from the properties file, named "DBSetting.properties".
	 * Singleton, only one config of DBSetting exists.
	 * @throws IOException 
	 * */
    public static Config getUIMsgConf() throws IOException{
    	if(config==null)
    	{
    		/****************************************************
    		 * for standalone jar, use "/conf/DBSetting.properties";
    		 * for program within eclipse, use "DBSetting.properties"
    		 *****************************************************/
    		config = new Config(SystemConstant.PROPFILE_MSG_UI); //the properties file name 
    	}
        return config;
    }

    /**
     * Get an attribute from the config.
     * @throws IOException 
     * */
    public static String getAttribute(String key) throws IOException
    {
    	if(config==null)
    		getUIMsgConf();
    	return config.getAttribute(key);
    }
    
    /**
     * set an attribute into the config.
     * @throws IOException 
     * */
    public static void setAttribute(String key, String value) throws IOException
    {
    	if(config==null)
    		getUIMsgConf();
    	config.setAttribute(key, value);
    }
    
    
    /**
     * ݴڴconfigдļ
     * ǰ
     * 	configѸڴ
     * @throws NotSpecifiedInfoException 
     * */
    public static void saveConfig() throws IOException, NotSpecifiedInfoException
    {
    	if(config==null)
    		getUIMsgConf();
    	//write back to file
    	config.writeConf(SystemConstant.PROPFILE_MSG_UI, "");//the properties file name
    }
    
    
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Config conf;
		try {
			PropertyConfigurator.configure(SystemConstant.PROPFILE_LOG);//ȡlog4jļ
			conf = ConfigHelper.getUIMsgConf();
			conf.print();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

	}

	

}
