/**
 * //e452. Uncompressing a File in the GZIP Format
 * */

package org.cvo.fithas.util;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.util.zip.GZIPInputStream;

import org.cvo.fithas.exception.IllegalFileException;

public class GzipHelper {

	public static InputStream readGzFile(String inFileName) throws FileNotFoundException, IOException
	{
		GZIPInputStream in = new GZIPInputStream(new FileInputStream(inFileName));
		return in;
	}
	
	
	public static void ungzip(String inFileName, String outFileName) throws FileNotFoundException, IOException, IllegalFileException
	{
		GZIPInputStream in = null;
		OutputStream out = null;
		
		System.out.println(inFileName);
		//param check
		if (!inFileName.endsWith(".gz")) 
		{         
			throw new IllegalFileException();			
		}
		
		try{
				//Open the compressed file
				in = new GZIPInputStream(new FileInputStream(inFileName));
			    // Open the output file
		        out = new FileOutputStream(outFileName);
		    
		        // Transfer bytes from the compressed file to the output file
		        byte[] buf = new byte[1024];
		        int len;
		        while ((len = in.read(buf)) > 0) {
		            out.write(buf, 0, len);
		        }
		}
		finally
		{// Close the file and stream
		   	if(in!=null)
		   		in.close();
		   	if(out!=null)
		   		out.close();
		}		
	}
	
	/**
	 * @return String - the output file's name
	 * */
	public static String ungzip(String inFileName) throws IllegalFileException, IOException
	{
		//param check
		if (!inFileName.endsWith(".gz")) 
		{         
			throw new IllegalFileException();			
		}
		
		int indexTo = inFileName.lastIndexOf('.');
		String outFileName = inFileName.substring(0, indexTo);
		ungzip(inFileName, outFileName);
		
		return outFileName;
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
	        String inFilename = "D:\\data\\samples\\fpC-005853-r1-0227.fit.gz";
//	        String outFilename = "D:\\data\\testfpc.fit";
	        try {
//				ungzip(inFilename,outFilename);
//	        	ungzip(inFilename);


	             String line = null;
	             BufferedReader br = null;
	             
	             InputStream is = readGzFile(inFilename);
	             InputStreamReader isr = new InputStreamReader(is);
	             
//	             	fr = new FileReader(f);
	             	br = new BufferedReader(isr);
                 	line = br.readLine();//һֱس
                 	System.out.println(line);
	                     	
	        	
	        	
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}


	}

}
