package org.cvo.fithas.util;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.jar.Attributes;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.Manifest;

public class JarHelper {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
//			try {

//				String userDir = System.getProperty("user.dir");//ûǰĿ¼
//				System.out.println(userDir);
//				String name = userDir+File.separator+"bin"+File.separator+"FitHAS.jar";
//				System.out.println("Jar: " + name);

				Properties prop = System.getProperties();
				prop.list(System.out);
//			      JarEntry entry = getEntry(name, "DBSetting.properties");
//			      System.out.println(entry.getName());

//			} catch (IOException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}//շjarļ
	}
	
	
	private static JarEntry getEntry(String jarFileName, String entryFileName) throws IOException {
		
		System.out.println("Jar: " + jarFileName);
		//.jar file
	    JarFile jar = new JarFile(jarFileName);
	    //Creates a new JarEntry with fields taken from the specified ZipEntry object.
	    JarEntry jarEntry = new JarEntry(jar.getEntry(entryFileName));//
	    System.out.println("size:"+jarEntry.getSize());
	    return jarEntry;
	}

	
	public static Attributes getEntryAttributes(String jarFileName, String entryFileName) throws IOException
	{
		//get an entry file from the .jar
		JarEntry jarEntry = JarHelper.getEntry(jarFileName, entryFileName);
	    //all attributes in this entry(file)
	    Attributes attr = jarEntry.getAttributes();
	    return attr;
	}
	
	
	public static void printAttr(Attributes attr)
	{	    
            // Enumerate each attribute
            for (Iterator it=attr.keySet().iterator(); it.hasNext(); )
            {
                // Get attribute name
                Attributes.Name attrName = (Attributes.Name)it.next();    
                // Get attribute value
                String attrValue = attr.getValue(attrName);
                System.out.println("\t"+attrName+"-"+attrValue);
            }

	}

	public static String getValue(String jarFileName, String entryFileName, String attriKey) throws IOException
	{
		//get an entry file from the .jar
		JarEntry jarEntry = JarHelper.getEntry(jarFileName, entryFileName);
	    //all attributes in this entry(file)
	    Attributes attr = jarEntry.getAttributes();
	    String value = attr.getValue(attriKey);
	    return value;
	}
	
	private static void getManifest(String name) throws IOException
    {
	     System.out.println("Jar: " + name);
	     JarFile jar = new JarFile(name);
	     Manifest mf = jar.getManifest();
	     System.out.println((mf==null)?"null manifest":mf.toString());
	     Attributes at = mf.getMainAttributes();
	     System.out.println(at.getValue("MIDlet-4"));
      
    }
	
	
	private static void listjar(String name) throws IOException {
		 System.out.println("Jar: " + name);
		 JarFile jar = new JarFile(name);
		 Enumeration e = jar.entries();
		 while (e.hasMoreElements()) {
		   listInfo((JarEntry)e.nextElement());
		 }
		 System.out.println();
}
	

	private static void listInfo(JarEntry entry) {
	       System.out.println("\t" + entry.getName());
	    }

	public static void listManifestEntries(String jarFileName) throws IOException
	{
	        // Open the JAR file
	        JarFile jarfile = new JarFile(jarFileName);
	    
	        // Get the manifest
	        Manifest manifest = jarfile.getManifest();
	        System.out.println(manifest.toString());
	        // Get the manifest entries
	        Map map = manifest.getEntries();
	        System.out.println("The manifest has "+map.size()+" entries");
	        // Enumerate each entry
	        for (Iterator it=map.keySet().iterator(); it.hasNext(); ) {
	            // Get entry name
	            String entryName = (String)it.next();
	    
	            // Get all attributes for the entry
	            Attributes attrs = (Attributes)map.get(entryName);
	            System.out.println("Entry: "+entryName+" has "+attrs.size()+" attributes");
	            
	            // Enumerate each attribute
	            for (Iterator it2=attrs.keySet().iterator(); it2.hasNext(); ) {
	                // Get attribute name
	                Attributes.Name attrName = (Attributes.Name)it2.next();	    
	                // Get attribute value
	                String attrValue = attrs.getValue(attrName);
	                System.out.println("\t"+attrName+"-"+attrValue);
	                
	            }
	        }

	}

}
