
package org.cvo.fithas.util;

import java.io.IOException;

import org.apache.log4j.PropertyConfigurator;

public class PathConfHelper {
    
	private static Config config = null;
	
	/** HARD CODE HERE.
	 * Read config information from the properties file, named "SystemPath.properties".
	 * Singleton, only one config of system path exists.
	 * @throws IOException 
	 * */
    public static Config getPathConf() throws IOException{
    	if(config==null)
    	{
    		/****************************************************
    		 * for standalone jar, use "/conf/SystemPath.properties";???
    		 * for program within eclipse, use "SystemPath.properties"
    		 *****************************************************/
//			config = new Config("SystemPath.properties");
    		//method 1:
//    		String url = ClassLoader.getSystemResource("").getPath();
//    		File f = new File(url+"/SystemPath.properties");
//    		logger.debug(url+", file:"+f.getPath());
//    		logger.debug(f.getPath());
//    		config = new Config(f.getPath().replace('\\','/'));
    		
    		//method 2:
//    		String url = Config.class.getResource("/").getPath();
//    		File f = new File(url);
//    		logger.debug("url="+url); //eg: /E:/projects/eclipse-3.1.2_workspace/FitHAS/bin/
//    		logger.debug("file.getPath()="+f.getPath()); //eg: E:\projects\eclipse-3.1.2_workspace\FitHAS\bin
//    		String newUrl = url + "SystemPath.properties"; 
//    		f = new File(newUrl);
//    		logger.debug("newUrl="+newUrl); //eg: /E:/projects/eclipse-3.1.2_workspace/FitHAS/bin/SystemPath.properties
//    		logger.debug("file.getPath()="+f.getPath());//e.g: E:\projects\eclipse-3.1.2_workspace\FitHAS\bin\SystemPath.properties
//    		config = new Config(f.getPath());
    		
    		//method 3:
    		config = new Config(SystemConstant.PROPFILE_CONFIG_PATH);
			    		
    	}
        return config;
    }
    

    /**
     * Get an attribute from the config.
     * @throws IOException 
     * */
    public static String getAttribute(String key) throws IOException
    {
    	if(config==null)
    		getPathConf();
    	return config.getAttribute(key);
    }
   

    /** update an item(basedir), and write back to file
     * @param value
     *			String -- here means the new "basedir" (the only value need to be set in the path config) to set 
     * @throws IOException
     */
    public static void saveAttribute(String value) throws IOException
    {
    	saveAttribute(SystemConstant.CONFIG_PATH_PROPFILE_KEY_BASEDIR, value);
    }
    
    
    /**
     * update an item, and write back to file
     * */
    public static void saveAttribute(String key, String value) throws IOException
    {
    	if(config==null)
    		getPathConf();
    	//update property item
    	config.setAttribute(key, value);
    	//write back to file, with comment
    	config.writeConf(SystemConstant.PROPFILE_CONFIG_PATH, SystemConstant.CONFIG_PATH_PROPFILE_COMMENT);
    }
    
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Config conf;
		try {
			PropertyConfigurator.configure(SystemConstant.PROPFILE_LOG);//ȡlog4jļ
			conf = PathConfHelper.getPathConf();
			conf.print();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
