package org.cvo.fithas.util;


public class SystemConstant {
	
	/************************* background image file ****************************************/
	public static final String UI_BACKGROUND_FILE = "icons/bg.jpg";

	/*********************** words and chars to create table  *************************************/
	
	//column names the specified fields ----YOU CAN USE THESE TWO IN CODE
	public static final String DB_COLUMNNAME_RECORDID_MYSQL = "record_Id";//"ID" may be used in some fits files
	public static final String DB_COLUMNNAME_RELATIVEPATH_MYSQL = "path";//relative path(contains filename)
	
	//default datatype in MySQL
	public static final String DB_DATATYPE_MYSQL_STRING = "varchar";//<=255, for 
	public static final String DB_DATATYPE_MYSQL_LONGSTRING = "text";//text:<=65535(>900 rows, enough)
	public static final String DB_DATATYPE_MYSQL_VLONGSTRING = "mediumtext";//mediumtext:>65535
	
	//datatypes for the specified fields ----YOU CAN USE THESE FOUR IN CODE
	public static final String DB_DATATYPE_MYSQL_RECORDID = "bigint";//bigint(20)
	public static final String DB_DATATYPE_MYSQL_RELATIVEPATH = DB_DATATYPE_MYSQL_LONGSTRING;//text(255)
	public static final String DB_DATATYPE_MYSQL_COMMENT = DB_DATATYPE_MYSQL_LONGSTRING;//mediumtext(65535)
	public static final String DB_DATATYPE_MYSQL_NORMAL = DB_DATATYPE_MYSQL_LONGSTRING;////20070503 modified. use text.
		
	//default column length
	public static final int DB_COLUMNLENGTH_BIGINT = 20;
	public static final int DB_COLUMNLENGTH_VARCHAR_SHORT = 80;
	public static final int DB_COLUMNLENGTH_VARCHAR_LONG = 255;//max length of type "varchar"
	public static final int DB_COLUMNLENGTH_TEXT_SHORT = 255;//length of type "text"/tinytext
	public static final int DB_COLUMNLENGTH_TEXT_LONG = 65535;//max length of type "text"
	public static final int DB_COLUMNLENGTH_UNKNOWN = 0;//
	
	/** NOTE: 
	 * 1. FOR UTF-8, 3 byte=1 character.
	 * 2. max length of "unique key" in mysql is 1024 bytes. 
	 * ==> max 341 characters for column "path" if use UTF-8,
	 * */
	//length for  the specified fields ----YOU CAN USE THESE FOUR IN CODE
	public static final int DB_COLUMNLENGTH_RECORDID = DB_COLUMNLENGTH_BIGINT; //record_id, bigint(20)
	public static final int DB_COLUMNLENGTH_RELATIVEPATH = DB_COLUMNLENGTH_UNKNOWN; //relative path(include filename),255
	public static final int DB_COLUMNLENGTH_COMMENT = DB_COLUMNLENGTH_UNKNOWN; //comment/history/blanks, 65535
	public static final int DB_COLUMNLENGTH_NORMAL = DB_COLUMNLENGTH_UNKNOWN;//20070503 modified. use text.
	public static final int DB_COLUMNLENGTH_UNIQUEKEY = DB_COLUMNLENGTH_TEXT_SHORT; //path(255)	
	

	/*********************** for db operation type  *************************************/
	//action type when duplicated keys detected
	public static final int DB_ACTION_DUPLICATE_CLEARTABLE = 0;
	public static final int DB_ACTION_DUPLICATE_SKIP = 1;
	public static final int DB_ACTION_DUPLICATE_UPDATE = 2;
	
	/*********************** for connection *************************************/
	//MySQL
	public static int DB_TYPE_MYSQL = 0;
	public static String DB_DEFAULT_DRIVER_MYSQL ="com.mysql.jdbc.Driver";
	public static String DB_CONN_ENCODING_UTF8 = "?useUnicode=true&CharacterEncoding=utf8";
	public static String DB_CONN_DEFAULT_SERVER_MYSQL = "localhost";
	
	//Oracle
	public static int DB_TYPE_ORACLE = 1;
	public static String DB_DRIVER_ORACLE ="oracle.jdbc.driver.OracleDriver";
	public static String DB_DEFAULT_PORT_ORACLE ="1521";	
	//MS SQL SERVER
	public static int DB_TYPE_SQLSERVER = 2;
	public static String DB_DRIVER_SQLSERVER ="com.microsoft.jdbc.sqlserver.SQLServerDriver";
	public static String DB_DEFAULT_PORT_SQLSERVER ="1433";
	
	
	
	/*********************** for config file (*.properties) *************************************/
	//config file name
	public static String PROPFILE_CONFIG_PATH = "conf/SystemPath.properties";
	public static String PROPFILE_CONFIG_DB = "conf/DBSetting.properties";
	public static String PROPFILE_MSG_UI = "lang/UIMessage.properties"; //for msg to show in UI
	public static String PROPFILE_LOG = "conf/log4j.properties";
	public static String PROJECT_DISTRIBUTE_JARFILE = "FitHAS.jar";
	
	
	/*********************** for keys in config file (SystemPath.properties) *************************************/
	//SystemPath config (basedir)
	public static String CONFIG_PATH_PROPFILE_KEY_BASEDIR = "data.path.basedir";

	/*********************** for keys in config file (DBSetting.properties) *************************************/
	//DB settings : MySQL
	public static String CONFIG_DB_PROPKEY_MYSQL_TYPE = "db.mysql.type";
	public static String CONFIG_DB_PROPKEY_MYSQL_DRIVER = "db.mysql.driver";
	public static String CONFIG_DB_PROPKEY_MYSQL_PORT = "db.mysql.port.default";
	public static String CONFIG_DB_PROPKEY_MYSQL_USERNAME = "db.mysql.username.default";
	public static String CONFIG_DB_PROPKEY_MYSQL_PASSWORD = "db.mysql.password.default";
	public static String CONFIG_DB_PROPKEY_MYSQL_SERVER = "db.mysql.server.default";
	public static String CONFIG_DB_PROPKEY_MYSQL_DATABASE = "db.mysql.database.default";
	
	public static String CONFIG_DB_PROPKEY_ORACLE_TYPE = "db.oracle.type";
	public static String CONFIG_DB_PROPKEY_ORACLE_DRIVER = "db.oracle.driver";
	public static String CONFIG_DB_PROPKEY_ORACLE_PORT = "db.oracle.port.default";
	public static String CONFIG_DB_PROPKEY_ORACLE_USERNAME = "db.oracle.username.default";
	public static String CONFIG_DB_PROPKEY_ORACLE_PASSWORD = "db.oracle.password.default";
	public static String CONFIG_DB_PROPKEY_ORACLE_SERVER = "db.oracle.server.default";
	public static String CONFIG_DB_PROPKEY_ORACLE_DATABASE = "db.common.database.default.name";
	
	public static String CONFIG_DB_PROPKEY_SQL_TYPE = "db.sqlserver.type";
	public static String CONFIG_DB_PROPKEY_SQL_DRIVER = "db.sqlserver.driver";
	public static String CONFIG_DB_PROPKEY_SQL_PORT = "db.sqlserver.port.default";
	public static String CONFIG_DB_PROPKEY_SQL_USERNAME = "db.sqlserver.username.default";
	public static String CONFIG_DB_PROPKEY_SQL_PASSWORD = "db.sqlserver.password.default";
	public static String CONFIG_DB_PROPKEY_SQL_SERVER = "db.sqlserver.server.default";
	public static String CONFIG_DB_PROPKEY_SQL_DATABASE = "db.common.database.default.name";
		
		
	/************************ comment in properties files *********************************/
	public static String CONFIG_PATH_PROPFILE_COMMENT = "Basedir for datafile, DO NOT end with '/' in windows.  e.g: data.path.basedir = E:/data  ";
	public static String CONFIG_DB_PROPFILE_COMMENT = "Default database setting. \n"
		+"#e.g: db.oracle.type=1 \n" 
		+"#\t db.oracle.driver=oracle.jdbc.driver.OracleDriver \n" 
		+"#\t db.oracle.server.default=localhost \n"
		+"#\t db.oracle.port.default=1521 \n"
		+"#\t db.sqlserver.type=2 \n" 
		+"#\t db.sqlserver.driver=com.microsoft.jdbc.sqlserver.SQLServerDriver \n"
		+"#\t db.sqlserver.server.default=localhost\n"
		+"#\t db.sqlserver.port.default=1433 \n";

	
	
	/*********************** for UI *************************************/
	public static String UI_FILE_SEPERATOR = ",";
	
	//for judging whether user selected single file/multiple files/ directory
	public static int UI_FILE_METHOD_DIR = 0;
	public static int UI_FILE_METHOD_SINGLEFILE = 1;
	public static int UI_FILE_METHOD_MULTIFILE = 2;
	public static int UI_FILE_METHOD_FILE = 3;	
	
	//for file choosing mode:union/interset
	public static int SAMPLE_UNION = 1;
	public static int SAMPLE_INTERSECT = 0;
	
	//db type select in UI, only show "MySQL"
	public static String UI_DB_TYPE_NAME_MYSQL = "MySQL";
	public static String UI_DB_TYPE_NAME_ORACLE = "Oracle";
	public static String UI_DB_TYPE_NAME_SQLSERVER = "SQL Server";
	
	/*********************** for OPERATION MESSAGE TO SHOW **************************/
	public static String MSG_IMPORT_SUCCESS_MSG = "success";
	public static String MSG_IMPORT_FAIL_MSG = "fail";
	public static String MSG_IMPORT_SUCCESS = "import success.";
	public static String MSG_UPDATE_SUCCESS = "update success.";
	
	public static String MSG_UI_TABLEVIEW_COLUMNCOMMENT_ID = "Primary key";
	public static String MSG_UI_TABLEVIEW_COLUMNCOMMENT_PATH = "unique key";
	public static String MSG_UI_TABLEVIEW_COLUMNCOMMENT_NORMAL = "";
	
	
	/********************** FOR FILENAME PATTERN FILTER *******************************/
	public static String[] REG_CHARS = {"",
										"\\d", "\\D", 
										"\\w", "\\W",
										"\\s", "\\S", 
										"[a-zA-Z]", "." };
	public static String[] REG_CHARS_COMMENT = {"customize literal text...", 
		"\\d <-> digit(0-9)", "\\D <-> non-digit", 
		"\\w <-> word character(letters,digits,etc.)", "\\W <-> non-word character", 
		"\\s <-> whitespace character(spaces,tabs,line breaks,etc.)", "\\S <-> non-whitespace character",
		"[a-zA-Z] <-> letter(a-zA-Z)", ". <-> any character"};


	/********************** FOR FILENAME EXTENSION PART PATTERN *******************************/
	public static String[] REG_FILENAME_EXTENSION = {"\\.FIT|\\.FITS|\\.FIT\\.GZ|\\.FITS\\.GZ",
								"\\.FIT|\\.FITS", 
								"\\.FIT\\.GZ|\\.FITS\\.GZ"};
	public static String[] REG_MATCH_PATTERNS={"CONTAINS","PREFIX","SUFFIX","NOT CONTAINS","EXACT MATCH"};
	public static String[] REG_FILENAME_EXTENSION_COMMENT = {"ALL FITS EXTENSION NAMES", ".FIT, .FITS", ".FIT.GZ, .FITS.GZ"};
	
	
	/********************** FOR DB BROWSE *******************************/
	public static int UI_DB_BROWSE_ROWSPERPAGE = 30;
	
}
